//change AdminPost to corresponding name
var mAdminPostList = [];
var mAdminPostTypeID = null;

var mXXXXPageNumber = 1;
var mXXXXLoading = false;
var mXXXXFullyLoaded = false;

function initPage() {
    mAdminPostTypeID = parseInt(getCache(CONST_CACHE_ADMIN_POST_TYPE_ID));

    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mXXXXLoading == false) {
                if (mXXXXFullyLoaded == false) {
                    bindAdminPostListApi();
                } else {
                    showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                }
            }
        }
    });
}

function bindPage() {
    bindData();
}

function bindData() {
    bindTitle();
    bindAdminPostListApi();
}

function bindTitle() {
    var title = getAdminPostTypeTitle();
    $('#title').html(title);
}

function getAdminPostTypeTitle() {
    switch(mAdminPostTypeID) {
        case 1:
            return '新手上路';
        case 2:
            return '意见问题';
        case 3:
            return '车商用品';
        default:
            return '信息列表';
    }
}

function bindAdminPostListApi() {
    mXXXXLoading = true;

    var data = {
        id: mAdminPostTypeID
    };
    data.page = mXXXXPageNumber++;
    jAjaxGet('/adminPost/list', data, function (json) {
        console.log(data.page, json.list.length)
        mAdminPostList = mAdminPostList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mXXXXFullyLoaded = true;
        }

        bindAdminPostList();
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    })
}

function bindAdminPostList() {
    var html = getAdminPostListHtml();
    $('#adminPostList').html(html);
}

function getAdminPostListHtml() {
    if (mAdminPostList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(mAdminPostList).each(function (index, item) {
        html += getAdminPostHtml(index, item);
    });
    return html;
}

function getAdminPostHtml(index, item) {
    var html = '<div class="row middle-y border-bottom p-3" onclick="chooseAdminPost(' + index + ');">';
    html += '<div class="col">' + item.title + '</div>';
    html += '<div>' + item.updated_at + '</div>';
    html += '</div>';
    return html;
}

function chooseAdminPost(index) {
    var adminPostID = mAdminPostList[index].id;
    openWinWithCache("admin_post_details", CONST_CACHE_ADMIN_POST_ID, adminPostID);
}
