var mTimeRangeList = null;
var mLastPlaceIndex = null;
var mUser = null;
var mLevel = null;
var mCurrentLevelTimeRangeList = null;
var mWechatRegistered = false;
var mModalID = null;
var mBonusObject = BonusClass.createNew('#bonusControlID');
var mHasWalletPay = false;
var mBalance = null;

function initPage() {
	mUser = getUser();
	mBonusObject.init();
	initRollDateControls();
}

function initRollDateControls() {
	var startYear = 1990;
	var endYear = new Date().getFullYear() + 10;
	new Rolldate({
		el: '#date',
		format: 'YYYY-MM-DD',
		beginYear: startYear,
		endYear: endYear,
		init: function() {
			document.activeElement.blur();
		},
		confirm: function(date) {
			refreshTime();
		}
	})

	var today = getDateText(new Date());
	$('#date').val(today);
}

function bindPage() {
	bindData();
}

function bindData() {
	bindTimeRangeListApi();
	bindBalanceInfo();
}

function bindBalanceInfo() {
	var data = getUserIdObject();
	jAjaxGet('/user/profile', data, function (json) {
		mBalance = json.account_money;
		$('#wallet').html('余额支付 (' + mBalance + '元)');
	});
}

function bindTimeRangeListApi() {
	var data = getUserIdObject();
	data.date = $('#date').val();
	jAjaxGet('/product/bannerVip', data, function (json) {
		mTimeRangeList = json.list;
		console.dir(mTimeRangeList);
		choosePlace(2);
	})
}

function bindTimeRangeList() {
	var html = getTimeRangeListHtml();
	$('#timeRangeList').html(html);
}

function getTimeRangeListHtml() {
	if (mCurrentLevelTimeRangeList.length % 2 == 1) {
		mCurrentLevelTimeRangeList.push(null);
	}
	var html = '';
	for(var i = 0; i < mCurrentLevelTimeRangeList.length; i += 2) {
		var leftTimeRange = mCurrentLevelTimeRangeList[i];
		var rightTimeRange = mCurrentLevelTimeRangeList[i + 1];
		leftTimeRange.selected = false;
		rightTimeRange.selected = false;
		html += getTimeRangeRowHtml(i, leftTimeRange, rightTimeRange);
	}
	return html;
}

function getTimeRangeRowHtml(index, leftTimeRange, rightTimeRange) {
	var html = '<div class="row">';
	html += getTimeRangeHtml(index, leftTimeRange);
	html += getTimeRangeHtml(index + 1, rightTimeRange);
	html += '</div>';

	return html;
}

function getTimeRangeHtml(index, item) {
	if (item == null) {
		return getEmptyTimeRangeHtml();
	}

	var innerHtml = '<i class="far fa-clock"></i> ';
	innerHtml += item.name + ' ';
	innerHtml += '¥ ' + item.price;

	var html = '<div id="timeRange' + index + '" class="col unSelected py-2 m-1 small rounded" onclick="chooseTimeRange(' + index + ');">';
	if (item.can_buy == false) {
		html = '<div id="timeRange' + index + '" class="col forbidden py-2 m-1 small rounded">';
	}
	html += innerHtml;
	html += '</div>';

	return html;
}

function getEmptyTimeRangeHtml() {
	return  '<div class="col">&nbsp;</div>';
}

function chooseTimeRange(index) {
	var timeRange = mCurrentLevelTimeRangeList[index];
	if (timeRange.can_buy != false) {
		mBonusObject.init();
		timeRange.selected = !timeRange.selected;
		if (timeRange.selected) {
			$('#timeRange' + index).addClass('selected').removeClass('unSelected');
		} else {
			$('#timeRange' + index).removeClass('selected').addClass('unSelected');
		}

		bindPrice();
	}
}

function getTotalPrice() {
	var totalPrice = 0;
	$(mCurrentLevelTimeRangeList).each(function (index, item) {
		if (item.selected) {
			totalPrice += parseFloat(item.price);
		}
	})
	totalPrice = totalPrice.toFixed(2);
	return totalPrice;
}

function bindPrice() {
	var totalPrice = getTotalPrice();
	$('#price').html(CONST_CHAR_YUAN + ' ' + totalPrice);
	if (totalPrice == 0) {
		$('#submitButton').html('支付');
	} else {
		$('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + totalPrice);
	}

}

function choosePlace(index) {
	if (mLastPlaceIndex == index) {
		return;
	}
	mBonusObject.init();
	if (mLastPlaceIndex != null) {
		$('#place' + mLastPlaceIndex).removeClass('selected').addClass('unSelected');
	}
	mLastPlaceIndex = index;
	$('#place' + mLastPlaceIndex).addClass('selected').removeClass('unSelected');

	$(mTimeRangeList).each(function (index0, item) {
		item.selected = false;
	})
	bindPrice();

	mLevel = getLevel();
	setCurrentLevelTimeRangeList();
	bindTimeRangeList();
}

function getLevel() {
	switch(mLastPlaceIndex) {
		case 0:
			return 3;
		case 1:
			return 2;
		case 2:
			return 1;
		default:
			return 0;
	}
}

function setCurrentLevelTimeRangeList() {
	mCurrentLevelTimeRangeList = [];
	$(mTimeRangeList).each(function (index, item) {
		if (item.extra.level == mLevel) {
			mCurrentLevelTimeRangeList.push(item);
		}
	})
}

function buy() {
	var totalPrice = getTotalPrice();
	if ((mHasWalletPay == false) || totalPrice > mBalance) {
		if (mWechatRegistered == false) {
			var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0', 'https://noahsoft.site/app/');
			if (info != 0) {
				showToast('微信授权失败');
				return;
			}
			mWechatRegistered = true;
		}

		var supportPay = uexWeiXin.isSupportPay();
		if (supportPay == false) {
			showToast('微信支付不支持');
			return;
		}
	}

	var use_account_money = mHasWalletPay ? 1 : 0;
	var ids = getSelectedIds();
	var data = {
		id: ids,
		date: $('#date').val(),
		use_account_money: use_account_money
	};
	var coupon_ids = mBonusObject.getBonusIds();
	if (coupon_ids.length > 0) {
		data.coupon_ids = coupon_ids;
	}
	appendUserId(data);
	jAjaxPostJsonContentType('/product/bannerVip/buy', data, function (json) {
		payOrder(json, '您已成功购买', function () {
			if (isApp()) {
				appcan.window.evaluateScript('home', 'bindHomePageDataApi();');
			}
		});
	});
}

function getSelectedIds() {
	var ids = [];
	$(mCurrentLevelTimeRangeList).each(function (index, item) {
		if (item.selected) {
			ids.push(item.id);
		}
	})
	return ids;
}

function chooseBonus() {
	var totalPrice = getTotalPrice();
	if (totalPrice == 0) {
		showToast('请选择霸屏时间');
		return;
	}
	mBonusObject.goPage('bapin_buy', totalPrice);
}

function bindBonus() {
	mBonusObject.populate();
	mBonusObject.bindData();

	var totalPrice = getTotalPrice();
	var newPrice = mBonusObject.getPriceOffBonus(totalPrice);
	$('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + newPrice);
}

function chooseWallet() {
	if (mBalance != null && mBalance > 0) {
		mHasWalletPay = !mHasWalletPay;
		bindWalletPayStatus();
	}
}

function bindWalletPayStatus() {
	var html = getCheckStatusHtml(mHasWalletPay);
	$('#ckbWallet').html(html);
}

function refreshTime() {
	var data = getUserIdObject();
	data.date = $('#date').val();
	jAjaxGet('/product/bannerVip', data, function (json) {
		mTimeRangeList = json.list;
		setCurrentLevelTimeRangeList();
		bindTimeRangeList();
		bindPrice();
	})
}
