var mCarId = null;
var mCar = null;
var mReasonList = ['价格低于真实车价','图片和车款不符','新车冒充二手车','车辆不存在或已售','电话无法接通','商家冒充个人','商家服务态度不好','内容含联系方式','走私套牌抵押车','看车前骗取定金','隐瞒车况、事故车'];
var mLastReasonIndex = null;
var mWechatRegistered = false;
var mQQ_Registered = false;
var mQQ_Installed = null;
var mLocationObject = null;
var mModalID = null;

function initPage() {
    mCarId = getCache(CONST_CACHE_CAR_ID);

    if (isAndroid()) {
        var params = {
            windowName:"carDetails"
        };
        uexWeiXin.setCallbackWindowName(JSON.stringify(params));
    }
}

function bindPage() {
	bindData();
}

function bindData() {
    bindCarApi();
    bindReasonList();
}

function bindCarApi() {
    var data = {
        id: mCarId
    };
    var user = getUser();
    if (user != null) {
        appendUserId(data);
    }

    jAjaxGet('/shopItem/detail', data, function (json) {
        mCar = json;
        bindCar();
        bindRecommandCarList();
    });
}

function bindCar() {
    bindBanners(mCar.imgs)
    $('#carName').html(mCar.vehicle_brand + ' ' + mCar.vehicle_name);
    $('#price').html(getPriceText(mCar.price));
    $('#firstLicenseDate').html(getYearMonthText(mCar.first_license_date) + '上牌');
    $('#transferInfo').html(mCar.transfer_times + '次过户');
    $('#inspectionDate').html(getYearMonthText(mCar.inspection_date));
    $('#insuranceExpiresDate').html(getYearMonthText(mCar.insurance_end_date));
    $('#color').html(mCar.vehicle_color);
    if (mCar.violation_status) {
        $('#violation').html(mCar.violation_times + '次');
    } else {
        $('#violation').html('无');
    }
    $('#emission').html(mCar.emission_type_fmt);
    $('#gearBox').html(mCar.gearbox);
    if (isPhoneNumber(mCar.shop.phone)) {
        $('#phone').attr('href', 'tel:' + mCar.shop.phone);
    }

    var user = getUser();
    if (user == null) {
        $('#phone').html('电话: 未登录');
    } else {
        $('#phone').html('电话: ' + mCar.shop.phone);
    }
    $('#remark').html('补充说明：车源编号<span class="mr-2">' + mCar.id + '</span>' +  mCar.remark);
    $('#shareLink').removeClass('d-none');
    bindFollowInfo();
    if (mCar.share_text) {
        showToast(mCar.share_text);
    }
    var rankLevel = getRankLevel(mCar.vip_level);
    if (rankLevel != null) {
        $('#rankLevel').html(rankLevel);
    }
}

function bindRecommandCarList() {
    if (mCar.recommend_list && mCar.recommend_list.length > 0) {
        var html = getCarListHtml();
        $('#recommandCarList').html(html);
    }
}

function getCarListHtml() {
    var html = '';
    $(mCar.recommend_list).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="chooseCar(' + item.id + ');">';

    html += '<div class="ml-2 thumb divBackground rounded" style="background-image: url(' + item.imgs[0] + ')"></div>';
    html += '<div class="col ellipsis" style="display:flex;flex-direction:column;justify-content:space-between;height:5rem;">' + getCarDetailsHtml(item) + '</div>';

    html += '</div>';
    return html;
}

function chooseCar(carId) {
    setCache(CONST_CACHE_CAR_ID, carId);
    openWin("carDetails", 'carDetails' + carId);
}

function getCarDetailsHtml(item) {
    var html = '<div class="carName ellipsis">' + item.vehicle_name + '</div>';
    html += '<div class="carPrice">价格: ¥' + getPriceText(item.price) + '</div>';
    html += '<div class="carDate">上牌时间：' + item.first_license_date + '</div>';
    return html;
}

function bindBanners(banners) {
    if (banners.length == 1) {
        var html = getBannerImageHtml(banners[0]);
        $('#banners').html(html);
    } else if (banners.length > 1) {
        bindBannerSwipe(banners, '#bannerImageList', '#bannersFooter');
        enableBanner('banner_box');
    }
}

function getBannerImageHtml(banner) {
    var html = '';
    html += '<div class="swiper-slide" onclick="showImage(0);">';
    html += '<img src="' + banner + '" alt="" style="width:100%; height:12rem;"';
    html += '>';
    html += '</div>';
    return html;
}

function getYearMonthText(date) {
    var yearMonth = date.split('-');
    year = yearMonth[0];
    month = parseInt(yearMonth[1]);
    return year + '年' + month + '月';
}

function bindBannerSwipe(bannerList, imageListId, footerId) {
    var html = '';
    var bannerFooterHtml = '';

    $(bannerList).each(function (index, item) {
        html += getBannerCode(index, item);
        bannerFooterHtml += getBannerFooterCode(index);
    });
    $(imageListId).html(html);
    $(footerId).html(bannerFooterHtml);
}

function getBannerCode(index, item) {
    var html = '';
    html += '<div class="swiper-slide divBackground" onclick="showImage(' + index + ')" style="height:10rem;background-image: url(' + item + ');">';
    html += '</div>';
    return html;
}

function getBannerFooterCode(index) {
    var itemClass = (index == 0) ? "on" : "";
    return '<li class="' + itemClass + '"></li> ';
}

function enableBanner() {
    new Swipe(document.getElementById('banner_box'), {
        speed: 500,
        auto: 3000,
        callback: function () {
            var lis = $(this.element).next("ol").children();
            lis.removeClass("on").eq(this.index).addClass("on");
        }
    });
}

function bindFollowInfo() {
    if (mCar.is_follow) {
        $('#followIcon').removeClass('far d-none').addClass('fas');
    } else {
        $('#followIcon').removeClass('fas d-none').addClass('far');
    }
}

function toggleFollow() {
    if (mCar.is_follow) {
        unFollowCar();
    } else {
        followCar();
    }
}

function unFollowCar() {
    var data = {
        id: mCarId
    };
    appendUserId(data);
    jAjaxPost('/shopItem/unFollow', data, function (json) {
        jLog(json, 'unFollow')
        mCar.is_follow = 0;
        bindFollowInfo();
    });
}

function followCar() {
    var data = {
        id: mCarId
    };
    appendUserId(data);
    jLog(data)
    jAjaxPost('/shopItem/follow', data, function (json) {
        jLog(json, 'follow')
        mCar.is_follow = 1;
        bindFollowInfo();
    });
}

function enterStore() {
    if (mCar) {
        openWinWithCache('company', CONST_CACHE_COMPANY_ID, mCar.shop.id);
    }
}

function follow() {
    var data = {
        id: mCarId
    };
    appendUserId(data);
    console.dir(data)
    jAjaxPost('/shopItem/follow', data, function (json) {
        console.dir(json)
    });
}

function showGuaranteeText() {
    var text = getCache(CONST_CACHE_GUARANTEE_NOTICE);
    var tel = getCache(CONST_CACHE_PLATFORM_400_TELEPHONE);
    if (text && tel) {
        text += ' 担保电话：' + '<a style="text-decoration: none;" href="tel:' + tel + '">' + tel + '</a>';
        $('#guaranteeText').html(text);
        openModal('#guaranteePage');
    } else {
        jAjaxGet('/public/config', null, function (json) {
            console.dir(json)
            if (json.guarantee_text) {
                setCache(CONST_CACHE_GUARANTEE_NOTICE, $.trim(json.guarantee_text));
                setCache(CONST_CACHE_PLATFORM_400_TELEPHONE, json.contact_phone);
                showGuaranteeText();
            }
        });
    }
}

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
}

function bindReasonList() {
    var html = getReasonListHtml();
    $('#reasonList').html(html);
}

function getReasonListHtml() {
    var html = '';
    $(mReasonList).each(function (index, item) {
        html += getReasonHtml(index, item);
    });
    return html;
}

function getReasonHtml(index, item) {
    var html = '<div id="reason' + index + '" class="small middle-y border-bottom px-2 py-2" onclick="chooseReason(' + index + ');">';
    html += item;
    html += '</div>';
    return html;
}

function chooseReason(index) {
    var reason = mReasonList[index];
    if (mLastReasonIndex != null) {
        $('#reason' + mLastReasonIndex).removeClass('bg-primary');
    }
    mLastReasonIndex = index;
    $('#reason' + mLastReasonIndex).addClass('bg-primary');
}

function submitCompliant() {
    if (mLastReasonIndex == null) {
        showToast('请选择举报原因');
        return;
    }

    var reason = mReasonList[mLastReasonIndex];
    var data = {
        id: mCarId,
        note: reason
    };
    appendUserId(data);
    jAjaxPost('/shopItem/report', data, function (json) {
        showToast('您已投诉成功');
        hidePage('#compaliantPage');
    });
}

function showCompliantPage() {
    $('#compaliantPage').show();
}

function closeModal() {
    $('#compaliantPage').hide();
    hideLayer();
}

function shareToWechat(isGroup) {
    closeLayer();
    if (mWechatRegistered == false) {
        var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0');
        if (info != 0) {
            showToast('微信授权失败');
            return;
        }
        mWechatRegistered = true;
    }
    var url = '/car.html?carId=' + mCarId;
    var user = getUser();
    if (user != null) {
        url += '&user=' + user.uuid;
    }
    var title = '琦亿车 ' + mCar.vehicle_brand + ' ' + mCar.vehicle_name + ' 售价' + getPriceText(mCar.price);
    shareUrl(isGroup, url, title, '来自琦亿车的分享', shareSuccess);
}

function shareSuccess() {
    jLog('success')
    var user = getUser();
    jLog(user)
    if (user != null) {
        var data = {
            id: mCarId
        };
        jLog(data)
        appendUserId(data);
        jLog(data)
        jAjaxPost('/shopItem/shareCallback', data, function (json) {
            jLog(json, 'shareCallback')
            jLog('share success')
        })
    }
}

function shareToQQ() {
    closeLayer();

    if (isH5()) {
        showToast('H5不支持当前功能');
        return;
    }

    if (mQQ_Installed == null) {
        mQQ_Installed = uexQQ.isQQInstalled();
    }

    if (mQQ_Installed == false) {
        showToast('QQ未安装');
        return;
    }

    if (mQQ_Registered == false) {
        uexQQ.login(CONFIG_QQ_APP_ID, function (error, data) {
            if (error == 0) {
                mQQ_Registered = true;
                qqShareToFriend();
            } else {
                showToast('QQ登录失败');
            }
        });
    } else {
        qqShareToFriend();
    }
}

function qqShareToFriend() {
    var title = '琦亿车 ' + mCar.vehicle_brand + ' ' + mCar.vehicle_name + ' 售价' + getPriceText(mCar.price);
    var url = '/car.html?carId=' + mCarId;
    if (user != null) {
        url += '&user=' + user.uuid;
    }
    qqShareUrl(title, url, shareSuccess);
}

function showSharePage() {
    $('#sharePage').show();
    $('.layer').css('display', 'block');
}

function closeLayer() {
    $('.layer').css('display', 'none');
    $('#sharePage').hide();
    $('#navigationPage').hide();
    $('#guaranteePage').hide();
}

function navigate() {
    $('#navigationPage').show();
    $('.layer').css('display', 'block');
}

function navigateByGaode() {
    if (isIos()) {
        navigateByIosGaode();
    } else if (isAndroid()) {
        navigateByAndroidGaode();
    }
    closeLayer();
}

function navigateByIosGaode() {
    var location = mCar.location;
    var lat = location.location.lat;
    var lng = location.location.lng;

    var appInfo = 'iosamap://navi?sourceApplication=pipiche&backScheme=iosamap&poiname=&lat=' + lat + '&lon=' + lng + '&dev=1&style=2';
    uexWidget.loadApp(appInfo,null,null);
}

function navigateByAndroidGaode() {
    var poiname = mCar.location.formattedAddress;
    var lat = mCar.location.location.lat;
    var lng = mCar.location.location.lng;
    var main = "android.intent.action.VIEW";
    var pkg = "com.autonavi.minimap";
    var add = '{"data":{"scheme":"androidamap://navi?sourceApplication=琦亿车&poiname=' + poiname + '&lat=' + lat + '&lon=' + lng + '&style=2&dev=0&package=com.autonavi.minimap"}}';
    uexWidget.startApp(1, main, add);
}

function navigateByBaidu() {
    if (isIos()) {
        navigateByIosBaidu();
    } else if (isAndroid()) {
        navigateByAndroidBaidu();
    }
    closeLayer();
}

function navigateByIosBaidu() {
    if (mCar == null) {
        showToast('数据加载中');
        return;
    }

    if (mLocationObject == null) {
        mLocationObject = LocationClass.createNew();
    }

    mLocationObject.bindCurrentLocation(function (currentLocation) {
        var params = {
            latitude:currentLocation.location.lat,
            longitude:currentLocation.location.lng,
            from:"gcj02",
            to:"bd09"
        };
        var data = uexLocation.convertLocation(JSON.stringify(params));
        var baiduLocation = JSON.parse(data);

        var appInfo = 'baidumap://map/direction';
        var verticleLineEncode = encodeURIComponent('|');
        appInfo += '?origin=latlng:' + baiduLocation.latitude + ',' + baiduLocation.longitude + verticleLineEncode + 'name:' + encodeURIComponent(currentLocation.formattedAddress);

        var poiname = mCar.location.formattedAddress;

        params = {
            latitude: mCar.location.location.lat,
            longitude: mCar.location.location.lng,
            from:"gcj02",
            to:"bd09"
        };
        data = uexLocation.convertLocation(JSON.stringify(params));
        baiduLocation = JSON.parse(data);

        appInfo += '&destination=latlng:' + baiduLocation.latitude + ',' + baiduLocation.longitude +  verticleLineEncode + 'name:' + encodeURIComponent(poiname);
        appInfo += '&mode=driving';

        uexWidget.loadApp(appInfo,null,null);
    })
}

function navigateByAndroidBaidu() {
    var poiname = mCar.location.formattedAddress;
    var lat = mCar.location.location.lat;
    var lng = mCar.location.location.lng;

    var main = "android.intent.action.VIEW";
    var add = '{"data":{"scheme":"bdapp://map/direction?destination=latlng:' + lat + ',' + lng + '|name:' + poiname + '&src=Infosys|PiPiChe#Intent;scheme=bdapp;package=com.baidu.BaiduMap;end"}}';
    uexWidget.startApp(1, main, add);
}

function goCompanyPage() {
    if (mCar && mCar.shop) {
        openWinWithCache('company', CONST_CACHE_COMPANY_ID, mCar.shop.id);
    }
}

function showImage(index) {
    var data ={
        displayActionButton:false,
        displayNavArrows:true,
        enableGrid:true,
        startIndex:index,
        data: mCar.imgs
    }
    var json=JSON.stringify(data);
    uexImage.openBrowser(json);
}