var mTimeRangeList = null;
var mLastTimeRangeIndex = null;
var mLastPlaceIndex = null;
var mUser = null;
var mLevel = null;
var mCurrentLevelTimeRangeList = null;
var mWechatRegistered = false;
var mCarID = null;
var mBonusObject = BonusClass.createNew('#bonusControlID');
var mHasWalletPay = false;
var mBalance = null;

function initPage() {
	mUser = getUser();
	mCarID = getCache(CONST_CACHE_CAR_ID);
	mBonusObject.init();
}

function bindPage() {
	bindData();
	bindBalanceInfo();
}

function bindData() {
	bindTimeRangeListApi();
}

function bindTimeRangeListApi() {
	var data = getUserIdObject();
	jAjaxGet('/product/shopItemVip', data, function (json) {
		mTimeRangeList = json.list;
		choosePlace(2);
	})
}

function bindTimeRangeList() {
	var html = getTimeRangeListHtml();
	$('#timeRangeList').html(html);
}

function getTimeRangeListHtml() {
	if (mCurrentLevelTimeRangeList.length % 2 == 1) {
		mCurrentLevelTimeRangeList.push(null);
	}
	var html = '';
	for(var i = 0; i < mCurrentLevelTimeRangeList.length; i += 2) {
		var leftTimeRange = mCurrentLevelTimeRangeList[i];
		var rightTimeRange = mCurrentLevelTimeRangeList[i + 1];
		html += getTimeRangeRowHtml(i, leftTimeRange, rightTimeRange);
	}
	return html;
}

function getTimeRangeRowHtml(index, leftTimeRange, rightTimeRange) {
	var html = '<div class="row">';
	html += getTimeRangeHtml(index, leftTimeRange);
	html += getTimeRangeHtml(index + 1, rightTimeRange);
	html += '</div>';

	return html;
}

function getTimeRangeHtml(index, item) {
	if (item == null) {
		return getEmptyTimeRangeHtml();
	}

	var innerHtml = '<i class="far fa-clock"></i> ';
	innerHtml += item.name + ' ';
	innerHtml += '¥ ' + item.price;

	var html = '<div id="timeRange' + index + '" class="col unSelected py-2 m-1 small rounded" onclick="chooseTimeRange(' + index + ');">';
	html += innerHtml;
	html += '</div>';

	return html;
}

function getEmptyTimeRangeHtml() {
	return  '<div class="col">&nbsp;</div>';
}

function chooseTimeRange(index) {
	if (mLastTimeRangeIndex == index) {
		return;
	}
	mBonusObject.init();
	$('#timeRange' + mLastTimeRangeIndex).removeClass('selected').addClass('unSelected');
	mLastTimeRangeIndex = index;
	$('#timeRange' + mLastTimeRangeIndex).addClass('selected').removeClass('unSelected');

	var timeRange = mCurrentLevelTimeRangeList[index];
	$('#price').html(CONST_CHAR_YUAN + ' ' + timeRange.price);

	$('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + timeRange.price);
}

function choosePlace(index) {
	if (mLastPlaceIndex == index) {
		return;
	}
	mBonusObject.init();
	if (mLastPlaceIndex != null) {
		$('#place' + mLastPlaceIndex).removeClass('selected').addClass('unSelected');
	}
	mLastPlaceIndex = index;
	$('#place' + mLastPlaceIndex).addClass('selected').removeClass('unSelected');

	mLevel = getLevel();
	setCurrentLevelTimeRangeList();
	bindTimeRangeList();
	mLastTimeRangeIndex = null;
	$('#submitButton').html('支付');
}

function getLevel() {
	switch(mLastPlaceIndex) {
		case 0:
			return 3;
		case 1:
			return 2;
		case 2:
			return 1;
		default:
			return 0;
	}
}

function setCurrentLevelTimeRangeList() {
	mCurrentLevelTimeRangeList = [];
	$(mTimeRangeList).each(function (index, item) {
		if (item.extra.level == mLevel) {
			mCurrentLevelTimeRangeList.push(item);
		}
	})
}

function bindBalanceInfo() {
	var data = getUserIdObject();
	jAjaxGet('/user/profile', data, function (json) {
		mBalance = json.account_money;
		$('#wallet').html('余额支付 (' + mBalance + '元)');
	});
}

function buy() {
	if (mLastTimeRangeIndex == null) {
		showToast('请选择价格');
		return;
	}

	var timeRange = mCurrentLevelTimeRangeList[mLastTimeRangeIndex];
	if ((mHasWalletPay == false) || timeRange.price > mBalance) {
		if (mWechatRegistered == false) {
			var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0', 'https://noahsoft.site/app/');
			if (info != 0) {
				showToast('微信授权失败');
				return;
			}
			mWechatRegistered = true;
		}

		var supportPay = uexWeiXin.isSupportPay();
		if (supportPay == false) {
			showToast('微信支付不支持');
			return;
		}
	}

	var use_account_money = mHasWalletPay ? 1 : 0;
	var data = {
		id: mCurrentLevelTimeRangeList[mLastTimeRangeIndex].id,
		shop_item_id: mCarID,
		use_account_money: use_account_money
	};
	var coupon_ids = mBonusObject.getBonusIds();
	if (coupon_ids.length > 0) {
		data.coupon_ids = coupon_ids;
	}

	appendUserId(data);
	jAjaxPostJsonContentType('/product/shopItemVip/buy', data, function (json) {
		payOrder(json, '您已成功购买');
	});
}

function chooseBonus() {
	if (mLastTimeRangeIndex == null) {
		showToast('请选择置顶时间');
		return;
	}
	mBonusObject.goPage('car_rank_buy', mCurrentLevelTimeRangeList[mLastTimeRangeIndex].price);
}

function bindBonus() {
	mBonusObject.populate();
	mBonusObject.bindData();

	var product = mCurrentLevelTimeRangeList[mLastTimeRangeIndex];
	var newPrice = mBonusObject.getPriceOffBonus(product.price);
	$('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + newPrice);
}

function chooseWallet() {
	if (mBalance != null && mBalance > 0) {
		mHasWalletPay = !mHasWalletPay;
		bindWalletPayStatus();
	}
}

function bindWalletPayStatus() {
	var html = getCheckStatusHtml(mHasWalletPay);
	$('#ckbWallet').html(html);
}
