var mLocationObject = LocationClass.createNew();
var mMarkerID = null;
var mBaiduLongtiude = null;
var mBaiduLatitude = null;
var mGaodePoiList = null;

function initPage() {
}

function bindPage() {
	bindData();
}

function bindData() {
	showMap();
}

function showMap() {
	mLocationObject.bindCurrentLocation(function (json) {
		var longitude = 116.309;
		var latitude = 39.977;
		if (json != null) {
			longitude = json.location.lng;
			latitude = json.location.lat;
		}

		var params = {
			latitude:latitude,
			longitude:longitude,
			from:"gcj02",
			to:"bd09"
		};
		var data = uexLocation.convertLocation(JSON.stringify(params));
		var baiduLocation = JSON.parse(data);
		mBaiduLongtiude = baiduLocation.longitude;
		mBaiduLatitude = baiduLocation.latitude;

		var pos = $('#map').position();
		var width = $('#map').width();
		var height = $('#map').height() - 300;
		$('#mapSearch').css('top', pos.top);
		try {
			var poiListHeight = 300 - $('#searchBar').height();
			$('#poiList').height(poiListHeight);
		} catch(ex) {
			alert(JSON.stringify(ex))
		}

		uexBaiduMap.open(0, pos.top+300,width,height,mBaiduLongtiude,mBaiduLatitude, function(){
			uexBaiduMap.setZoomLevel(20);

			mMarkerID = 1;
			addMarker();
			uexBaiduMap.onMapClickListener = function (locationString) {
				var location = string2json(locationString);
				mBaiduLongtiude = location.longitude;
				mBaiduLatitude = location.latitude;

				removeMarker();
				mMarkerID ++;
				addMarker();
				//bindNearbyLocations(longitude, latitude);
			}
		});
	})
}

function removeMarker() {
	var markerID = getMarketId();
	var ids='["' + markerID + '"]';
	uexBaiduMap.removeMakersOverlay(ids);
}

function addMarker() {
	var markerID = getMarketId();
	var data =  [
		{
			id:markerID,
			longitude:mBaiduLongtiude,
			latitude:mBaiduLatitude,
			icon:"http://noahsoft.site/locate.png"
		}];
	uexBaiduMap.addMarkersOverlay(JSON.stringify(data));
}

function getMarketId() {
	return 'marker' + mMarkerID;
}

function bindNearbyLocations(longitude, latitude) {
	var json={
		longitude:longitude,
		latitude: latitude,
		radius:1000,
		searchKey:'',
		pageNum:0
	};
	//it causes app crashed, if the searchKey is not empty
	uexBaiduMap.poiNearbySearch(JSON.stringify(json), function(error,data) {
		jLog(data)
		jLog(error, 'error')
	});
}

function submitLocation() {
	if (mBaiduLongtiude == null) {
		showToast('定位中...');
		return;
	}

	$('#title').val('0')
	var params = {
		latitude:mBaiduLatitude,
		longitude:mBaiduLongtiude,
		from:'bd09',
		to:"gcj02"
	};
	var data = uexLocation.convertLocation(JSON.stringify(params));
	var location = JSON.parse(data);
	mLocationObject.getGaodeLocationByLngLat(location.longitude, location.latitude, function (json) {
		if (json == null) {
			showToast('无法获取位置');
		} else {
			if (!json.addressComponent.city) {
				json.addressComponent.city = json.addressComponent.province;
			}
			setObjectCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_OBJECT, json);
			var winName = getCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_WIN_NAME);

			appcan.window.evaluateScript(winName, 'chooseGaodeAddress();');
			setTimeout(goBack, 500);
		}
	});
}

function searchAddress() {
	AMap.service(["AMap.PlaceSearch"], function () {
		var addressName = $.trim($('#addressName').val());
		var placeSearch = new AMap.PlaceSearch({
			pageSize: 10, // 单页显示结果条数
			pageIndex: 1, // 页码
			citylimit: false,  //是否强制限制在设置的城市内搜索
		});

		placeSearch.search(addressName, function (status, json) {
			if (status == 'complete') {
				mGaodePoiList = json.poiList.pois;
				bindPoiList();
			}
		})
	});
}

function bindPoiList() {
	var html = getPoiListHtml();
	$('#poiList').html(html);
}

function getPoiListHtml() {
	if (mGaodePoiList.length == 0) {
		return getEmptyDataCode();
	}
	var html = '';
	$(mGaodePoiList).each(function (index, item) {
		html += getPoiHtml(index, item);
	});
	return html;
}

function getPoiHtml(index, item) {
	var html = '<div class="border-bottom p-2" onclick="choosePoi(' + index + ');">';
	html += '<div>' + item.name + '</div>';
	html += '<div class="t-gra small">' + item.address + '</div>';
	html += '</div>';
	return html;
}

function choosePoi(index) {
	var poi = mGaodePoiList[index];
	var params = {
		latitude:poi.location.lat,
		longitude:poi.location.lng,
		from:'gcj02',
		to:"bd09"
	};
	var data = uexLocation.convertLocation(JSON.stringify(params));
	var location = JSON.parse(data);
	mBaiduLatitude = location.latitude;
	mBaiduLongtiude = location.longitude;
	removeMarker();
	mMarkerID ++;
	addMarker();

	$('#addressName').val('');
	$('#poiList').html('');

	uexBaiduMap.setCenter(mBaiduLongtiude,mBaiduLatitude);
}