//change Bonus to corresponding name
var mBonusList = null;
var mOrderAmount = null;

function initPage() {
    mOrderAmount = getCache(CONST_CACHE_ORDER_AMOUNT);
}

function bindPage() {
    bindData();
}

function bindData() {
    bindBonusListApi();
}

function bindBonusListApi() {
    var data = {
        status: 1
    };
    appendUserId(data);
    jAjaxGet('/user/coupons', data, function (json) {
        mBonusList = [];
        $(json.list).each(function (index, item) {
           if (item.min_amount <= mOrderAmount) {
               mBonusList.push(item);
           }
        });
        $('#bonusCountText').html('当前可用红包' + mBonusList.length + '个');
        bindBonusList();
    })
}

function bindBonusList() {
    var html = getBonusListHtml();
    $('#bonusList').html(html);
}

function getBonusListHtml() {
    if (mBonusList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(mBonusList).each(function (index, item) {
        html += getBonusHtml(index, item);
    });
    return html;
}

function getBonusHtml(index, item) {
    var html = '<div class="row middle-y border-bottom p-2" onclick="swapItem(' + index + ');">';
    html += getBonusHeadHtml(item);
    html += getBonusBodyHtml(item);
    html += getBonusChooseHtml(index);
    html += '</div>';
    return html;
}

function getBonusHeadHtml(item) {
    return '<div><img src="img/bonus.png" class="bonus" /><span class="small">¥</span> <span class="font-weight-bold">' + item.coupon_amount + '</span></div>';
}

function getBonusBodyHtml(item) {
    var html = '<div class="col border-left ml-2">';

    html += '<div class="letterSpacing1">满' + item.min_amount + '元减' + item.coupon_amount + '元</div>';
    html += '<div class="small t-gra">' + item.valid_time + '</div>';

    html += '</div>';
    return html;
}

function getBonusChooseHtml(index) {
    return '<div><i id="item' + index + '" class="far fa-lg text-secondary fa-circle"></i></div>';
}

function swapItem(index) {
    var item = mBonusList[index];
    if (item.selected) {
        item.selected = false;

    } else {
        item.selected = true;
    }
    refreshItemStatus(index);
}

function refreshItemStatus(index) {
    var item = mBonusList[index];
    var jqid = '#item' + index;
    if (item.selected) {
        $(jqid).removeClass('far fa-circle text-secondary').addClass('fas fa-check-circle text-danger');
    } else {
        $(jqid).removeClass('fas fa-check-circle text-danger').addClass('far fa-circle text-secondary');
    }
}

function submitBonus() {
    var list = [];
    $(mBonusList).each(function (index, item) {
        if (item.selected) {
            list.push(item);
        }
    })

    if (list.length > 1) {
        jAjaxGet('/public/config', null, function (json) {
            if (json.multi_coupon_use == 0) {
                showToast('优惠券不允许叠加使用');
                return;
            } else {
                submitBonusData(list);
            }
        });
    } else {
        submitBonusData(list);
    }
}

function submitBonusData(list) {
    setObjectCache(CONST_CACHE_BONUS_LIST_OBJECT, list);
    if (isApp()) {
        var pageName = getCache(CONST_CACHE_ORDER_PAGE);
        appcan.window.evaluateScript(pageName, 'bindBonus();');
    }
    closePage();
}
