var mCompanyID = null;
var mScreenCountDown = 5;

var mTabTitles = ['商家', '收到的礼物', '车源', '分类信息'];    //set titles of tabs
var mCodeList = null;
var mLastIndex = -1;
var mUser = null;
var mFollowNumber = null;
var mIsFollow = null;

var mGiftList = [];
var mGiftPageNumber = 1;
var mGiftLoading = false;
var mGiftFullyLoaded = false;

var mCarList = [];
var mCarPageNumber = 1;
var mCarLoading = false;
var mCarFullyLoaded = false;

var mInfoList = [];
var mInfoPageNumber = 1;
var mInfoLoading = false;
var mInfoFullyLoaded = false;

function initPage() {
    mUser = getUser();
    mCompanyID = getCache(CONST_CACHE_COMPANY_ID);
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mLastIndex == 1) {
                if (mGiftLoading == false) {
                    if (mGiftFullyLoaded == false) {
                        fetchGiftListApi();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            } else if (mLastIndex == 2) {
                if (mCarLoading == false) {
                    if (mCarFullyLoaded == false) {
                        fetchCarListApi();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            } else if (mLastIndex == 3) {
                if (mInfoLoading == false) {
                    if (mInfoFullyLoaded == false) {
                        fetchPostApi();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            }

        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindTabTitles();
    chooseTab(0);
}

function bindCompanyApi() {
    var data = { id: mCompanyID };
    if (mUser != null) {
        appendUserId(data);
    }
    jAjaxGet('/shop/detail', data, function (json) {
        mFollowNumber = json.follower_num;
        mIsFollow = (json.is_follow == 1);
        bindFollowInfo();
        bindCompany(json);
    });
}

function bindFollowInfo() {
    var html = getFollowInfoHtml();
    $('#followInfo').html(html);

}

function getFollowInfoHtml() {
    if (mUser == null) {
        return getNotLoggedFollowInfoHtml();
    } else {
        return getLoggedFollowInfoHtml();
    }
}

function getNotLoggedFollowInfoHtml() {
    var html = '<span style="font-size: 0.8rem;">关注</span><span  style="font-size: 0.8rem;" class="mx-1">' + mFollowNumber + '</span>';
    html += '<i class="far fa-star" onclick="goLogin();"></i>';
    return html;
}

function getLoggedFollowInfoHtml() {
    var html = '<span style="font-size: 0.8rem;">关注</span><span  style="font-size: 0.8rem;" class="mx-1">' + mFollowNumber + '</span>';
    if (mIsFollow) {
        html += '<i class="fas fa-star" onclick="unFollow();"></i>';
    } else {
        html += '<i class="far fa-star" onclick="follow();"></i>';
    }
    return html;
}

function unFollow() {
    var data = {
        id: mCompanyID
    };
    appendUserId(data);
    jAjaxPost('/shop/unFollow', data, function (json) {
        mIsFollow = false;
        mFollowNumber --;
        bindFollowInfo();
        console.dir(json)
    });
}

function follow() {
    var data = {
        id: mCompanyID
    };
    appendUserId(data);
    jAjaxPost('/shop/follow', data, function (json) {
        mIsFollow = true;
        mFollowNumber ++;
        bindFollowInfo();
        console.dir(json)
    });
}


function bindCompany(company) {
    $('.companyPicture').css('background-image', 'url(' + company.cover + ')');
    $('#followed').html(company.follower_num);
    $('#title').html(company.name);
    $('#tab0').html(company.name);


    $('#fans').html(company.total_tipping);
    $('#level').html('LV' + company.tipping_level);
    var companyInfo = getCompanyHtml(company)

    mCodeList[0] = companyInfo;
    $('#dataList').html(companyInfo);
}

function getCompanyHtml(company) {
    var html = '<div class="container-fluid">';

    html += '<div class="row mt-3">';
    html += '<div style="width:2rem;">编号</div>';
    html += '<div class="col">' + company.id + '</div>';
    html += '</div>';

    html += '<div class="row mt-2">';
    html += '<div style="width:2rem;">微信</div>';
    html += '<div class="col">' + company.wechat + '</div>';
    html += '</div>';

    html += '<div class="row mt-2">';
    html += '<div style="width:2rem;">电话</div>';
    html += '<div class="col">' + company.phone + '</div>';
    html += '</div>';

    html += '<div class="row mt-2">';
    html += '<div style="width:2rem;">地址</div>';
    html += '<div class="col">' + company.address + '</div>';
    html += '</div>';

    html += '</div>';
    return html;
}

function bindTabTitles() {
    mCodeList = [];
    var html = '';
    $(mTabTitles).each(function (index, item) {
        html += '<div class="middle bar" id="tab' + index + '" onclick="chooseTab(' + index + ');">' + item + '</div>';
        mCodeList.push(null);
    });
    $('#tabs').html(html);
}

function chooseTab(index) {
    if (index != mLastIndex) {
        $('#tab' + mLastIndex).removeClass('highlight');
        $('#tab' + index).addClass('highlight');
        mLastIndex = index;

        var html = mCodeList[index];
        if (html == null) {
            fetchTabResultCode();
        } else {
            bindTabData();
        }
    }
}

//user defined function according to the logic
function fetchTabResultCode() {
    switch (mLastIndex) {
        case 0:
            bindCompanyApi();
            break;
        case 1:
            fetchGiftListApi();
            break;
        case 2:
            fetchCarListApi();
            break;
        case 3:
            fetchPostApi();
            break;
        default:
            break;
    }
}

function fetchGiftListApi() {
    mGiftLoading = true;

    var data = {
        id: mCompanyID
    };
    data.page = mGiftPageNumber++;
    jAjaxGet('/shop/tippingRecords', data, function (json) {
        console.log(data.page, json.list.length)
        mGiftList = mGiftList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mGiftFullyLoaded = true;
        }

        fetchGiftList();
        mGiftLoading = false;
    }, function () {
        mGiftLoading = false;
    }, function () {
        mGiftLoading = false;
    });
}

function fetchGiftList() {
    var html = getGiftListHtml();

    mCodeList[mLastIndex] = html;
    bindTabData();
}

function getGiftListHtml() {
    if (mGiftList.length == '') {
        return getEmptyDataCode('还没有收到礼物');
    }
    var html = '<div class="container-fluid pl-4">';
    var sequence = 0;
    $(mGiftList).each(function (index, item) {
        if (item.gift) {
            sequence++;
            html += getGiftRowHtml(sequence, item);
        }
    });
    html += '</div>';
    return html;
}

function getGiftRowHtml(index, item) {
    var html = '<div class="row middle-y mt-4">';
    html += '<div style="color:#E65554">NO.' + index + '</div>';
    html += '<div class="ml-2">';
    html += '<img class="rounded-circle" src="' + item.user.avatar + '" style="width:1.5rem;" />';
    html += '</div>';
    html += '<div class="col" style="color:#BC594B">';
    html += '昵称|' + item.user.name;
    html += '</div>';
    html += '<div class="col" style="color:#BC594B">' + item.gift.name + '|' + item.total_amount + '</div>';
    html += '</div>';
    return html;
}

function fetchCarListApi() {
    mCarLoading = true;

    var data = {
        shop_id: mCompanyID
    };
    data.page = mCarPageNumber++;
    jAjaxGet('/shopItem/list', data, function (json) {
        console.log(data.page, json.list.length)
        mCarList = mCarList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mCarFullyLoaded = true;
        }

        mCodeList[mLastIndex] = getCarListHtml();
        bindTabData();

        mCarLoading = false;
    }, function () {
        mCarLoading = false;
    }, function () {
        mCarLoading = false;
    });
}

function fetchPostApi() {
    mInfoLoading = true;

    var data = {
        id: mCompanyID
    };
    data.page = mInfoPageNumber++;
    jAjaxGet('/shop/posts', data, function (json) {
        console.log(data.page, json.list.length)
        mInfoList = mInfoList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mInfoFullyLoaded = true;
        }

        fetchOwnerDetails();
        mInfoLoading = false;
    }, function () {
        mInfoLoading = false;
    }, function () {
        mInfoLoading = false;
    });
}

function fetchOwnerDetails() {
    var html = getOwnerDetailsHtml();
    mCodeList[mLastIndex] = html;
    bindTabData();
}

function getOwnerDetailsHtml() {
    if (mInfoList.length == 0) {
        return getEmptyDataCode('还没有发布信息');
    }
    var html = '';
    $(mInfoList).each(function (index, item) {
        html += getPostHtml(index, item);
    });
    return html;
}

function bindTabData() {
    var code = mCodeList[mLastIndex];
    $('#dataList').html(code);
}

function getCarListHtml() {
    if (mCarList.length == 0) {
        return getEmptyDataCode('还没有发布车源');
    }
    var html = '';
    $(mCarList).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="goCarDetailsPage(' + item.id + ');">';

    html += '<div class="pl-2"><img class="thumb" src="' + item.imgs[0] + '" /></div>';
    html += '<div class="col pr-0 ub-ver">' + getCarDetailsHtml(index, item) + '</div>';

    html += '</div>';
    return html;
}

function goCarDetailsPage(id) {
    openWinWithCache('carDetails', CONST_CACHE_CAR_ID, id);
}

function getCarDetailsHtml(index, item) {
    var html = '<div class="carName small">' + item.vehicle_name + '</div>';
    html += '<div class="ub-f1">&nbsp;</div>';
    html += '<div class="carAddress small">发布地址: ' + item.address + '</div>';
    html += '<div class="carDate small">上牌时间：' + item.first_license_date + '</div>';
    //html += '<div class="text-right small"><span onclick="edit(' + index + ');">编辑</span><span class="mx-2 t-gra" onclick="del(' + index + ');">删除</span></div>';
    return html;
}

function getPostHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="goPostPage(' + item.id + ');">';

    html += '<div class="pl-2"><img class="thumb" src="' + item.imgs[0] + '" /></div>';
    html += '<div class="col pr-0 ub-ver">' + getPostDetails(index, item) + '</div>';

    html += '</div>';
    return html;
}

function goPostPage(id) {
    openWinWithCache('post_details', CONST_CACHE_POST_ID, id);
}

function getPostDetails(index, item) {
    var html = '<div class="carName small mb-2">' + item.title + '</div>';
    html += '<div class="carAddress small mb-2">发布地址: ' + item.address + '</div>';
    html += '<div class="carAddress small mb-2">发布人: ' + item.contact_name + '</div>';
    html += '<div class="carDate small">发布时间：' + item.updated_at + '</div>';
    return html;
}

function showScreen() {
    if (mScreenCountDown > 0) {
        mScreenCountDown--;
    }
    if (mScreenCountDown == 0) {
        var msg = 'Width:' + screen.width + ', Height:' + screen.height;
        alert(msg);
    }
}
