var mRank = null;
var mRankIndex = 0; //0 for country, 1 for province, 2 for city
var mCityId = null;

function initPage() {
    if (isIos()) {
        $('.currentHeader').addClass('pt-3');
    }
    mCityId = getCache(CONST_CACHE_CITY_ID);
}

function bindPage() {
	bindData();
}

function bindData() {
    bindCompanyRankListApi();
}

function bindCompanyRankListApi() {
    var data = {
        id: mCityId
    };
    console.dir(data)
    jAjaxGet('/shop/rank', data, function (json) {
        mRank = json;
        console.dir(mRank)
        bindCompanyRankList();
    });
}

function bindCompanyRankList() {
    var list = getDataList();
    bindCompanyRankListByData(list);
}

function getDataList() {
    switch(mRankIndex) {
        case 0:
            return mRank.country;
        case 1:
            return mRank.province;
        case 2:
            return mRank.city;
        default:
            return [];
    }
}

function bindCompanyRankListByData(list) {
    var html = '';
    if (list.length == 0) {
        html = getEmptyDataCode();
    } else {
        html = getCompanyRankHeadHtml();
        $(list).each(function (index, item) {
            html += getCompanyRankHtml(index, item);
        });
    }
    $('#companyRankList').html(html);
}

function getCompanyRankHeadHtml() {
    var html = '<div class="row" style="color:#999;">';
    html += '<div class="col text-center px-0">排行</div>';
    html += '<div class="col text-center px-0">名称</div>';
    html += '<div class="col text-center px-0">人气财富</div>';
    html += '<div class="col text-center px-0">顶</div>';
    html += '</div>';
    return html;
}

function getCompanyRankHtml(index, item) {
    var rankCode = getRankCode(index);
    var html = '';
    if (index < 3) {
        html += '<div class="row small middle-y">';
        html += '<div class="col text-center px-0">' + rankCode + '</div>';
    } else {
        html += '<div class="row small mt-2">';
        html += '<div class="col text-center px-0 t-gra">' + rankCode + '</div>';
    }
    html += '<div class="col text-center px-0" onclick="goCompanyPage(' + item.id + ')">' + item.name + '</div> ';
    html += '<div class="col text-center px-0">' + item.total_tipping + '</div>';
    html += '<div class="col text-center px-0 t-red" onclick="reward(' + item.id + ');">支持他</div> ';
    html += '</div>';
    return html;
}

function goCompanyPage(shopId) {
    openWinWithCache('company', CONST_CACHE_COMPANY_ID, shopId);
}

function getRankCode(index) {
    if (index < 3) {
        return '<img src="img/rank' + (index + 1) + '.png" style="width:1.5rem;height:auto;" />';
    } else {
        return (index + 1);
    }
}

function reward(id) {
    openWinWithCache('reward', CONST_CACHE_COMPANY_ID, id);
}

function bindCompanyRankListForIndex(index) {
    if (index != mRankIndex) {
        $('#rank' + mRankIndex).removeClass('highlight');
        mRankIndex = index;
        bindCompanyRankList();
        $('#rank' + mRankIndex).addClass('highlight');
    }
}