//fields for whole page
var mCityObject = CityClass.createNew('#cityBlock');
var mLocationObject = LocationClass.createNew();
var mLoadBusListInterval = null;
var mSituationId = null;
var mFilterDisplayIndex = -1;   //-1 means no filter is displayed, while 0, 1, 2 and 3 for category, brand, year and price filter is displayed

//fields for search page
var mSearchCityId = 0;
var mSearchCurrentCity = null;
var mDistrictSearchPage = null;
var mSearchBusList = null;
var mSearchCarCategoryList = null;

var mCurrentLocation = null;
var mSearchCarCategoryIndex = null;
var mCarBrandListCarPage = null;
var mSearchCarBrandName = '';
var mSearchYearList = null;
var mSearchYearIndex = null;
var mSearchPriceList = null;
var mSearchMinPrice = null;
var mSearchMaxPrice = null;
var mMinPrice = 0;
var mMaxPrice = 60;

function initPage() {
    mSituationId = parseInt(getCache(CONST_CACHE_CAR_SITUATION_ID));
    //mLoadBusListInterval = setInterval(tryBindData, 500);
    mCurrentLocation = getObjectCache(CONST_CACHE_LOCATION_BAD_CAR_OBJECT);
    populateYearList();
    populatePriceList();
}

function bindPage() {
    initData();
    bindData();
    bindCarBrandListApiCarPage();
    tryBindData();
}

function initData() {
    jAjaxGet('/public/config', null, function (json) {
        mSearchCarCategoryList = json.vehicle_categories;
    });
}

function tryBindData() {

    mCurrentLocation = getObjectCache(CONST_CACHE_LOCATION_BAD_CAR_OBJECT);
    if (mCurrentLocation && mCurrentLocation.cityId) {
        mCityObject.locateCurrentCity(mCurrentLocation.cityId);
    }
    $('#searchCity').html(mCurrentLocation.cityName);
    bindBusListApi();
}

function chooseCityById(cityId) {
    console.log('cityId', cityId)
    var city = mCityObject.getCityByCityId(cityId);

    console.dir(city)

    mCurrentLocation.cityId = city.id;
    mCurrentLocation.district = null;
    $('#searchCity').html(city.city_name);
    bindBusListApi();

    hidePage('#cityPage');
}

function bindData() {
    var situationName = getCarSituationNameById(mSituationId);
    console.log(mSituationId, situationName)
    $('#title').html(situationName);
    mCityObject.loadCityApi();
    mLocationObject.bindCurrentLocation();
}

function searchSource() {
    var sourceKeywords = $.trim($('#sourceKeywords').val());
    if (sourceKeywords == '') {
        showToast('请输入搜索关键词');
        return;
    }
    var criteria = {
        name: sourceKeywords,
        cityId: mCityId,
        district: mDistrict
    };
    var cityName = $('#homeCity').html();
    if (mCityId == 0 || mCityId == null) {
        criteria.cityName = '全国';
        criteria.cityId = 0;
    } else {
        if (cityName != criteria.district) {
            criteria.cityName = cityName;
        }
    }
    setObjectCache(CONST_CACHE_SEARCH_BUS_OBJECT, criteria);

    openWin("search_car_list");
}

function chooseWholeCountry() {
    mCurrentLocation.cityId = 0;
    mCurrentLocation.district = null;
    $('#searchCity').html('全国');
    bindBusListApi();

    hidePage('#cityPage');
}

function locateCity() {
    var currentCityName = $('#currentCity').html();
    if (currentCityName != '定位中...') {
        var location = mLocationObject.bindCurrentLocation(function (location) {
            mCityObject.changeCurrentCity(location.addressComponent.city);
            console.dir(location);
        }, true);
    }
}

function chooseCity(cityIndex) {
    var city = mCityObject.getCity(cityIndex);
    mCurrentLocation.cityId = city.id;
    mCurrentLocation.district = '';
    $('#searchCity').html(city.city_name);

    bindBusListApi();
    hidePage('#cityPage');
}

function bindBusListApi() {
    var data = getBusListApiData();
    console.dir(data)
    jAjaxGet('/shopItem/list', data, function (json) {
        mSearchBusList = json.list;
        bindBusList();
    });
}

function getBusListApiData() {
    var data = {
        city_id: mCurrentLocation.cityId,
        vehicle_situation: mSituationId
    };
    if (mCurrentLocation.district != null) {
        data.district = mCurrentLocation.district;
    }
    if (mSearchCarCategoryIndex != null) {
        data.vehicle_category = mSearchCarCategoryList[mSearchCarCategoryIndex].key;
    }
    data.vehicle_brand = mSearchCarBrandName;
    var carName = $('#carName').val();
    if (carName) {
        data.name = carName;
    }
    if (mSearchYearIndex != null) {
        data.year_range = getYearRange();
    }
    data.price_range = getPriceRange();
    return data;
}

function bindBusList() {
    var html = getCarListHtml(mSearchBusList);
    $('#searchCarList').html(html);
}

function getCarListHtml(carList) {
    var html = '';
    $(carList).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="chooseCar(' + item.id + ');">';

    html += '<div class="ml-2 thumb divBackground rounded" style="background-image: url(' + item.imgs[0] + ')"></div>';
    html += '<div class="col ellipsis" style="display:flex;flex-direction:column;justify-content:space-between;height:5rem;">' + getCarDetailsHtml(item) + '</div>';

    html += '</div>';
    return html;
}

function chooseCar(carId) {
    openWinWithCache("carDetails", CONST_CACHE_CAR_ID, carId);
}

function getCarDetailsHtml(item) {
    var html = '<div class="carName ellipsis">' + item.vehicle_name + '</div>';
    html += '<div class="carPrice">价格: ¥' + getPriceText(item.price) + '</div>';
    html += '<div class="carDate">上牌时间：' + item.first_license_date + '</div>';
    return html;
}

function showCategoryList() {
    if (canOpenFilter(0)) {
        var html = getCategoryListHtml();
        showFilterBody(html, false);

        mFilterDisplayIndex = 0;
        event.stopPropagation();
    }
}

function canOpenFilter(index) {
    if (mFilterDisplayIndex == -1) {
        return true;
    }
    return (mFilterDisplayIndex != index);
}

function getCategoryListHtml() {
    var html = getSearchCaregoryHtml(-1, '不限');
    $(mSearchCarCategoryList).each(function (index, item) {
        html += getSearchCaregoryHtml(index, item.label);
    });
    return html;
}

function getSearchCaregoryHtml(index, label) {
    var html = '<div class="row border-top p-2">';
    if (index >= 0) {
        html += '<div class="col" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + label + '</div>';
    } else {
        html += '<div class="col" onclick="resetCarCategory();">' + label + '</div>';
    }

    html += '</div>';
    return html;
}

function chooseCarCategory(index) {
    mSearchCarCategoryIndex = index;
    $('#filterType').html(mSearchCarCategoryList[index].label);
    bindBusListApi();
}

function resetCarCategory() {
    mSearchCarCategoryIndex = null;
    $('#filterType').html('类型');
    bindBusListApi();
}

function showFilterBody(html, isPrice) {
    $('#filterBody').html(html);
    if (isPrice) {
        $('#priceSlider').removeClass('d-none');
    } else {
        $('#priceSlider').addClass('d-none');
    }
    $('#filter').show();
}

function showBrandList() {
    showBrandPage(true);
    mFilterDisplayIndex = 1;
    event.stopPropagation();
}

function showBrandPage(hasAllOption) {
    if (hasAllOption) {
        $('#allCarOption').show();
    } else {
        $('#allCarOption').hide();
    }
    showPage('#carBrandPage');
}

function emptyFilters() {
    $('#filterBody').html('');
    $('#filter').hide();
    $('#priceSlider').addClass('d-none');
    mFilterDisplayIndex = -1;
    bindBusListApi();
}

function bindCarBrandListApiCarPage() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mCarBrandListCarPage = json.list;
        bindCarBrandListCarPage();
    });
}

function bindCarBrandListCarPage() {
    var html = getCarBrandListHtmlCarPage();
    $('#carBrandList').html(html);

    html = getCarBrandLetterListHtmlCarPage();
    if (isIos()) {
        $('#carBrandLetters').css('top', '4.5rem');
    }
    $('#carBrandLetters').html(html);
}

function getCarBrandListHtmlCarPage() {
    var itemHtml = '<div id="allCarOption" class="border-bottom p-2" onclick="resetCarBrand();">不限</div>';
    $(mCarBrandListCarPage).each(function (index, item) {
        itemHtml += getCarBrandItemHtmlCarPage(index, item);
    });

    var html = '<div class="row">';
    html += '<div class="col mr-4">' + itemHtml + '</div>';
    html += '<div style="position: fixed;bottom:0px;right:0;">&nbsp;</div>';
    html += '</div>';

    return html;
}

function resetCarBrand() {
    $('#filterBrand').html('品牌');
    mSearchCarBrandName = '';
    bindBusListApi();
    hidePage('#carBrandPage');
}

function getCarBrandItemHtmlCarPage(letterIndex, item) {
    if (item.itemList.length == 0) {
        return '';
    } else {
        var html = '<div class="invisible" id="brandLetter' + item.letter + '"></div>';
        $(item.itemList).each(function (index, brand) {
            html += '<div class="border-bottom p-2" onclick="chooseCarBrandCarPage(' + letterIndex + ',' + index + ');">' + brand + '</div>';
        });
        return html;
    }
}

function chooseCarBrandCarPage(letterIndex, index) {
    mSearchCarBrandName = mCarBrandListCarPage[letterIndex].itemList[index];
    $('#filterBrand').html(mSearchCarBrandName);
    bindBusListApi();
    hidePage('#carBrandPage');
}

function getCarBrandLetterListHtmlCarPage() {
    var letterHtml = '';
    $(mCarBrandListCarPage).each(function (index, item) {
        letterHtml += getLetterHtml(index);
    });

    return letterHtml;
}

function getLetterHtml(index) {
    var letter = mCarBrandListCarPage[index].letter;
    return '<div class="text-center px-1 ub-f1" style="color:#DC4F3F;" ontouchstart="jumpToAnchor(' + index + ');">' + letter + '</div>';
}

function jumpToAnchor(index){
    var letter = mCarBrandListCarPage[index].letter;
    var url = 'home.html';               //Save down the URL without hash.
    location.href = "#brandLetter" + letter;                 //Go to the target element.
    history.replaceState(null,null,url);   //Don't like hashes. Changing it back.
}

function showYearList() {
    if (canOpenFilter(2)) {
        var html = getYearListHtml();
        showFilterBody(html, false);
        mFilterDisplayIndex = 2;
        event.stopPropagation();
    }
}

function getYearListHtml() {
    var html = '<div class="row border-top p-2"><div class="col" onclick="resetCarYear();">不限</div></div>';
    $(mSearchYearList).each(function (index, item) {
        html += getYearHtml(index, item);
    });
    return html;
}

function getYearHtml(index, item) {
    var html = '<div class="row border-top p-2">'
    html += '<div class="col" onclick="chooseYear(' + index + ');">' + item.text + '</div>';
    html += '</div>'
    return html;
}

function chooseYear(index) {
    mSearchYearIndex = index;
    var name = mSearchYearList[index].text;
    $('#filterAge').html(name);
    bindBusListApi();
}

function populateYearList() {
    mSearchYearList = [
        {
            min: 0,
            max: 1,
            text:'一年内'
        },
        {
            min: 1,
            max: 2,
            text: '1~2年'
        },
        {
            min: 2,
            max: 3,
            text: '2~3年'
        },
        {
            min: 3,
            max: 5,
            text: '3~5年'
        },
        {
            min: 5,
            max: null,
            text: '5年以上'
        }
    ];
}

function showPriceList() {
    if (canOpenFilter(3)) {
        var html = getPriceListHtml();
        showFilterBody(html, true);

        mFilterDisplayIndex = 3;
        event.stopPropagation();
    }
}

function getPriceListHtml() {
    var html = getPriceHtml(-1, '不限');
    $(mSearchPriceList).each(function (index, item) {
        html += getPriceHtml(index, item.text);
    });
    return html;
}

function getPriceHtml(index, text) {
    var html = '<div class="row border-top p-2">'
    if (index == -1) {
        html += '<div class="col" onclick="resetCarPrice();">' + text + '</div>';
    } else {
        html += '<div class="col" onclick="choosePrice(' + index + ');">' + text + '</div>';
    }
    html += '</div>'
    return html;
}

function resetCarPrice() {
    mSearchMinPrice = null;
    mSearchMaxPrice = null;
    showFilterPrice();
    bindBusListApi();
}

function showFilterPrice() {
    var name = '';
    if (mSearchMinPrice == null || mSearchMinPrice == 0) {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = '价格';
        } else {
            name = mSearchMaxPrice + '万以下';
        }
    } else {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = mSearchMinPrice + '万以上';
        } else {
            name = mSearchMinPrice + '-' + mSearchMaxPrice + '万';
        }
    }
    $('#filterPrice').html(name);
}

function choosePrice(index) {
    var price = mSearchPriceList[index];
    mSearchMinPrice = price.min;
    mSearchMaxPrice = price.max;

    showFilterPrice();
    bindBusListApi();
}

function populatePriceList() {
    mSearchPriceList = [
        {
            min: 0,
            max: 5,
            text: '5万以下'
        },
        {
            min: 5,
            max: 10,
            text: '5~10万'
        },
        {
            min: 10,
            max: 15,
            text: '10~15万'
        },
        {
            min: 15,
            max: 20,
            text: '15~20万'
        },
        {
            min: 20,
            max: 50,
            text: '20~50万'
        },
        {
            min: 50,
            max: null,
            text: '50万以上'
        }
    ];
}

function chooseMinPrice(current) {
    current.value=Math.min(current.value,current.parentNode.childNodes[5].value - 1);
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.left=value*100/60+'%';
    children[7].style.left=value*100/60+'%';
    mMinPrice = value;
    mSearchMinPrice = value;
    showPriceRange();
}

function chooseMaxPrice(current) {
    current.value=Math.max(current.value,current.parentNode.childNodes[3].value - (-1));
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.right=(100-value*100/60)+'%';
    children[9].style.left=value*100/60+'%';
    mMaxPrice = value;
    mSearchMaxPrice = value;
    showPriceRange();
}

function showPriceRange() {
    if (mMaxPrice == 60) {
        mSearchMaxPrice = null;
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    } else {
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    }

    showSliderPrice();
    showFilterPrice();
}

function showSliderPrice() {
    var name = '';
    if (mSearchMinPrice) {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMinPrice) + '-' + getPriceText(mSearchMaxPrice);
        } else {
            name = getPriceText(mSearchMinPrice) + '以上';
        }
    } else {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMaxPrice) + '以下';
        } else {
            name = '价格不限';
        }
    }
    $('#priceRange').html(name);
}

function getPriceText(wan) {
    return wan + '万元';
}

function getPriceRange() {
    var min = mSearchMinPrice ? mSearchMinPrice : 0;
    var max = (mSearchMaxPrice) ? mSearchMaxPrice : '';
    return min + '-' + max;
}