//fields for whole page
var mLastPageIndex = 0;
var mPagesStatus = [true, false, false, false, false];
var mUser = null;
var mCityObject = CityClass.createNew('#cityBlock');
var mLocationObject = LocationClass.createNew();
var mFileUploader = null;
var mCustomerServiceDisplayed = false;
var mModalID = null;
var mTakePhotoOnPostPage = null;
var mChoseImageList = null;
var mUploadingImageIndex = null;
var mNoticeCount = 0;
var mDateIndex = -1;

//fields for home page
var mCityId = 1;
var mLoadDataInterval = null;
var mDistrict = null;
var mSituationId = 0;
var mVipShopBackgroundImage = null;
var mHotShopBackgroundImage = null;
var mBannerList = null;
var mGiftCount = 0;
var mSwiper = null;
var mPostCategoryList = null;

//fields for search page
var mLoadBusListInterval = null;
var mSearchCityId = 0;
var mSearchCurrentCity = null;
var mDistrictSearchPage = null;
var mSearchBusList = null;
var mSearchCarCategoryList = null;
var mSearchCarBrandList = null;
var mSearchCarCategoryIndex = null;
var mSearchYearList = null;
var mSearchYearIndex = null;
var mSearchPriceList = null;
var mSearchMinPrice = null;
var mSearchMaxPrice = null;
var mFilterDisplayIndex = -1;   //-1 means no filter is displayed, while 0, 1, 2 and 3 for category, brand, year and price filter is displayed
var mMinPrice = 0;
var mMaxPrice = 60;

//fields for post page
var mCategoryListPostPage = null;
var mCategoryIndexPostPage = -1;
var mPostIdPostPage = null;
var mPostLocation = null;
var mPostPhotoList = [];

//fields for car page
var mCarCategoryListCarPage = null;
var mCarBrandListCarPage = null;
var mSearchCarBrandName = '';
var mCarTypeListCarPage = null;
var mCarColorListCarPage = null;
var mCarCategoryIndexCarPage = -1;
var mCarBrandLetterIndexCarPage = -1;
var mCarBrandLetterItemIndexCarPage = -1;
var mCarTypeIndexCarPage = -1;
var mCarColorIndexCarPage = -1;
var mIsViolationCarPage = false;
var mLocationCarPage = null;
var mCarSubmissionTypeListCarPage = null;
var mCarSubmissionTypeIndexCarPage = -1;
var mCarSituationListCarPage = null;
var mCarSituationIndexCarPage = -1;
var mCarGearBoxListCarPage = null;
var mCarGearBoxIndexCarPage = -1;
var mCarLocation = null;
var mCarPhotoList = [];
var mCarPhotoUploadedUrlList = [];
var mCarSeriesArray = [];
var mCarPatternArray = [];
var mLastBrand = null;
var mBrandSeriesIndex = null;

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
}

function closeModal() {
    if (mModalID == null) {
        return;
    }
    $(mModalID).hide();
    hideLayer();

    handleOtherModals();
    mModalID = null;
}

function handleOtherModals() {
    switch (mModalID) {
        case "#customerServiceUserPage":
            mCustomerServiceDisplayed = true;
            break;
        default:
            break;
    }
}

//fields for user page
var mCustomerServiceUserPage = null;

function openHomePageByUser(index) {
    if (mLastPageIndex == index) {
        return;
    }
    if (mUser != null) {
        showHomePage(index);
    } else {
        openWin('login');
    }
}

function showHomePage(index) {
    if (index == 0 || index == 4) {
        refreshUserApi();
    }
    if (index == 0) {
        tryBindData();
    }

    var pageName = getPageNameByIndex(mLastPageIndex);
    hidePage('#' + pageName);
    mLastPageIndex = index;
    pageName = getPageNameByIndex(mLastPageIndex);
    showPage('#' + pageName);
    initAndBindPage(index);

    if (isApp()) {
        uexWindow.setBounce(mLastPageIndex > 0 ? 0 : 1);
    }

    if (mUser != null && index == 0) {
        trySetJpush(mUser.id);
    }
}

function initAndBindPage(index) {
    if (mPagesStatus[index] == false) {
        mPagesStatus[index] = true;

        switch (index) {
            case 1:
                $('#searchFooter').html(getFooterHtml(index));
                bindPageSearchPage();
                break;
            case 2:
                $('#footerPostPage').html(getFooterHtml(index));
                locateNowPostPage();
                break;
            case 3:
                $('#footerCarPage').html(getFooterHtml(index));
                initPageCarPage();
                bindPageCarPage();
                checkIsShopOwner();
                break;
            case 4:
                $('#footerUserPage').html(getFooterHtml(index));
                bindPageUserPage();
                break;
            default:
                break;
        }
    }
}

function refreshUser() {
    mUser = getUser();
    bindUserDataUserPage();
}

function initPage() {
    if (CONFIG_IS_DEBUG == false) {
        setMainWindow();
    }

    bindBonuseEvents();
    initRollDateControls();
    mUser = getUser();
    mFileUploader = FileUploader.createNew();
    mLoadDataInterval = setInterval(tryBindData, 1000);

    if (isIphoneX()) {
        var marginBottom = '1rem';
        $('#homeBodyPage').css('marginBottom', marginBottom);
        $('#cityBodyPage').css('marginBottom', marginBottom);
        $('#filterBodyPage').css('marginBottom', marginBottom);
        $('#postBodyPage').css('marginBottom', marginBottom);
        $('#carBodyPage').css('marginBottom', marginBottom);
        $('#userBodyPage').css('marginBottom', marginBottom);
    }
}

function uploadChoseImageList() {
    startLoading('图片上传中');
    uploadChoseImage();
}

function uploadChoseImage() {
    var imgPath = mChoseImageList[mUploadingImageIndex];
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
        mUploadingImageIndex++;

        if (mTakePhotoOnPostPage) {
            mPostPhotoList.push(uploadedUrl);
            if (mUploadingImageIndex == mChoseImageList.length) {
                bindCarPhotoListPostPage();
                finishLoading();
            } else {
                uploadChoseImage();
            }
        } else {
            mCarPhotoList.push(uploadedUrl);
            if (mUploadingImageIndex == mChoseImageList.length) {
                bindCarPhotoListCarPage();
                finishLoading();
            } else {
                uploadChoseImage();
            }
        }
    });
}

function bindPage() {
    bindData();

    var html = getFooterHtml(mLastPageIndex);
    $('#footer').html(html);
    bindCarBrandListApiCarPage();
}

function tryBindData() {
    if (mCityObject.isInitialized() && mLocationObject.isInitialized()) {
        jLog('city and location are initialized');
        clearInterval(mLoadDataInterval);
        var location = mLocationObject.getCurrentLocation();
        if (location == null) {
            mCityId = 0;
            mSearchCityId = 0;
            mDistrict = '';
            mDistrictSearchPage = '';
            $('#homeCity').html('全国');
            $('#searchCity').html('全国');
            mCityObject.locateCurrentCityFailed();
        } else {
            mCityId = mCityObject.getCityIdByCityName(location.addressComponent.city);
            mSearchCityId = mCityId;
            if (mCityId != 0) {
                mDistrict = location.addressComponent.district;
                if (mDistrict) {
                    $('#homeCity').html(mDistrict);

                    mDistrictSearchPage = mDistrict;
                    $('#searchCity').html(mDistrictSearchPage);
                } else {
                    $('#homeCity').html(location.addressComponent.city);
                    $('#searchCity').html(location.addressComponent.city);
                }
                mCityObject.locateCurrentCity(mCityId);
            } else {
                $('#homeCity').html('全国');
                $('#searchCity').html('全国');
                mCityObject.locateCurrentCityFailed();
            }
        }
        bindHomePageDataApi();
    }
}

function locateCity() {
    var currentCityName = $('#currentCity').html();
    if (currentCityName != '定位中...') {
        mLocationObject.bindCurrentLocation(function (location) {
            mCityObject.changeCurrentCity(location.addressComponent.city);
        }, true);
    }
}

function chooseCityById(cityId) {
    var city = mCityObject.getCityByCityId(cityId);
    var cityName = city.city_name;
    if (mLastPageIndex == 0) {
        mCityId = city.id;
        $('#homeCity').html(cityName);
        mDistrict = null;
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != city.id || mDistrictSearchPage != null) {
            mSearchCityId = city.id;
            mDistrictSearchPage = null;
            $('#searchCity').html(cityName);
            bindBusListApi();
        }
    }
    hideCityPage();
}

function bindData() {
    bindPublicData();

    try {
        mCityObject.loadCityApi();
        mLocationObject.bindCurrentLocation();
    } catch( err) {
        jLog(err)
    }
    bindNotificationAlertInfo();
}

function bindNotificationAlertInfo() {
    var count = getCache(CONST_CACHE_NOTIFICATION_COUNT);
    if (count == '') {
        $('#notificationInfo').html('');
    } else {
        var html = '<sup class="rounded-circle middle bellNotification">' + count + '</sup>';
        $('#notificationInfo').html(html);
    }
}

function addNotificationAlert() {
    var count = getCache(CONST_CACHE_NOTIFICATION_COUNT);
    if (count == '') {
        count = 1;
    } else {
        count ++;
    }
    setCache(CONST_CACHE_NOTIFICATION_COUNT, count);
    bindNotificationAlertInfo();
}

function clearNotificationAlert() {
    removeCache(CONST_CACHE_NOTIFICATION_COUNT);
    bindNotificationAlertInfo();
}

function searchSource() {
    var sourceKeywords = $.trim($('#sourceKeywords').val());
    if (sourceKeywords == '') {
        showToast('请输入搜索关键词');
        return;
    }
    var criteria = {
        name: sourceKeywords,
        cityId: mCityId,
        district: mDistrict
    };
    var cityName = $('#homeCity').html();
    if (mCityId == 0 || mCityId == null) {
        criteria.cityName = '全国';
        criteria.cityId = 0;
    } else {
        if (cityName != criteria.district) {
            criteria.cityName = cityName;
        }
    }
    setObjectCache(CONST_CACHE_SEARCH_BUS_OBJECT, criteria);

    openWin("search_car_list");
}

function bindPublicData() {
    var data = null;
    if (isAndroid()) {
        data = {
            versionId: CONFIG_IS_TEST ? CONFIG_ANDROID_TEST_VERSION_ID : CONFIG_ANDROID_PRODUCTION_VERSION_ID
        }
    }
    jAjaxGet('/public/config', data, function (json) {
        checkUpdate(json);
        if (json.guarantee_text) {
            setCache(CONST_CACHE_GUARANTEE_NOTICE, $.trim(json.guarantee_text));
            setCache(CONST_CACHE_PLATFORM_400_TELEPHONE, json.contact_phone);
            setCache(CONST_CACHE_SHARE_TEXT, json.share_text);
        }
        mHotShopBackgroundImage = json.hot_vehicle_bg;
        mVipShopBackgroundImage = json.vip_shop_bg;
        mCarColorListCarPage = json.vehicle_colors;

        bindHotCarType();

        //bind search page
        mSearchCarCategoryList = json.vehicle_categories;

        //bind post page
        mCategoryListPostPage = json.post_categories;
        bindCategoryListPostPage();

        //bind car page
        mCarCategoryListCarPage = json.vehicle_categories;
        bindCarCategoryListCarPage();

        mCarSubmissionTypeListCarPage = json.emission_types;
        bindCarSubmissionTypeListCarPage();

        mCarSituationListCarPage = json.vehicle_situations;
        var normalSituation = {
            key: 0,
            label: '正常'
        };
        mCarSituationListCarPage.splice(0, 0, normalSituation);
        bindCarSituationListCarPage();
        chooseCarSituationCarPage(0);

        mCarGearBoxListCarPage = json.gearbox;
        bindCarGearBoxListCarPage();

        //car typelist
        mCarTypeListCarPage = json.vehicle_types;
        bindCarTypeListCarPage();

        //kefu
        mCustomerServiceUserPage = json.kefu;
        bindCustomerServiceUserPage();
    });
}

function resetListField(jqid, placeholder) {
    $(jqid).addClass('t-gra').html(placeholder);
}

//functions for home page
function bindHomePageDataApi() {
    var data = {
        id: mCityId
    };
    if (mDistrict) {
        data.district = mDistrict;
    }
    jAjaxGet('/public/home', data, function (json) {
        mBannerList = json.banners;
        mPostCategoryList = json.post_categories;
        bindBanners();
        bindNotificationList(json.notices);
        bindPostCategoryList();
        bindTippingList(json.recent_tipping);
        bindTopShopList(json.top_shops);
        bindVipShopList(json.vip_shops);
        bindLatestCarList(json.latest_shop_items);
    });
}

function bindBanners() {
    var html = '';
    $(mBannerList).each(function (index, item) {
        html += '<div class="swiper-slide" onclick="viewBanner(' + index + ')">';
        html += '<img src="' + item.img + '" alt="" style="width:100%;height:10rem;" class="breath_light">';
        html += '</div>';
    });
    $('#banners').html(html);

    new Swiper('.swiper-container', {
        spaceBetween: 0,
        centeredSlides: true,
        autoplay: {
            delay: 2500,
            disableOnInteraction: false,
        },
        pagination: {
            el: '.swiper-pagination',
            clickable: true,
        }
    });

    $('#prevSlide').css('height', '3rem').show();
    $('#nextSlide').css('height', '3rem').show();
    $('#slideButtons').css('height', 0);

    updateBapinLocation();
}

function updateBapinLocation() {
    var notificationTop = $('#dvNotification').position().top;
    var height = $('#bapin').height();
    $('#bapin').css('height', 0).show();
}

function slidePrevious() {
    if (mSwiper != null) {
        mSwiper.prev();
    }
    event.stopPropagation();
}

function slideNext() {
    if (mSwiper != null) {
        mSwiper.next();
    }
    event.stopPropagation();
}

function bindVipShopList(shops) {
    if (shops.length == 0) {
        var html = getEmptyVipBannerImageHtml();
        $('#vipBanners').removeClass('d-none').html(html);
    } else if (shops.length == 1) {
        var html = getVipBannerImageHtml(shops[0]);
        $('#vipBanners').removeClass('d-none').html(html);
    } else if (shops.length > 1) {
        $('#vipBanners').removeClass('d-none');
        bindVipBannerSwipe(shops);
        enableBanner('vipBanner_box');
    }
}

function getEmptyVipBannerImageHtml() {
    var shop = { cover: 'img/vip.jpg' };
    if (mVipShopBackgroundImage) {
        shop.cover = mVipShopBackgroundImage;
    }
    var html = '';
    html += '<div class="swiper-slide divBackground" style="height:8rem;background-image: url(' + shop.cover + ');">';
    html += '<div onclick="buyShopVip();" class="font-weight-bold small" style="color:#BC594B;position: absolute;bottom:0.25rem;right:0.5rem;">我也想加入</div>';
    html += '</div>';
    return html;
}

function bindHotCarType() {
    var shop = { cover: 'img/vip.jpg' };
    if (mVipShopBackgroundImage) {
        shop.cover = mVipShopBackgroundImage;
    }
    var html = '';
    html += '<div class="swiper-slide divBackground" style="height:8rem;background-image: url(' + shop.cover + ');">';
    html += '<div>';
    html += '<div class="text-center pt-2 font-weight-bold" style="right:0.5rem;">';
    html += '<img src="img/type-yinzhuangfei.png" class="rounded" style="width:5rem;height:1.75rem;" onclick="searchBadCarList(3);" />';
    html += '<img src="img/type-offline.png" class="mx-2 rounded" style="width:5rem;height:1.75rem;" onclick="searchBadCarList(4);" />';
    html += '<img src="img/type-taxi.png" class="rounded" style="width:5rem;height:1.75rem;" onclick="searchBadCarList(6);">';
    html += '</div>';
    html += '</div>';
    html += '</div>';
    $('#hotType').html(html).removeClass('d-none');
}

function buyShopVip() {
    var user = getUser();
    if (user == null) {
        goLoginForNotLoggedUserUserPage();
    } else {
        if (user.is_vip) {
            openWin('shop_bapin_buy');
        } else {
            var data = getUserIdObject();
            jAjaxGet('/user/profile', data, function (json) {
                if (json.is_vip) {

                } else {
                    showToast('非会员不能加入，请先到我的-购买会员后加入');
                }
                refreshUserData(json);
            });
        }
    }
}

function getBannerImageHtml() {
    var imgUrl = mBannerList[0].img;
    var html = '';
    html += '<div class="swiper-slide divBackground" style="height:10rem;background-image: url(' + imgUrl + ');" onclick="viewBanner(0);">';
    html += '</div>';
    return html;
}

function viewBanner(bannerIndex) {
    var banner = mBannerList[bannerIndex];
    if (banner.shop_id && banner.shop_id != "0") {
        goCompanyPage(banner.shop_id);
        return;
    }
    if (banner.title && banner.content) {
        var article = {
            title: banner.title,
            content: banner.content
        };
        setObjectCache(CONST_CACHE_ARTICLE_OBJECT, article);
        openWin('article');
    }
}

function getVipBannerImageHtml(shop) {
    var html = '';

    html += '<div class="swiper-slide pt-3 doubleBackgrounds" style="height:10rem;width:100%;background-image: -webkit-cross-fade(url(http://noahsoft.site/images/light-gray.png), url(' + shop.cover + '), 50%);">';

    html += '<div class="container-fluid">';
    html += '<div class="row" onclick="goCompanyPage(' + shop.id + ');">';
    html += '<div class="col-3"></div>';
    html += '<div class="text-left col-9" style="font-size: 90%;font-weight: 400;">';
    html += '<div class="font-weight-bold ellipsis" style="font-size: 0.9rem;"><span class="mr-2">' + shop.name + '</span><span style="color:#DD0101;">LV' + shop.tipping_level + '</span></div>';
    html += '<div>电话：' + shop.phone + '</div>';
    html += '<div>微信：' + shop.wechat + '</div>';
    html += getVipShopGiftListHtml(shop.recent_gift, shop.total_tipping);
    html += '</div>';
    html += '</div>';
    html += '</div>';

    html += '<div class="container-fluid mt-2">';
    html += '<div class="row" style="font-size: 90%;font-weight: 400;">';
    html += '<div onclick="goRankPage();" class="col text-left font-weight-bold" style="color:#AE7B4A;"><img style="width:0.4rem;height:auto;" src="img/arrow-up.png" /><span>榜上有名</span></div>';
    html += '<div onclick="reward(' + shop.id + ');" class="col text-center font-weight-bold" style="color:#117373;"><img style="width:0.4rem;height:auto;" src="img/thumb-up.png" />支持他</div>';
    html += '<div onclick="buyShopVip();" class="col text-right font-weight-bold" style="color:#BC594B;">我也想加入</div>';
    html += '</div>';
    html += '</div>';
    html += '</div>';

    return html;
}

function getVipShopGiftListHtml(giftList, tippings) {
    switch(giftList.length) {
        case 0:
            return getVipShopNoGiftsHtml(tippings);
        case 1:
            return getVipSingleGiftHtml(giftList[0], tippings);
        default:
            return getVipShopMoreGiftsHtml(giftList, tippings);
    }
}

function getVipShopNoGiftsHtml(tippings) {
    return '<div>人气值：' + tippings + '</div>';
}

function getVipSingleGiftHtml(gift, tippings) {
    var html = '<div>' + gift.gift + ':' + gift.num + '</div>';
    html += '<div>人气值：' + tippings + '</div>';
    return html;
}

function getVipShopMoreGiftsHtml(giftList, tippings) {
    var gift1 = giftList[0];
    var gift2 = giftList[1];

    var html = '<div>' + gift1.gift + ':' + gift1.num + '</div>';
    html += '<div>' + gift2.gift + ':' + gift2.num + '<span class="ml-2">人气值：' + tippings + '</span></div>';
    if (giftList.length > 2) {
        var gift2 = giftList[2];
        html += '<div>' + gift2.gift + ':' + gift2.num + '</div>';
    }
    return html;
}

function reward(companyID) {
    var user = getUser();
    if (user == null) {
        setCache(CONST_CACHE_COMPANY_ID, companyID);
        goLogin('home', null, 'reward');
    } else {
        openWinWithCache('reward', CONST_CACHE_COMPANY_ID, companyID);
    }
}

function goCompanyPage(shopId) {
    if (shopId) {
        openWinWithCache('company', CONST_CACHE_COMPANY_ID, shopId);
    }
}

function bindVipBannerSwipe(vipBannerList) {
    var html = '<div style="-webkit-transform: translate3d(0,0,0);">';
    html += '<div id="vipBanner_box" class="box_swipe" style="visibility: visible;">';
    html += '<ul style="list-style: none; width: 4800px; transition-duration: 500ms; transform: translate3d(-1920px, 0px, 0px);">';
    $(vipBannerList).each(function (index, item) {
        html += getVipBannerImageHtml(item);
    });
    html += '</div></div>';
    $('#vipBanners').html(html);
}

function getBannerCode(index, banner) {
    var html = '';
    html += '<div class="swiper-slide divBackground" style="height:10rem;background-image: url(' + banner.img + ');" onclick="viewBanner(' + index + ')">';
    html += '</div>';
    return html;
}

function getBannerFooterCode(index) {
    var itemClass = (index == 0) ? "on" : "";
    return '<li class="' + itemClass + '"></li> ';
}

function enableBanner(elementId) {
    var swiper = new Swipe(document.getElementById(elementId), {
        speed: 500,
        auto: 3000,
        callback: function () {
            var lis = $(this.element).next("ol").children();
            lis.removeClass("on").eq(this.index).addClass("on");
        }
    });
    if (elementId == 'vipBanner_box') {
        mSwiper = swiper;
    }
}

function bindNotificationList(notificationList) {
    if (notificationList.length > 0) {
        var html = getNotificationListHtml(notificationList);
        $('#holder2').html(html);

        mNoticeCount = notificationList.length;

        setTimeout(autoScrollNoticeList, 1000);
    }
}

function getNotificationListHtml(itemList) {
    var html = '';
    $(itemList).each(function (index, item) {
        html += '<li id="notice' + index + '">' + item.title + '</li>';
    })
    html += '<li id="noticeLast' + '">' + itemList[0].title + '</li>';
    return html;
}

function autoScrollNoticeList() {
    $('#notice0').animate({
            marginTop: ('-' + (1.5 * mNoticeCount) + 'rem')
        },
        mNoticeCount * 3000,
        function() {
            $('#notice0').css({  marginTop: "0rem" });
            autoScrollNoticeList();
        }
    );
}

function getNotificationHtml(index, notification) {
    return  '<li id="notice' + index + '">' + notification.title + '</li>';
}

function goNoticeListPage() {
    openWin('notification_list');
}

function bindPostCategoryList() {
    fillArrayOneRow(mPostCategoryList, 5);

    var html = '';
    for (var i = 0; i < mPostCategoryList.length; i += 5) {
        html += getPostCategoryListHtml(i);
    }
    $('#postCategoryList').html(html);
}

function getPostCategoryListHtml(startIndex) {
    var html = '<div class="row mt-2">';
    for (var i = startIndex; i < startIndex + 5; i++) {
        var pcss = null;
        if (i % 5 == 0) {
            pcss = 'pr-0';
        } else if (i % 5 == 4) {
            pcss = 'pl-0';
        } else {
            pcss = 'p-0';
        }
        html += getPostCategoryHtml(pcss, i);
    }
    html += '</div>';
    return html;
}

function getPostCategoryHtml(css, index) {
    var postCategory = mPostCategoryList[index];
    if (postCategory == null) {
        return getEmptyPostCategoryHtml(css);
    }
    var html = '<div class="col ' + css + '" onclick="goPostList(' + index + ');">';
    html += '<div class="middle-x"> <img src="' + postCategory.img + '" class="flag" /></div>';
    html += '<div class="flagText middle-x">' + postCategory.name + '</div>';
    html += '</div>';
    return html;
}

function getEmptyPostCategoryHtml(css) {
    var html = '<div class="col ' + css + '" style="visibility:hidden;">';
    html += '<div class="middle-x"></div>';
    html += '<div class="flagText middle-x"></div>';
    html += '</div>';
    return html;
}

function bindTippingList(itemList) {
    if (itemList.length > 0) {
        var html = getTippingListHtml(itemList);
        $('#holder').html(html);
        $('#broadcast').show();

        mGiftCount = itemList.length;

        setTimeout(autoScrollGiftList, 1000);
    }
}

function getTippingListHtml(itemList) {
    var html = '';
    $(itemList).each(function (index, item) {
        html += '<li id="gift' + index + '"><a href="#" target="_blank" class="text-white">' + item + '</a></li>';
    })
    html += '<li id="giftLast' + '"><a href="#" target="_blank" class="text-white">' + itemList[0] + '</a></li>';
    return html;
}

function bindTopShopList(topShopList) {
    fillArrayOneRow(topShopList, 3);

    var html = getTopShopHeaderHtml();
    for (var i = 0; i < topShopList.length; i += 3) {
        html += getTopShopImageRowHtml(topShopList, i);
        html += getTopShopNameRowHtml(topShopList, i);
    }
    $('#topShopList').html(html);
}

function getTopShopHeaderHtml() {
    var html = '<div style="border-left:0.15rem solid #DD0101; padding:0 0 0 0.25rem;" class="ub">';
    if (CONFIG_IS_DEBUG) {
        html += '<div style="color:#DD0101;" class="font-weight-bold ub-f1" onclick="goBack();">人气财富排行榜x</div>';
    } else {
        html += '<div style="color:#DD0101;" class="font-weight-bold ub-f1">人气财富排行榜</div>';
    }
    html += '<div onclick="goRankPage();">查看更多 <i class="fas fa-chevron-right"></i></div>';
    html += '</div>';
    return html;
}

function getTopShopImageRowHtml(topShopList, startIndex) {
    var html = '<div class="row mt-2">';
    for (var i = startIndex; i < startIndex + 3; i++) {
        var topShop = topShopList[i];
        html += getTopShopImageHtml(topShop, (i + 1));
    }
    html += '</div>';
    return html;
}

function getTopShopNameRowHtml(topShopList, startIndex) {
    var html = '<div class="row mt-1">';
    for (var i = startIndex; i < startIndex + 3; i++) {
        var topShop = topShopList[i];
        html += getTopShopTitleHtml(topShop);
    }
    html += '</div>';
    return html;
}

function getTopShopTitleHtml(topShop) {
    if (topShop == null) {
        return getEmptyTopShopTitleHtml();
    }
    var html = '<div class="col px-0 flagText text-center ellipsis" onclick="goCompanyPage(' + topShop.id + '); ">';
    html += topShop.name;
    html += '</div>';
    return html;
}

function getTopShopImageHtml(topShop, sequence) {
    if (topShop == null) {
        return getEmptyTopShopImageHtml();
    }
    var html = '<div class="col" onclick="goCompanyPage(' + topShop.id + '); ">';
    html += '<div class="middle-x">';
    if (sequence <= 3) {
        html += '<img src="img/flag-' + sequence + '.png" style="width:15px;height:22px;" class="" />';
        html += '<img src="' + topShop.cover + '" class="rounded flagRank" />';
    } else {
        html += '<img src="img/flag-' + sequence + '.png" style="width:15px;height:22px;visibility: hidden;" class="" />';
        html += '<img src="' + topShop.cover + '" class="rounded flagRank" />';
    }
    html += '</div>';
    html += '</div>';
    return html;
}

function getEmptyTopShopTitleHtml() {
    var html = '<div class="col px-0 flagText text-center ellipsis">';
    html += '</div>';
    return html;
}

function getEmptyTopShopImageHtml() {
    var html = '<div class="col">';
    html += '</div>';
    return html;
}

function bindLatestCarList(carList) {
    var html = getCarListHtml(carList, true);
    $('#carList').html(html);
}

function getCarListHtml(carList, isHomePage) {
    var html = '';
    $(carList).each(function (index, item) {
        html += getCarHtml(index, item, isHomePage);
    });
    return html;
}

function getCarHtml(index, item, isHomePage) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="chooseCar(' + item.id + ');">';

    html += '<div class="ml-2 thumb divBackground rounded" style="background-image: url(' + item.imgs[0] + ')"></div>';
    html += '<div class="col ellipsis" style="display:flex;flex-direction:column;justify-content:space-between;height:5rem;">' + getCarDetailsHtml(item, isHomePage) + '</div>';

    html += '</div>';
    return html;
}

function chooseCar(carId) {
    openWinWithCache("carDetails", CONST_CACHE_CAR_ID, carId);
}

function getCarDetailsHtml(item, isHomePage) {
    var html = '<div class="carName ellipsis">' + item.vehicle_brand + ' ' + item.vehicle_name + '</div>';
    if (isHomePage == false) {
        var level = getRankLevel(item.vip_level);
        if (level != null) {
            html += '<div class="carDate">' + level + '</div>';
        }
    }
    html += '<div class="carPrice">价格: ¥' + getPriceText(item.price) + '</div>';
    html += '<div class="carDate">上牌时间：' + item.first_license_date + '</div>';
    return html;
}

function goPostList(index) {
    var category = mPostCategoryList[index];
    setCache(CONST_CACHE_POST_CATEGORY_NAME, category.name);

    var data = {
        city_id: mCityId
    };
    data.id = category.id;
    setObjectCache(CONST_CACHE_POST_LOCATION_DATA, data);
    openWin('post_list')
}

function chooseCity(cityIndex) {
    var city = mCityObject.getCity(cityIndex);
    var cityName = city.city_name;
    if (mLastPageIndex == 0) {
        mCityId = city.id;
        mDistrict = null;
        $('#homeCity').html(cityName);
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != city.id) {
            mSearchCityId = city.id;
            mDistrictSearchPage = null;
            $('#searchCity').html(cityName);
            bindBusListApi();
        }
    }
    hideCityPage();
}

function chooseWholeCountry() {
    if (mLastPageIndex == 0) {
        mCityId = 0;
        mDistrict = null;
        $('#homeCity').html('全国');
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != 0) {
            mSearchCityId = 0;
            mDistrictSearchPage = null;
            $('#searchCity').html('全国');
            bindBusListApi();
        }
    }
    hideCityPage();
}

function openDebugPage() {
    if (CONFIG_IS_TEST) {
        if (mUser == null) {
            openWin('debug');
        }
    }
}

function closeDebugPage() {
    if (CONFIG_IS_TEST) {
        closePage();
    }
}

function goBaPin() {
    openUserPage('home', '', 'bapin_buy');
    event.stopPropagation();
}

function goNearByBusList() {
    openWin('nearby_bus_list');
}

function suggestion() {
    goUserPageUserPage('feedback');
}

function viewAdminPost(typeId) {
    openWinWithCache("admin_post_list", CONST_CACHE_ADMIN_POST_TYPE_ID, typeId);
}

function searchBadCarList(situationId) {
    var currentLocation = {
        cityId: mCityId,
        district: mDistrict,
        cityName: $('#homeCity').html()
    };

    setObjectCache(CONST_CACHE_LOCATION_BAD_CAR_OBJECT, currentLocation);
    openWinWithCache('filter_car_list', CONST_CACHE_CAR_SITUATION_ID, situationId);
}

function goRankPage() {
    openWinWithCache('companyRankList', CONST_CACHE_CITY_ID, mCityId);
}

function clearLog() {
    $('#logs').html('');
}

//functions for search page
function bindPageSearchPage() {
    mLoadBusListInterval = setInterval(tryBindBusList, 500);
    bindCarBrandListApi();
    populateYearList();
    populatePriceList();
}

function tryBindBusList() {
    if (mPagesStatus[1] == true) {
        if (mLocationObject.isInitialized()) {
            clearInterval(mLoadBusListInterval);
            bindBusListApi();
        }
    }
}

function bindBusListApi() {
    var data = getBusListApiData();
    jAjaxGet('/shopItem/list', data, function (json) {
        mSearchBusList = json.list;
        bindBusList();
    });
}

function getBusListApiData() {
    var data = {
        city_id: mSearchCityId
    };
    if (mDistrictSearchPage != null) {
        data.district = mDistrictSearchPage;
    }
    if (mSearchCarCategoryIndex != null) {
        data.vehicle_category = mSearchCarCategoryList[mSearchCarCategoryIndex].key;
    }
    data.vehicle_brand = mSearchCarBrandName;
    var carName = $('#carName').val();
    if (carName) {
        data.name = carName;
    }
    if (mSearchYearIndex != null) {
        data.year_range = getYearRange();
    }
    data.price_range = getPriceRange();
    data.vehicle_situation = mSituationId;
    return data;
}

function getYearRange() {
    var year = mSearchYearList[mSearchYearIndex];
    var max = (year.max) ? year.max : '';
    return year.min + '-' + max;
}

function getPriceRange() {
    var min = mSearchMinPrice ? mSearchMinPrice : 0;
    var max = (mSearchMaxPrice) ? mSearchMaxPrice : '';
    return min + '-' + max;
}

function bindBusList() {
    var html = getCarListHtml(mSearchBusList, false);
    $('#searchCarList').html(html);
}

function bindCarBrandListApi() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mSearchCarBrandList = json.list;
    });
}

function populateYearList() {
    mSearchYearList = [
        {
            min: 0,
            max: 1,
            text:'一年内'
        },
        {
            min: 1,
            max: 2,
            text: '1~2年'
        },
        {
            min: 2,
            max: 3,
            text: '2~3年'
        },
        {
            min: 3,
            max: 5,
            text: '3~5年'
        },
        {
            min: 5,
            max: null,
            text: '5年以上'
        }
    ];
}

function populatePriceList() {
    mSearchPriceList = [
        {
            min: 0,
            max: 5,
            text: '5万以下'
        },
        {
            min: 5,
            max: 10,
            text: '5~10万'
        },
        {
            min: 10,
            max: 15,
            text: '10~15万'
        },
        {
            min: 15,
            max: 20,
            text: '15~20万'
        },
        {
            min: 20,
            max: 50,
            text: '20~50万'
        },
        {
            min: 50,
            max: null,
            text: '50万以上'
        }
    ];
}

function showCategoryList() {
    if (canOpenFilter(0)) {
        var html = getCategoryListHtml();
        showFilterBody(html, false);

        mFilterDisplayIndex = 0;
        $('#searchFooter').hide();
        event.stopPropagation();
    }
}

function showFilterBody(html, isPrice) {
    $('#filterBody').html(html);
    if (isPrice) {
        $('#priceSlider').removeClass('d-none');
    } else {
        $('#priceSlider').addClass('d-none');
    }
    $('#filter').show();
}

function canOpenFilter(index) {
    if (mFilterDisplayIndex == -1) {
        return true;
    }
    return (mFilterDisplayIndex != index);
}

function showBrandList() {
    showBrandPage(true);
    mFilterDisplayIndex = 1;
    $('#searchPage').removeClass('ub').css('display', 'none');
    event.stopPropagation();
}

function showBrandPage(hasAllOption) {
    if (hasAllOption) {
        $('#allCarOption').show();
    } else {
        $('#allCarOption').hide();
    }
    showPage('#carBrandPage');
}

function getCategoryListHtml() {
    var html = getSearchCaregoryHtml(-1, '不限');
    $(mSearchCarCategoryList).each(function (index, item) {
        html += getSearchCaregoryHtml(index, item.label);
    });
    return html;
}

function getSearchCaregoryHtml(index, label) {
    var html = '<div class="row border-top p-2">';
    if (index >= 0) {
        html += '<div class="col" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + label + '</div>';
    } else {
        html += '<div class="col" onclick="resetCarCategory();">' + label + '</div>';
    }

    html += '</div>';
    return html;
}

function resetCarCategory() {
    mSearchCarCategoryIndex = null;
    $('#filterType').html('类型');
    bindBusListApi();
}

function chooseCarCategory(index) {
    mSearchCarCategoryIndex = index;
    $('#filterType').html(mSearchCarCategoryList[index].label);
    bindBusListApi();
}

function resetCarBrand() {
    $('#filterBrand').html('品牌');
    mSearchCarBrandName = '';
    bindBusListApi();
    if (mLastPageIndex == 1) {
        $('#searchPage').addClass('ub').css('display', 'block');
        emptyFilters();
    }
    hidePage('#carBrandPage');
}

function showYearList() {
    if (canOpenFilter(2)) {
        var html = getYearListHtml();
        showFilterBody(html, false);
        mFilterDisplayIndex = 2;
        $('#searchFooter').hide();
        event.stopPropagation();
    }
}

function getYearListHtml() {
    var html = '<div class="row border-top p-2"><div class="col" onclick="resetCarYear();">不限</div></div>';
    $(mSearchYearList).each(function (index, item) {
        html += getYearHtml(index, item);
    });
    return html;
}

function resetCarYear() {
    mSearchYearIndex = null;
    $('#filterAge').html('车龄');
    bindBusListApi();
}

function getYearHtml(index, item) {
    var html = '<div class="row border-top p-2">'
    html += '<div class="col" onclick="chooseYear(' + index + ');">' + item.text + '</div>';
    html += '</div>'
    return html;
}

function chooseYear(index) {
    mSearchYearIndex = index;
    var name = mSearchYearList[index].text;
    $('#filterAge').html(name);
    bindBusListApi();
}

function showPriceList() {
    if (canOpenFilter(3)) {
        var html = getPriceListHtml();
        showFilterBody(html, true);

        mFilterDisplayIndex = 3;
        $('#searchFooter').hide();
        event.stopPropagation();
    }
}

function getPriceListHtml() {
    var html = getPriceHtml(-1, '不限');
    $(mSearchPriceList).each(function (index, item) {
        html += getPriceHtml(index, item.text);
    });
    return html;
}

function getPriceHtml(index, text) {
    var html = '<div class="row border-top p-2">'
    if (index == -1) {
        html += '<div class="col" onclick="resetCarPrice();">' + text + '</div>';
    } else {
        html += '<div class="col" onclick="choosePrice(' + index + ');">' + text + '</div>';
    }
    html += '</div>'
    return html;
}

function resetCarPrice() {
    mSearchMinPrice = null;
    mSearchMaxPrice = null;
    showFilterPrice();
    bindBusListApi();
}

function choosePrice(index) {
    var price = mSearchPriceList[index];
    mSearchMinPrice = price.min;
    mSearchMaxPrice = price.max;

    showFilterPrice();
    bindBusListApi();
}

function showFilterPrice() {
    var name = '';
    if (mSearchMinPrice == null || mSearchMinPrice == 0) {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = '价格';
        } else {
            name = mSearchMaxPrice + '万以下';
        }
    } else {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = mSearchMinPrice + '万以上';
        } else {
            name = mSearchMinPrice + '-' + mSearchMaxPrice + '万';
        }
    }
    $('#filterPrice').html(name);
}

function chooseMinPrice(current) {
    current.value=Math.min(current.value,current.parentNode.childNodes[5].value - 1);
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.left=value*100/60+'%';
    children[7].style.left=value*100/60+'%';
    mMinPrice = value;
    mSearchMinPrice = value;
    showPriceRange();
}

function chooseMaxPrice(current) {
    current.value=Math.max(current.value,current.parentNode.childNodes[3].value - (-1));
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.right=(100-value*100/60)+'%';
    children[9].style.left=value*100/60+'%';
    mMaxPrice = value;
    mSearchMaxPrice = value;
    showPriceRange();
}

function showPriceRange() {
    if (mMaxPrice == 60) {
        mSearchMaxPrice = null;
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    } else {
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    }

    showSliderPrice();
    showFilterPrice();
}

function showSliderPrice() {
    var name = '';
    if (mSearchMinPrice) {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMinPrice) + '-' + getPriceText(mSearchMaxPrice);
        } else {
            name = getPriceText(mSearchMinPrice) + '以上';
        }
    } else {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMaxPrice) + '以下';
        } else {
            name = '价格不限';
        }
    }
    $('#priceRange').html(name);
}

function getPriceText(wan) {
    return wan + '万元';
}

function emptyFilters() {
    $('#filterBody').html('');
    $('#filter').hide();
    $('#searchFooter').show();
    $('#priceSlider').addClass('d-none');
    mFilterDisplayIndex = -1;
    bindBusListApi();
}

//functions for post page
function bindCategoryListPostPage() {
    var html = getCategoryListHtmlPostPage();
    $('#categoryListPostPage').html(html);
}

function getCategoryListHtmlPostPage() {
    var html = '';
    $(mCategoryListPostPage).each(function (index, item) {
        html += getCategoryItemHtmlPostPage(index, item);
    });
    return html;
}

function getCategoryItemHtmlPostPage(index, item) {
    return '<div class="border-top p-2" onclick="chooseCategoryPostPage(' + index + ');">' + item.label + '</div>';
}

function chooseCategoryPostPage(index) {
    mCategoryIndexPostPage = index;
    bindCategoryItemPostPage(index);
}

function bindCategoryItemPostPage(index) {
    $('#carCategoryPostPage').removeClass('t-gra');
    $('#carCategoryPostPage').html(mCategoryListPostPage[index].label);

    closeModal();
}

function bindCategoryPostPage(categoryId) {
    if (categoryId == -1) {
        $('#carCategoryPostPage').addClass('t-gra').html('请填写分类板块');
        return;
    }
    for (var i = 0; i < mCategoryListPostPage.length; i++) {
        var category = mCategoryListPostPage[i];
        if (category.key == categoryId) {
            mCategoryIndexPostPage = i;
            $('#carCategoryPostPage').html(category.label);
        }
    }
}

function takePhotoPostPage() {
    mTakePhotoOnPostPage = true;
    openModal('#chooseImageOrPhotoPage');
}

function takePhoto() {
    closeModal();
    if (isH5NotSupported()) {
        return;
    }
    if (mUser == null) {
        goLogin('home', 'takePhoto();', null);
        return;
    }
    if (mTakePhotoOnPostPage) {
        if (mPostPhotoList.length >= CONFIG_MAX_POST_PHOTOS) {
            showToast('最多' + CONFIG_MAX_POST_PHOTOS + '张照片');
            return;
        }
    } else {
        if (mCarPhotoList.length >= CONFIG_MAX_CAR_PHOTOS) {
            showToast('最多' + CONFIG_MAX_CAR_PHOTOS + '张照片');
            return;
        }
    }

    uexCamera.open(0, 50, function (imgPath) {
        uploadPhoto(imgPath);
    });
}

function chooseImage() {
    closeModal();

    if (isH5NotSupported()) {
        return;
    }
    if (mUser == null) {
        goLogin('home', 'chooseImage();', null);
        return;
    }

    var max = null;
    if (mTakePhotoOnPostPage) {
        max = CONFIG_MAX_POST_PHOTOS - mPostPhotoList.length;
        if (max <= 0) {
            showToast('最多' + CONFIG_MAX_POST_PHOTOS + '张照片');
            return;
        }
    } else {
        max = CONFIG_MAX_CAR_PHOTOS - mCarPhotoList.length;
        if (max <= 0) {
            showToast('最多' + CONFIG_MAX_CAR_PHOTOS + '张照片');
            return;
        }
    }

    var param={
        min:1,
        max:max,
        quality:0.4, //压缩质量
        style:1
    }
    uexImage.openPicker(param, function (error, info) {
        if (error == -1) {
            //cancelled
        } else if (error == 0) {
            mChoseImageList = info.data;
            mUploadingImageIndex = 0;

            uploadChoseImageList();
        } else {
            //error
        }
    })
}

function uploadPhoto(imgPath) {
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
        if (mTakePhotoOnPostPage) {
            mPostPhotoList.push(uploadedUrl);
            bindCarPhotoListPostPage();
        } else {
            mCarPhotoList.push(uploadedUrl);
            bindCarPhotoListCarPage();
        }
    });
}

function bindCarPhotoListPostPage() {
    var html = '<div class="bg-white pb-2 px-2" style="width:100%;">';
    html += '<div class="mb-2">*上传车辆照片：</div>';
    $(mPostPhotoList).each(function (index, item) {
        html += getCarPhotoHtmlPostPage(index, item);
    });
    html += '<img src="img/take-photo.png" style="width:4rem;height:4rem;" class="ml-2" onclick="takePhotoPostPage();" />';
    html += '</div>';
    $('#carPhotoListPostPage').html(html);
}

function locateNowPostPage() {
    mLocationObject.bindCurrentLocation(function (json) {
        mPostLocation = json;
        $('#formattedAddressPostPage').html('*车源的实际位置：' + mPostLocation.formattedAddress);
    })
}

function chooseMapAddress() {
    setCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_WIN_NAME, 'home');
    openWin('choose_address');
}

function chooseGaodeAddress() {
    var location = getObjectCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_OBJECT);
    if (mLastPageIndex == 2) {
        mPostLocation = location;
        $('#formattedAddressPostPage').html('*车源的实际位置：' + mPostLocation.formattedAddress);
    } else {
        mCarLocation = location;
        $('#formattedAddressCarPage').html('*车源的实际位置：' + mCarLocation.formattedAddress);
    }

}

function getCarPhotoHtmlPostPage(index, item) {
    var html = '<div style="position:relative;float:left;" class="mr-2">';
    html += '<img src="' + item + '" style="width:4rem;height:4rem;" class="mr-2" />';
    html += '<span class="alarm" onclick="removePhoto(' + index + ');">-</span>';
    html += '</div>';
    return html;
}

function removePhoto(index) {
    if (mLastPageIndex == 2) {
        mPostPhotoList.splice(index, 1);
        bindCarPhotoListPostPage();
    } else if (mLastPageIndex == 3) {
        mCarPhotoList.splice(index, 1);
        bindCarPhotoListCarPage();
    }
}

function postInformationPostPage() {
    var post = getPostData();

    var errMsg = getPostErrorMsgPostPage(post);
    if (errMsg != null) {
        showToast(errMsg);
        return;
    }

    appendUserId(post);
    jAjaxPostJsonContentType('/post/save', post, function (json) {
        showToast('您已发布成功');
        resetPostPage();
    })
}

function uploadPostPhoto() {
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, mPostPhotoList[mPostPhotoUploadIndex], function (uploadedUrl) {
        mPostPhotoUploadedUrlList.push(uploadedUrl);
        mPostPhotoUploadIndex++;

        if (mPostPhotoUploadIndex < mPostPhotoList.length) {
            uploadPostPhoto();
        } else {
            //upload successful
            finishLoading();
            postInformationPostPage();
        }
    });
}

function getPostData() {
    var post = {};
    post.category_id = (mCategoryIndexPostPage == -1) ? null : mCategoryListPostPage[mCategoryIndexPostPage].key;
    post.title = $.trim($('#titlePostPage').val());
    post.desc = $.trim($('#descriptionPostPage').val());
    post.contact_name = $.trim($('#publisherPostPage').val());
    post.contact_phone = $.trim($('#phonePostPage').val());
    post.location = mPostLocation;
    post.imgs = mPostPhotoList;
    return post;
}

function getPostErrorMsgPostPage(post) {
    if (post.category_id == null) {
        return '请选择分类板块';
    }
    if (post.title == '') {
        return '请输入标题';
    }
    if (post.desc == '') {
        return '请输入描述';
    }
    if (post.contact_name == '') {
        return '请输入您的昵称';
    }
    if (post.contact_phone == '') {
        return '请输入您的手机号';
    }
    if (isContactNumber(post.contact_phone) == false) {
        return '手机号输入无效，请检查';
    }
    if (post.location == null) {
        return '请定位您的位置';
    }
    if (post.imgs.length == 0) {
        return '请至少选择一张照片';
    }
    return null;
}

function resetPostPage() {
    mCategoryIndexPostPage = -1;
    $('#carCategoryPostPage').html('');
    $('#titlePostPage').val('');
    $('#descriptionPostPage').val('');
    $('#publisherPostPage').val('');
    $('#phonePostPage').val('');
    mPostPhotoList = [];
    mPostPhotoUploadedUrlList = [];
    bindCarPhotoListPostPage();
}

//functions for car page
function initPageCarPage() {
}

function bindPageCarPage() {
    locateNowCarPage();
    bindDataCarPage();
}

function getEmptyCarInfoCarPage() {
    return {
        vehicle_name: '',
        vehicle_category: null,
        vehicle_brand: '',
        first_license_date: '',
        inspection_date: '',
        insurance_end_date: '',
        violation_status: 0,
        use_kilometer: '',
        price: '',
        transfer_times: '',
        vehicle_type: null,
        vehicle_situation: null,
        vehicle_color: null,
        emission_type: null,
        remark: '',
        imgs: [],
        location: null
    };
}

function bindDataCarPage() {
    bindCarColorListCarPage();
}

function bindCarCategoryListCarPage() {
    var html = getCarCategoryListHtmlCarPage();
    $('#carCategoryListCarPage').html(html);
    chooseCarCategoryCarPage(0);
}

function getCarCategoryListHtmlCarPage() {
    var html = '';
    for (var i = 0; i < mCarCategoryListCarPage.length; i++) {
        var index = i;
        var item = mCarCategoryListCarPage[index];
        if (i == 0) {
            html += '<div class="col pink pr-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else if (i == mCarCategoryListCarPage.length - 1) {
            html += '<div class="col pink pl-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else {
            html += '<div class="col pink px-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        }
    }
    return html;
}

function chooseCarCategoryCarPage(index) {
    if (index == mCarCategoryIndexCarPage) {
        return;
    }

    $('#category' + mCarCategoryIndexCarPage).removeClass('text-white font-weight-bolder').addClass('pink');
    mCarCategoryIndexCarPage = index;
    $('#category' + mCarCategoryIndexCarPage).removeClass('pink').addClass('text-white font-weight-bolder');
}

function bindCarSubmissionTypeListCarPage() {
    var html = getCarSubmissionTypeListHtmlCarPage();
    $('#carSubmissionTypeListCarPage').html(html);
}

function getCarSubmissionTypeListHtmlCarPage() {
    var html = '';
    $(mCarSubmissionTypeListCarPage).each(function (index, item) {
        html += getCarSubmissionTypeItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarSubmissionTypeItemHtmlCarPage(index, item) {
    return '<div class="border-top p-2" onclick="chooseCarSubmissionTypeCarPage(' + index + ');">' + item.label + '</div>';
}

function chooseCarSubmissionTypeCarPage(index) {
    mCarSubmissionTypeIndexCarPage = index;
    bindCarSubmissionTypeItemCarPage(index);
}

function bindCarSubmissionTypeItemCarPage(index) {
    $('#carSubmissionTypeCarPage').removeClass('t-gra');
    $('#carSubmissionTypeCarPage').html(mCarSubmissionTypeListCarPage[index].label);

    closeModal();
}

//gear start
function bindCarGearBoxListCarPage() {
    var html = getCarGearBoxListHtmlCarPage();
    $('#carGearBoxListCarPage').html(html);
}

function getCarGearBoxListHtmlCarPage() {
    var html = '';
    $(mCarGearBoxListCarPage).each(function (index, item) {
        html += getCarGearBoxItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarGearBoxItemHtmlCarPage(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarGearBoxCarPage(' + index + ');">' + item + '</div>';
    return html;
}

function chooseCarGearBoxCarPage(index) {
    mCarGearBoxIndexCarPage = index;
    bindCarGearBoxItemCarPage(index);
}

function bindCarGearBoxItemCarPage(index) {
    $('#carGearBoxCarPage').removeClass('t-gra');
    $('#carGearBoxCarPage').html(mCarGearBoxListCarPage[index]);

    closeModal();
}
//gear end

function bindCarSituationListCarPage() {
    var html = getCarSituationListHtmlCarPage();
    $('#carSituationListCarPage').html(html);
}

function getCarSituationListHtmlCarPage() {
    var html = '';
    $(mCarSituationListCarPage).each(function (index, item) {
        html += getCarSituationItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarSituationItemHtmlCarPage(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarSituationCarPage(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarSituationCarPage(index) {
    mCarSituationIndexCarPage = index;
    bindCarSituationItemCarPage(index);
}

function bindCarSituationItemCarPage(index) {
    $('#carSituationCarPage').removeClass('t-gra');
    $('#carSituationCarPage').html(mCarSituationListCarPage[index].label);

    closeModal();
}

function bindCarBrandListApiCarPage() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mCarBrandListCarPage = json.list;
        bindCarBrandListCarPage();
    });
}

function bindCarBrandListCarPage() {
    var html = getCarBrandListHtmlCarPage();
    $('#carBrandList').html(html);

    html = getCarBrandLetterListHtmlCarPage();
    if (isIos()) {
        $('#carBrandLetters').css('top', '4.5rem');
    }
    $('#carBrandLetters').html(html);
}

function getCarBrandListHtmlCarPage() {
    var itemHtml = '<div id="allCarOption" class="border-bottom p-2" onclick="resetCarBrand();">不限</div>';
    $(mCarBrandListCarPage).each(function (index, item) {
        itemHtml += getCarBrandItemHtmlCarPage(index, item);
    });

    var html = '<div class="row">';
    html += '<div class="col mr-4">' + itemHtml + '</div>';
    html += '<div style="position: fixed;bottom:0px;right:0;">&nbsp;</div>';
    html += '</div>';

    return html;
}

function getCarBrandLetterListHtmlCarPage() {
    var letterHtml = '';
    $(mCarBrandListCarPage).each(function (index, item) {
        letterHtml += getLetterHtml(index);
    });

    return letterHtml;
}

function jumpToAnchor(index){
    var letter = mCarBrandListCarPage[index].letter;
    var url = 'home.html';               //Save down the URL without hash.
    location.href = "#brandLetter" + letter;                 //Go to the target element.
    history.replaceState(null,null,url);   //Don't like hashes. Changing it back.
}

function checkBrandAndOpenSeriesPage() {
    showPage('#carBrandSeriesPage');
    refreshCarSeriesListApi(mLastBrand);
}

function refreshCarSeriesListApi() {
    $('#carBrandSeriesList').html('');

    var data = {
        brand: mLastBrand
    };

    jAjaxGet('/vehicle/series', data, function (json) {
        mCarSeriesArray = json;
        bindCarSeriesList();
    })
}

function bindCarSeriesList() {
    var html = getCarSeriesListHtml();
    $('#carBrandSeriesList').html(html);
}

function getCarSeriesListHtml() {
    var html = '';
    $(mCarSeriesArray).each(function (index, item) {
        html += getCarSeriesHtml(index, item);
    });
    return html;
}

function getCarSeriesHtml(index, item) {
    var html = '<div class="middle-y border-bottom p-2" onclick="chooseCarSeries(' + index + ');">';
    html += item.series;
    html += '</div>';
    return html;
}

function chooseCarSeries(seriesIndex) {
    $('#carBrandSeriesPatternList').html('');
    showPage('#carPatternPage');

    mBrandSeriesIndex = seriesIndex;
    refreshCarPatternList();
}

function refreshCarPatternList() {
    var carSeries = mCarSeriesArray[mBrandSeriesIndex];
    var data = {
        brand: carSeries.brand,
        series: carSeries.series
    };
    jAjaxGet('/vehicle/names', data, function (json) {
        if (json.length == 0) {
            $('#brand_nameCarPage').val(carSeries.series);
            hidePage('#carBrandPage');
            hidePage('#carBrandSeriesPage');
            hidePage('#carPatternPage');
        } else {
            mCarPatternArray = json;
            bindCarPatternList();
        }
    })
}

function bindCarPatternList() {
    var html = getCarPatternListHtml();
    $('#carBrandSeriesPatternList').html(html);
}

function getCarPatternListHtml() {
    var html = '';
    $(mCarPatternArray).each(function (index, item) {
        html += getCarPatternHtml(index, item);
    });
    return html;
}

function getCarPatternHtml(index, item) {
    var html = '<div class="middle-y border-bottom p-2" onclick="chooseCarPattern(' + index + ');">';
    html += item;
    html += '</div>';
    return html;
}

function chooseCarPattern(index) {
    var carPattern = mCarPatternArray[index];

    $('#brand_nameCarPage').val(carPattern);

    hidePage('#carBrandPage');
    hidePage('#carBrandSeriesPage');
    hidePage('#carPatternPage');
}

function getLetterHtml(index) {
    var letter = mCarBrandListCarPage[index].letter;
    return '<div class="text-center px-1 ub-f1" style="color:#DC4F3F;" ontouchstart="jumpToAnchor(' + index + ');">' + letter + '</div>';
}

function getCarBrandItemHtmlCarPage(letterIndex, item) {
    if (item.itemList.length == 0) {
        return '';
    } else {
        var html = '<div class="invisible" id="brandLetter' + item.letter + '"></div>';
        $(item.itemList).each(function (index, brand) {
            html += '<div class="border-bottom p-2" onclick="chooseCarBrandCarPage(' + letterIndex + ',' + index + ');">' + brand + '</div>';
        });
        return html;
    }
}

function chooseCarBrandCarPage(letterIndex, index) {
    if (mLastPageIndex == 1) {
        mSearchCarBrandName = mCarBrandListCarPage[letterIndex].itemList[index];
        $('#filterBrand').html(mSearchCarBrandName);
        bindBusListApi();
        $('#searchPage').addClass('ub').css('display', 'block');
        emptyFilters();
        hidePage('#carBrandPage');
    } else if (mLastPageIndex == 3) {
        mCarBrandLetterIndexCarPage = letterIndex;
        mCarBrandLetterItemIndexCarPage = index;
        bindCarBrandItemCarPage();
    }
}

function bindCarBrandItemCarPage() {
    mLastBrand = mCarBrandListCarPage[mCarBrandLetterIndexCarPage].itemList[mCarBrandLetterItemIndexCarPage];
    checkBrandAndOpenSeriesPage();
}

function bindCarTypeListCarPage() {
    var html = getCarTypeListHtmlCarPage();
    $('#carTypeListCarPage').html(html);
}

function getCarTypeListHtmlCarPage() {
    var html = '';
    $(mCarTypeListCarPage).each(function (index, item) {
        html += getCarTypeItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarTypeItemHtmlCarPage(index, item) {
    return '<div class="border-top p-2" onclick="chooseCarTypeCarPage(' + index + ');">' + item.label + '</div>';
}

function chooseCarTypeCarPage(index) {
    mCarTypeIndexCarPage = index;
    bindCarTypeItemCarPage(index);
}

function bindCarTypeItemCarPage(index) {
    $('#carTypeCarPage').removeClass('t-gra');
    $('#carTypeCarPage').html(mCarTypeListCarPage[index].label);

    closeModal();
}

function bindCarColorListCarPage() {
    var html = getCarColorListHtmlCarPage();
    $('#carColorListCarPage').html(html);
}

function getCarColorListHtmlCarPage() {
    var html = '';
    $(mCarColorListCarPage).each(function (index, item) {
        html += getCarColorItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarColorItemHtmlCarPage(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarColorCarPage(' + index + ');">' + item + '</div>';
    return html;
}

function chooseCarColorCarPage(index) {
    mCarColorIndexCarPage = index;
    bindCarColorItemCarPage(index);
}

function checkIsShopOwner() {
    if (mUser != null) {
        var data = getUserIdObject();
        jAjaxGet('/user/profile', data, function (json) {
            refreshUserData(json);
            if (mUser.is_shop == 0) {
                showToast('请先到我的-我的店铺完善资料');
            }
        }, null, null, true);
    }
}

function bindCarColorItemCarPage(index) {
    $('#carColorCarPage').removeClass('t-gra');
    $('#carColorCarPage').html(mCarColorListCarPage[index]);

    closeModal();
}

function setViolationCarPage(isViolation) {
    if (mIsViolationCarPage == isViolation) {
        return;
    }
    mIsViolationCarPage = isViolation;
    if (mIsViolationCarPage) {
        $('#violation1CarPage').removeClass('far').addClass('t-red').addClass('fas');
        $('#violation0CarPage').removeClass('t-red').removeClass('fas').addClass('far');
        $('#rowViolationTimesCarPage').removeClass('d-none');
    } else {
        $('#violation0CarPage').removeClass('far').addClass('t-red').addClass('fas');
        $('#violation1CarPage').removeClass('t-red').removeClass('fas').addClass('far');
        $('#rowViolationTimesCarPage').addClass('d-none');
    }
}

function takePhotoCarPage() {
    /*if (mUser == null) {
        return null;
    }
    uexCamera.open(0, 50, function (imgPath) {
        mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
            mCarPhotoList.push(uploadedUrl);
            bindCarPhotoListCarPage();
        });
    })*/

    mTakePhotoOnPostPage = false;
    openModal('#chooseImageOrPhotoPage');
}

function bindCarPhotoListCarPage() {
    var html = '<div class="bg-white pb-2 px-2" style="width:100%;">';
    html += '<div class="mb-2">*上传车辆照片：</div>';
    $(mCarPhotoList).each(function (index, item) {
        html += getCarPhotoHtmlCarPage(index, item);
    });
    html += '<img src="img/take-photo.png" style="width:4rem;height:4rem;" onclick="takePhotoCarPage();" />';
    html += '</div>';
    $('#carPhotoListCarPage').html(html);
}

function locateNowCarPage() {
    mLocationObject.bindCurrentLocation(function (json) {
        mCarLocation = json;
        $('#formattedAddressCarPage').html('*车源的实际位置：' + mCarLocation.formattedAddress);
    });
}

function getCarPhotoHtmlCarPage(index, item) {
    var html = '<div style="position:relative;float:left;" class="mr-2">';
    html += '<img src="' + item + '" style="width:4rem;height:4rem;" class="mr-2" />';
    html += '<span class="alarm" onclick="removePhoto(' + index + ');">-</span>';
    html += '</div>';
    return html;
}

function getCarObject() {
    var car = { };
    car.vehicle_category = (mCarCategoryIndexCarPage == -1) ? null : mCarCategoryListCarPage[mCarCategoryIndexCarPage].key;
    car.vehicle_brand = $('#brand_nameCarPage').val();
    car.vehicle_name = $.trim($('#vehicle_nameCarPage').val());
    car.first_license_date = $('#first_license_dateCarPage').val();
    car.inspection_date = $('#inspection_dateCarPage').val();
    car.insurance_end_date = $('#insurance_end_dateCarPage').val();
    car.vehicle_situation = mCarSituationIndexCarPage == -1 ? null : mCarSituationListCarPage[mCarSituationIndexCarPage].key;
    car.violation_status = mIsViolationCarPage ? 1 : 0;
    if (mIsViolationCarPage) {
        car.violation_times = $('#violationTimesCarPage').val();
    }
    car.use_kilometer = $.trim($('#use_kilometerCarPage').val());
    car.price = $('#priceCarPage').val();
    car.transfer_times = $.trim($('#transfer_timesCarPage').val());
    car.vehicle_type = mCarTypeIndexCarPage == -1 ? '' : mCarTypeListCarPage[mCarTypeIndexCarPage].key;
    car.vehicle_color = mCarColorIndexCarPage == -1 ? '' : mCarColorListCarPage[mCarColorIndexCarPage];
    car.location = mCarLocation;
    car.emission_type = mCarSubmissionTypeIndexCarPage == -1 ? '' : mCarSubmissionTypeListCarPage[mCarSubmissionTypeIndexCarPage].key;
    car.gearbox = mCarGearBoxIndexCarPage == -1 ? '' : mCarGearBoxListCarPage[mCarGearBoxIndexCarPage];
    car.imgs = mCarPhotoList;
    car.remark = $.trim($('#remarkCarPage').val());
    return car;
}

function updateCarCarPage() {
    var car = getCarObject();
    var errMsg = getPostErrorMsgCarPage(car);
    if (errMsg != null) {
        showToast(errMsg);
        return;
    }
    appendUserId(car);
    jAjaxPostJsonContentType('/shopItem/save', car, function (json) {
        showToast('您的批车已发布成功');
        resetCarPage();
    })
}

function getPostErrorMsgCarPage(car) {
    if (car.vehicle_category == null) {
        return '请选择车辆类别';
    }
    if (car.vehicle_brand == '') {
        return '请输入车辆品牌';
    }
    if (car.vehicle_name == '') {
        return '请输入车辆款式';
    }
    if (car.first_license_date == '') {
        return '请输入首次上牌日期';
    }
    if (car.inspection_date == '') {
        return '请输入检车日期';
    }
    if (car.insurance_end_date == '') {
        return '请输入保险到期日期';
    }
    var checkMsg = null;
    if (car.violation_status == 1) {
        checkMsg = isIntMessage('违章次数', car.violation_times, 1);
        if (checkMsg != null) {
            return checkMsg;
        }
    }
    if (car.use_kilometer != '') {
        checkMsg = isNumberMessage('真实公里数', car.use_kilometer, 0);
        if (checkMsg != null) {
            return checkMsg;
        }
    }

    checkMsg = isNumberMessage('批发价格', car.price, 0);
    if (checkMsg != null) {
        return checkMsg;
    }

    if (car.transfer_times != '') {
        checkMsg = isIntMessage('过户次数', car.transfer_times, 0);
        if (checkMsg != null) {
            return checkMsg;
        }
    }

    if (car.vehicle_situation == null) {
        return '请选择车辆状况';
    }
    if (car.location == null) {
        return '请定位你的车源实际位置';
    }

    if (car.imgs.length == 0) {
        return '请至少上传一张车辆照片';
    }
    return null;
}

function resetCarPage() {
    $('#category' + mCarCategoryIndexCarPage).removeClass('text-white').addClass('pink');
    mCarCategoryIndexCarPage = -1

    mCarBrandLetterIndexCarPage = -1;
    $('#brand_nameCarPage').val('');

    $('#vehicle_nameCarPage').val('');

    var today = getDateText(new Date());
    $('#first_license_dateCarPage').val(today);
    $('#inspection_dateCarPage').val(today);
    $('#insurance_end_dateCarPage').val(today);

    mCarSituationIndexCarPage = -1;
    resetListField('#carSituationCarPage', '请选择车辆状况');

    setViolationCarPage(false);
    $('#violationTimesCarPage').val('');

    $('#use_kilometerCarPage').val('');
    $('#priceCarPage').val('');
    $('#transfer_timesCarPage').val('');

    mCarTypeIndexCarPage = -1;
    resetListField('#carTypeCarPage', '请输入');

    mCarColorIndexCarPage = -1;
    resetListField('#carColorCarPage', '请输入');

    mCarSubmissionTypeIndexCarPage = -1;
    resetListField('#carSubmissionTypeCarPage', '请输入');

    mCarGearBoxIndexCarPage = -1;
    resetListField('#carGearBoxCarPage', '请输入');

    mCarPhotoList = [];
    bindCarPhotoListCarPage();

    $('#remarkCarPage').val('');
    chooseCarSituationCarPage(0);
}

//functions for user page
function refreshUserApi(isForce) {
    if (mUser != null || isForce) {
        var data = getUserIdObject();
        jAjaxGet('/user/profile', data, function (json) {
            refreshUserData(json);
        }, null, null, true);
    }
}

function refreshUserData(user) {
    var changed = false;
    if (mUser.account_money != user.account_money) {
        mUser.account_money = user.account_money;
        $('#balanceInfoUserPage').html('我的余额：' + mUser.account_money + '元');
        changed = true;
    }
    if (mUser.avatar != user.avatar) {
        mUser.avatar = user.avatar;
        $('#headImageUserPage').attr('src', mUser.avatar);
        changed = true;
    }
    if (mUser.gender != user.gender) {
        mUser.gender = user.gender;
        changed = true;
    }
    if (mUser.is_shop != user.is_shop) {
        mUser.is_shop = user.is_shop;
        changed = true;
    }
    if (mUser.is_vip != user.is_vip) {
        mUser.is_vip = user.is_vip;
        changed = true;
    }
    if (mUser.is_wechat != user.is_wechat) {
        mUser.is_wechat = user.is_wechat;
        changed = true;
    }
    if (mUser.name != user.name) {
        mUser.name = user.name;
        $('#userNameUserPage').html(mUser.name);
        changed = true;
    }

    if (mUser.vip_end_time != user.vip_end_time) {
        mUser.vip_end_time = user.vip_end_time;
        if (mUser.vip_end_time != null) {
            $('#vipStatus').html('会员到期日期：' + mUser.vip_end_time);
        } else {
            $('#vipStatus').html('当前非会员');
        }
        changed = true;
    }

    if (changed) {
        setUser(mUser);
    }
}

function bindPageUserPage() {
    bindDataUserPage();
}

function bindDataUserPage() {
    bindUserDataUserPage();
}

function bindUserDataUserPage() {
    if (mUser == null) {
        bindNotLoggedUserDataUserPage();
    } else {
        bindLoggedUserDataUserPage();
    }
}

function bindNotLoggedUserDataUserPage() {
    $('#balanceInfoUserPage').html('我的余额：0');
    $('#userNameUserPage').html('未登录用户');
    $('#headImageUserPage').attr('src', 'img/logo.png');
    $('#vipStatus').html('未登录');
}

function bindLoggedUserDataUserPage() {
    $('#balanceInfoUserPage').html('我的余额：' + mUser.account_money + '元');
    $('#userNameUserPage').html(mUser.name);
    $('#headImageUserPage').attr('src', mUser.avatar);
    if (mUser.vip_end_time) {
        $('#vipStatus').html('会员到期日期：' + mUser.vip_end_time);
    } else {
        $('#vipStatus').html('当前非会员');
    }
}

function goLoginForNotLoggedUserUserPage() {
    if (mUser == null) {
        goLogin();
    }
}

function bindCustomerServiceUserPage() {
    $('#qrcodeUserPage').attr('src', mCustomerServiceUserPage.qrcode);
    $('#btnCopyWechatUserPage').html('复制微信号 ' + mCustomerServiceUserPage.weixin);
}

function copyWechatUserPage() {
    if (isApp()) {
        uexClipboard.copy(mCustomerServiceUserPage.weixin);
    }

    hideCustomerServiceUserPage();
    showToast('微信号已复制');
}

function hideCustomerServiceUserPage() {
    mCustomerServiceDisplayed = false;
    closeModal();
}

function goUserPageUserPage(pageName) {
    openUserPage('home', 'bindUserDataUserPage();', pageName);
}

//other functions
function checkJPushAlias() {
    if (CONFIG_IS_TEST) {
        var text = getCache(CONST_JPUSH_SET);
        jLog(text);
    }
}

function closeCustomerServiceIfDisplayed() {
    if (mCustomerServiceDisplayed) {
        hideCustomerServiceUserPage();
    }
}

function autoScrollGiftList() {
    $('#gift0').animate({
            marginTop: ('-' + (1.5 * mGiftCount) + 'rem')
        },
        mGiftCount * 3000,
        function() {
            $('#gift0').css({  marginTop: "0rem" });
            autoScrollGiftList();
        }
    );
}

function testGift() {
    if (CONFIG_IS_DEBUG) {
        var data = {
            page: 'user_gift_list',
            img: 'https://ershouche.goozoe.com/storage/gifts/rbnWnQhlBMdc2sGvbtBo5xymZVg4qYWCqoV48VJP.png'
        };
        setObjectCache(CONST_CACHE_NOTIFICATION_EXTRAS_OBJECT, data);
        openWin(data.page);
    }
}

function showRemarkPage() {
    var content = $('#remarkCarPage').val();
    $('#remarkText').val(content);

    $('#remarkPage').addClass('ub').css('display', 'inline');
    var page = getPageNameByIndex(mLastPageIndex);
    var jqid = '#' + page;
    $(jqid).removeClass('ub').css('display', 'none');
}

function updateRemarkText() {
    var content = $('#remarkText').val();
    $('#remarkCarPage').val(content);

    hideRemarkPage();
}

function hideRemarkPage() {
    $('#remarkPage').removeClass('ub').css('display', 'none');
    var page = getPageNameByIndex(mLastPageIndex);
    var jqid = '#' + page;
    $(jqid).addClass('ub').css('display', 'inline');

    $(document).scrollTop($("#remarkCarPage").offset().top);
}

function bindBonuseEvents() {
    if (isApp()) {
        uexWindow.setBounce(1);
        //uexWindow.notifyBounceEvent(1, 1);
        uexWindow.notifyBounceEvent(0, 1);

        //var s = '{"imagePath":"","textColor":"#aaa","levelText":"","pullToReloadText":"上拉加载更多内容...","releaseToReloadText":"释放加载更多内容...","loadingText":"加载中，请稍等"}';
        //uexWindow.setBounceParams("1", s);
        //uexWindow.showBounceView("1", '#EAEAEA', '1');
        var b = '{"imagePath":"","textColor":"#aaa","levelText":"","pullToReloadText":"下拉刷新更多内容...","releaseToReloadText":"释放加载更多内容...","loadingText":"刷新中，请稍等"}';
        uexWindow.setBounceParams("0", b);
        uexWindow.showBounceView("0", '#EAEAEA', '1');

        uexWindow.onBounceStateChange = onBounceStateChange;
    }
}

function initRollDateControls() {
    var startYear = 1990;
    var endYear = new Date().getFullYear() + 10;
    new Rolldate({
        el: '#first_license_dateCarPage',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        init: function() {
            document.activeElement.blur();
        }
    })

    new Rolldate({
        el: '#inspection_dateCarPage',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        init: function() {
            document.activeElement.blur();
        }
    })

    new Rolldate({
        el: '#insurance_end_dateCarPage',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        init: function() {
            document.activeElement.blur();
        }
    })

    var today = getDateText(new Date());
    $('#first_license_dateCarPage').val(today);
    $('#inspection_dateCarPage').val(today);
    $('#insurance_end_dateCarPage').val(today);
}

function onBounceStateChange(type, state){
    switch(type) {
        case 0: //drag page downside
            if (state == 2) {
                uexWindow.resetBounceView("0");
                if (mLastPageIndex == 0) {
                    tryBindData();
                }
                if (mLastPageIndex == 1) {
                    bindBusListApi();
                }
            }
            break;
        case 1:
            if (state == 2) {
                uexWindow.resetBounceView("1");
            }
            break;
    }
}

function hideCityPage() {
    $('#cityPage').removeClass('ub').css('display', 'none');
    var page = getPageNameByIndex(mLastPageIndex);
    var jqid = '#' + page;
    $(jqid).addClass('ub').css('display', 'inline');
}

function showCityPage() {
    $('#cityPage').addClass('ub').css('display', 'inline');
    var page = getPageNameByIndex(mLastPageIndex);
    var jqid = '#' + page;
    $(jqid).removeClass('ub').css('display', 'none');
}

function closeBrandPage() {
    if (mLastPageIndex == 1) {
        $('#searchPage').addClass('ub').css('display', 'block');
    }
    hidePage('#carBrandPage');
}

function pressEnterToSearchSource() {
    if (event.keyCode==13) { //回车键的键值为13
        document.activeElement.blur();
        searchSource();
    }
}