var mLeftSeconds = 0;
var mWechatRegistered = false;
var mAgreementChecked = false;
var mAgreement = null;
var mAgreementIndex = null;

function initPage() {
    if (CONFIG_IS_DEBUG) {
        $('#phone').val('13175000056');
        $('#password').val('325604zz');
    }

    if (isAndroid()) {
        var params = {
            windowName:"login"
        };
        uexWeiXin.setCallbackWindowName(JSON.stringify(params));
    }
}

function bindPage() {
	bindData();
}

function bindData() {
    if (isApp()) {
        appcan.window.evaluateScript('home', 'refreshUser();');
    }
}

function setAgreement() {
    jAjaxGet('/agreement', null, function (json) {
        mAgreement = json;
        showAgreementPage();
    });
}

function showAgreement(index) {
    mAgreementIndex = index;
    if (mAgreement == null) {
        setAgreement();
    } else {
        showAgreementPage();
    }
}

function showAgreementPage() {
    var text = getAgreementText();
    $('#agreementText').html(text);

    var title = getAgreementTitle();
    $('#agreementTitle').html(title);
    showPage('#agreementPage');

}

function getAgreementText() {
    switch (mAgreementIndex) {
        case 0:
            return mAgreement.usage_agreement;
        case 1:
            return mAgreement.privacy_agreement;
        default:
            return '';
    }
}

function getAgreementTitle() {
    switch (mAgreementIndex) {
        case 0:
            return '《琦亿车用户服务协议》';
        case 1:
            return '《用户隐私协议》';
        default:
            return '';
    }
}

function onLogin() {
    var phone = $.trim($("#phone").val());
    var password = $('#password').val();
    if (isFormValid(phone, password) == false) {
        return;
    }

    var data = {
        phone: phone,
        password: password
    };

    jAjaxPost('/login', data, function (json) {
        logonSuccess(json);
    });
}

function isFormValid(phone, password) {
    if (mAgreementChecked == false) {
        showToast('您还未同意并签署《琦亿车用户服务协议》《用户隐私协议》');
        return false;
    }
    if (phone == '') {
        showToast("请输入手机号码");
        return false;
    }
    if (isPhoneNumber(phone) == false) {
        showToast("手机号码输入无效");
        return false;
    }
    if (password == '') {
        showToast('请输入密码');
        return false;
    }
    if (password.length < 8) {
        showToast('密码长度至少为8位');
        return false;
    }
    if (password.length > 16) {
        showToast('密码长度最多为16位');
        return false;
    }
    return true;
}

function closeOrderListAndGoBack() {
    if (isApp()) {
        var page = getCache(CONST_LOGIN_TARGET_PAGE);
        if (page == 'orderList') {
            appcan.window.evaluateScript("orderList", 'goBack();');
        }
    }
    appcan.window.close(5, 100);
}

function wechatLogin() {
    if (mAgreementChecked == false) {
        showToast('您还未同意并签署《琦亿车用户服务协议》《用户隐私协议》');
        return false;
    }

    if (mWechatRegistered == false) {
        // var installed = uexWeiXin.isWXAppInstalled();
        // if (installed == false) {
        //     showToast('您还未安装微信');
        //     return;
        // }

        var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0', 'https://noahsoft.site/app/');
        if (info != 0) {
            showToast('微信授权失败');
            return;
        }
        mWechatRegistered = true;
    }

    var requestJson = {
        scope: 'snsapi_base,snsapi_userinfo',
        state:'0901'
    }
    uexWeiXin.login(JSON.stringify(requestJson), function (json) {
        if (json.state == '0901') {
            checkWechatLogin(json.code);
        }
    });
}

function checkWechatLogin(code) {
    var data = {
        code: code
    };
    jAjaxGet('/wechatAuth', data, function (json) {
        if (json == null) {
            setCache(CONST_CACHE_WECHAT_CODE, code);
            openWin('register');
        } else {
            showToast('登录成功');

            logonSuccess(json);
        }
    });
}

function toggleAgreement() {
    mAgreementChecked = !mAgreementChecked;
    if (mAgreementChecked) {
        $('#agreement').removeClass('far').addClass('fas');
    } else {
        $('#agreement').removeClass('fas').addClass('far');
    }
}

function logonSuccess(json) {
    setUser(json);
    trySetJpush(json.id);

    if (isApp()) {
        appcan.window.evaluateScript('home', 'refreshUser();');

        var loginObject = getObjectCache(CONST_CACHE_LOGIN_OBJECT);

        if (loginObject != null) {
            if (loginObject.fromPage && loginObject.fromPageFunction) {
                appcan.window.evaluateScript(loginObject.fromPage, loginObject.fromPageFunction);
            }
            if (loginObject.goPage) {
                var companyID = getCache(CONST_CACHE_COMPANY_ID);
                if (companyID) {
                    setCache(CONST_CACHE_COMPANY_ID, companyID);
                }
                setTimeout(goBack, 500);
                openWin(loginObject.goPage);
                return;
            }
        }
    }
    goBack();
}