//fields for whole page
var mLastPageIndex = 0;
var mPagesStatus = [true, false, false, false, false];
var mUser = null;
var mCityObject = CityClass.createNew('#cityBlock');
var mLocationObject = LocationClass.createNew();
var mFileUploader = null;
var mCustomerServiceDisplayed = false;
var mModalID = null;
var mTakePhotoOnPostPage = null;
var mChoseImageList = null;
var mUploadingImageIndex = null;
var mNoticeCount = 0;

//fields for home page
var mCityId = 1;
var mLoadDataInterval = null;
var mDistrict = null;
var mSituationId = 0;
var mVipShopBackgroundImage = null;
var mHotShopBackgroundImage = null;
var mBannerList = null;
var mGiftCount = 0;
var mSwiper = null;
var mPostCategoryList = null;

//fields for search page
var mLoadBusListInterval = null;
var mSearchCityId = 0;
var mSearchCurrentCity = null;
var mDistrictSearchPage = null;
var mSearchBusList = null;
var mSearchCarCategoryList = null;
var mSearchCarBrandList = null;
var mSearchCarCategoryIndex = null;
var mSearchYearList = null;
var mSearchYearIndex = null;
var mSearchPriceList = null;
var mSearchMinPrice = null;
var mSearchMaxPrice = null;
var mFilterDisplayIndex = -1;   //-1 means no filter is displayed, while 0, 1, 2 and 3 for category, brand, year and price filter is displayed
var mMinPrice = 0;
var mMaxPrice = 60;

//fields for post page
var mCategoryListPostPage = null;
var mCategoryIndexPostPage = -1;
var mPostIdPostPage = null;
var mPostLocation = null;
var mPostPhotoList = [];

//fields for car page
var mCarCategoryListCarPage = null;
var mCarBrandListCarPage = null;
var mSearchCarBrandName = '';
var mCarTypeListCarPage = null;
var mCarCategoryIndexCarPage = -1;
var mCarBrandLetterIndexCarPage = -1;
var mCarBrandLetterItemIndexCarPage = -1;
var mCarTypeIndexCarPage = -1;
var mCarColorIndexCarPage = -1;
var mIsViolationCarPage = false;
var mLocationCarPage = null;
var mCarSubmissionTypeListCarPage = null;
var mCarSubmissionTypeIndexCarPage = -1;
var mCarSituationListCarPage = null;
var mCarSituationIndexCarPage = -1;
var mCarGearBoxListCarPage = null;
var mCarGearBoxIndexCarPage = -1;
var mCarLocation = null;
var mCarPhotoList = [];
var mCarPhotoUploadedUrlList = [];
var mCarSeriesArray = [];
var mCarPatternArray = [];
var mLastBrand = null;
var mBrandSeriesIndex = null;

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
}

function closeModal() {
    if (mModalID == null) {
        return;
    }
    $(mModalID).hide();
    hideLayer();

    handleOtherModals();
    mModalID = null;
}

function handleOtherModals() {
    switch (mModalID) {
        case "#customerServiceUserPage":
            mCustomerServiceDisplayed = true;
            break;
        default:
            break;
    }
}

//fields for user page
var mCustomerServiceUserPage = null;

function initPage() {
    mUser = getUser();
    mLoadDataInterval = setInterval(tryBindData, 1000);

    populateYearList();
    populatePriceList();
}

function bindPage() {
    bindData();

    bindCarBrandListApiCarPage();
}

function tryBindData() {
    if (mCityObject.isInitialized() && mLocationObject.isInitialized()) {
        clearInterval(mLoadDataInterval);
        var location = mLocationObject.getCurrentLocation();
        if (location == null) {
            mCityId = 0;
            mSearchCityId = 0;
            mDistrict = '';
            mDistrictSearchPage = '';
            $('#searchCity').html('全国');
            mCityObject.locateCurrentCityFailed();
        } else {
            mCityId = mCityObject.getCityIdByCityName(location.addressComponent.city);
            mSearchCityId = mCityId;
            if (mCityId != 0) {
                mDistrict = location.addressComponent.district;
                if (mDistrict) {
                    $('#homeCity').html(mDistrict);

                    mDistrictSearchPage = mDistrict;
                    $('#searchCity').html(mDistrictSearchPage);
                } else {
                    $('#homeCity').html(location.addressComponent.city);
                    $('#searchCity').html(location.addressComponent.city);
                }
                mCityObject.locateCurrentCity(mCityId);
            } else {
                $('#homeCity').html('全国');
                $('#searchCity').html('全国');
                mCityObject.locateCurrentCityFailed();
            }
        }
        bindHomePageDataApi();
    }
}

function bindHomePageDataApi() {
    bindBusListApi();
}

function locateCity() {
    var currentCityName = $('#currentCity').html();
    if (currentCityName != '定位中...') {
        var location = mLocationObject.bindCurrentLocation(function (location) {
            mCityObject.changeCurrentCity(location.addressComponent.city);
            console.dir(location);
        }, true);
    }
}

function chooseCityById(cityId) {
    console.dir(cityId)
    var city = mCityObject.getCityByCityId(cityId);
    console.dir(city)
    var cityName = city.city_name;
    if (mLastPageIndex == 0) {
        mCityId = city.id;
        $('#homeCity').html(cityName);
        mDistrict = null;
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != city.id) {
            mSearchCityId = city.id;
            mDistrictSearchPage = null;
            $('#searchCity').html(cityName);
            bindBusListApi();
        }
    }
    hidePage('#cityPage');
}

function bindData() {
    bindPublicData();
    try {
        mCityObject.loadCityApi();
        mLocationObject.bindCurrentLocation();
    } catch( err) {
        jLog(err)
    }
}

function searchSource() {
    var sourceKeywords = $.trim($('#sourceKeywords').val());
    if (sourceKeywords == '') {
        showToast('请输入搜索关键词');
        return;
    }
    var criteria = {
        name: sourceKeywords,
        cityId: mCityId,
        district: mDistrict
    };
    var cityName = $('#homeCity').html();
    if (mCityId == 0 || mCityId == null) {
        criteria.cityName = '全国';
        criteria.cityId = 0;
    } else {
        if (cityName != criteria.district) {
            criteria.cityName = cityName;
        }
    }
    setObjectCache(CONST_CACHE_SEARCH_BUS_OBJECT, criteria);

    openWin("search_car_list");
}

function bindPublicData() {
    jAjaxGet('/public/config', null, function (json) {
        if (json.guarantee_text) {
            setCache(CONST_CACHE_GUARANTEE_NOTICE, $.trim(json.guarantee_text));
            setCache(CONST_CACHE_PLATFORM_400_TELEPHONE, json.contact_phone);
            setCache(CONST_CACHE_SHARE_TEXT, json.share_text);
        }
        mHotShopBackgroundImage = json.hot_vehicle_bg;
        mVipShopBackgroundImage = json.vip_shop_bg;

        //bind search page
        mSearchCarCategoryList = json.vehicle_categories;
    });
}

function resetListField(jqid, placeholder) {
    $(jqid).addClass('t-gra').html(placeholder);
}

//functions for home page
function chooseCity(cityIndex) {
    var city = mCityObject.getCity(cityIndex);
    var cityName = city.city_name;
    if (mLastPageIndex == 0) {
        mCityId = city.id;
        mDistrict = null;
        $('#homeCity').html(cityName);
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != city.id) {
            mSearchCityId = city.id;
            mDistrictSearchPage = null;
            $('#searchCity').html(cityName);
            bindBusListApi();
        }
    }
    hidePage('#cityPage');
}

function chooseWholeCountry() {
    if (mLastPageIndex == 0) {
        mCityId = 0;
        mDistrict = null;
        $('#homeCity').html('全国');
        bindHomePageDataApi();
    } else {
        if (mSearchCityId != 0) {
            mSearchCityId = 0;
            mDistrictSearchPage = null;
            $('#searchCity').html('全国');
            bindBusListApi();
        }
    }
    hidePage('#cityPage');
}

function openDebugPage() {
    if (CONFIG_IS_TEST) {
        if (mUser == null) {
            openWin('debug');
        }
    }
}

function closeDebugPage() {
    if (CONFIG_IS_TEST) {
        closePage();
    }
}

function goBaPin() {
    openUserPage('home', '', 'bapin_buy');
    event.stopPropagation();
}

function suggestion() {
    goUserPageUserPage('feedback');
}

function viewAdminPost(typeId) {
    openWinWithCache("admin_post_list", CONST_CACHE_ADMIN_POST_TYPE_ID, typeId);
}

function searchBadCarList(situationId) {
    openWinWithCache('filter_car_list', CONST_CACHE_CAR_SITUATION_ID, situationId);
}

function goRankPage() {
    openWinWithCache('companyRankList', CONST_CACHE_CITY_ID, mCityId);
}

function clearLog() {
    $('#logs').html('');
}

//functions for search page
function bindPageSearchPage() {
    mLoadBusListInterval = setInterval(tryBindBusList, 500);
    bindCarBrandListApi();
    populateYearList();
    populatePriceList();
}

function tryBindBusList() {
    if (mPagesStatus[1] == true) {
        if (mLocationObject.isInitialized()) {
            clearInterval(mLoadBusListInterval);
            bindBusListApi();
        }
    }
}

function bindBusListApi() {
    var location = mLocationObject.getCurrentLocation().location;
    var data = getBusListApiData(location);


    console.dir(data);
    jAjaxGet('/shopItem/nearby', data, function (json) {
        mSearchBusList = json.list;
        console.log(json.list);
        bindBusList();
    });
}

function getBusListApiData(location) {
    var data = {
        city_id: mSearchCityId
    };
    if (mDistrictSearchPage != null) {
        data.district = mDistrictSearchPage;
    }
    if (mSearchCarCategoryIndex != null) {
        data.vehicle_category = mSearchCarCategoryList[mSearchCarCategoryIndex].key;
    }

    data.vehicle_brand = mSearchCarBrandName;
    var carName = $('#carName').val();
    if (carName) {
        data.name = carName;
    }
    if (mSearchYearIndex != null) {
        data.year_range = getYearRange();
    }
    data.price_range = getPriceRange();
    data.vehicle_situation = mSituationId;
    data.lng = location.lng;
    data.lat = location.lat;
    return data;
}

function getYearRange() {
    var year = mSearchYearList[mSearchYearIndex];
    var max = (year.max) ? year.max : '';
    return year.min + '-' + max;
}

function getPriceRange() {
    var min = mSearchMinPrice ? mSearchMinPrice : 0;
    var max = (mSearchMaxPrice) ? mSearchMaxPrice : '';
    return min + '-' + max;
}

function bindBusList() {
    var html = getCarListHtml(mSearchBusList);
    $('#searchCarList').html(html);
}

function getCarListHtml(carList) {
    var html = '';
    $(carList).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="chooseCar(' + item.id + ');">';

    html += '<div class="ml-2 thumb divBackground rounded" style="background-image: url(' + item.imgs[0] + ')"></div>';
    html += '<div class="col ellipsis" style="display:flex;flex-direction:column;justify-content:space-between;height:5rem;">' + getCarDetailsHtml(item) + '</div>';

    html += '</div>';
    return html;
}

function chooseCar(carId) {
    openWinWithCache("carDetails", CONST_CACHE_CAR_ID, carId);
}

function getCarDetailsHtml(item) {
    var html = '<div class="carName ellipsis">' + item.vehicle_name + '</div>';

    html += '<div class="container-fluid">';
    html += '<div class="row">';
    html += '<div class="carPrice col pl-0">价格: ¥' + getPriceText(item.price) + '</div>';
    html += '<div>' + item.distance + 'km</div>';
    html += '</div>';
    html += '</div>';

    html += '<div class="carDate">上牌时间：' + item.first_license_date + '</div>';
    return html;
}


function bindCarBrandListApi() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mSearchCarBrandList = json.list;
    });
}

function populateYearList() {
    mSearchYearList = [
        {
            min: 0,
            max: 1,
            text:'一年内'
        },
        {
            min: 1,
            max: 2,
            text: '1~2年'
        },
        {
            min: 2,
            max: 3,
            text: '2~3年'
        },
        {
            min: 3,
            max: 5,
            text: '3~5年'
        },
        {
            min: 5,
            max: null,
            text: '5年以上'
        }
    ];
}

function populatePriceList() {
    mSearchPriceList = [
        {
            min: 0,
            max: 5,
            text: '5万以下'
        },
        {
            min: 5,
            max: 10,
            text: '5~10万'
        },
        {
            min: 10,
            max: 15,
            text: '10~15万'
        },
        {
            min: 15,
            max: 20,
            text: '15~20万'
        },
        {
            min: 20,
            max: 50,
            text: '20~50万'
        },
        {
            min: 50,
            max: null,
            text: '50万以上'
        }
    ];
}

function showCategoryList() {
    if (canOpenFilter(0)) {
        var html = getCategoryListHtml();
        showFilterBody(html, false);

        mFilterDisplayIndex = 0;
        event.stopPropagation();
    }
}

function showFilterBody(html, isPrice) {
    $('#filterBody').html(html);
    if (isPrice) {
        $('#priceSlider').removeClass('d-none');
    } else {
        $('#priceSlider').addClass('d-none');
    }
    $('#filter').show();
}

function canOpenFilter(index) {
    if (mFilterDisplayIndex == -1) {
        return true;
    }
    return (mFilterDisplayIndex != index);
}

function showBrandList() {
    showBrandPage(true);
    mFilterDisplayIndex = 1;
    event.stopPropagation();
}

function showBrandPage(hasAllOption) {
    if (hasAllOption) {
        $('#allCarOption').show();
    } else {
        $('#allCarOption').hide();
    }
    showPage('#carBrandPage');
}

function getCategoryListHtml() {
    var html = getSearchCaregoryHtml(-1, '不限');
    $(mSearchCarCategoryList).each(function (index, item) {
        html += getSearchCaregoryHtml(index, item.label);
    });
    return html;
}

function getSearchCaregoryHtml(index, label) {
    var html = '<div class="row border-top p-2">';
    if (index >= 0) {
        html += '<div class="col" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + label + '</div>';
    } else {
        html += '<div class="col" onclick="resetCarCategory();">' + label + '</div>';
    }

    html += '</div>';
    return html;
}

function resetCarCategory() {
    mSearchCarCategoryIndex = null;
    $('#filterType').html('类型');
    bindBusListApi();
}

function chooseCarCategory(index) {
    mSearchCarCategoryIndex = index;
    $('#filterType').html(mSearchCarCategoryList[index].label);
    bindBusListApi();
}

function resetCarBrand() {
    $('#filterBrand').html('品牌');
    mSearchCarBrandName = '';
    bindBusListApi();
    hidePage('#carBrandPage');
}

function showYearList() {
    if (canOpenFilter(2)) {
        var html = getYearListHtml();
        showFilterBody(html, false);
        mFilterDisplayIndex = 2;
        event.stopPropagation();
    }
}

function getYearListHtml() {
    var html = '<div class="row border-top p-2"><div class="col" onclick="resetCarYear();">不限</div></div>';
    $(mSearchYearList).each(function (index, item) {
        html += getYearHtml(index, item);
    });
    return html;
}

function resetCarYear() {
    mSearchYearIndex = null;
    $('#filterAge').html('车龄');
    bindBusListApi();
}

function getYearHtml(index, item) {
    var html = '<div class="row border-top p-2">'
    html += '<div class="col" onclick="chooseYear(' + index + ');">' + item.text + '</div>';
    html += '</div>'
    return html;
}

function chooseYear(index) {
    mSearchYearIndex = index;
    var name = mSearchYearList[index].text;
    $('#filterAge').html(name);
    bindBusListApi();
}

function showPriceList() {
    if (canOpenFilter(3)) {
        var html = getPriceListHtml();
        showFilterBody(html, true);

        mFilterDisplayIndex = 3;
        event.stopPropagation();
    }
}

function getPriceListHtml() {
    var html = getPriceHtml(-1, '不限');
    $(mSearchPriceList).each(function (index, item) {
        html += getPriceHtml(index, item.text);
    });
    return html;
}

function getPriceHtml(index, text) {
    var html = '<div class="row border-top p-2">'
    if (index == -1) {
        html += '<div class="col" onclick="resetCarPrice();">' + text + '</div>';
    } else {
        html += '<div class="col" onclick="choosePrice(' + index + ');">' + text + '</div>';
    }
    html += '</div>'
    return html;
}

function resetCarPrice() {
    mSearchMinPrice = null;
    mSearchMaxPrice = null;
    showFilterPrice();
    bindBusListApi();
}

function choosePrice(index) {
    var price = mSearchPriceList[index];
    mSearchMinPrice = price.min;
    mSearchMaxPrice = price.max;

    showFilterPrice();
    bindBusListApi();
}

function showFilterPrice() {
    var name = '';
    if (mSearchMinPrice == null || mSearchMinPrice == 0) {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = '价格';
        } else {
            name = mSearchMaxPrice + '万以下';
        }
    } else {
        if (mSearchMaxPrice == null || mSearchMaxPrice == 60) {
            name = mSearchMinPrice + '万以上';
        } else {
            name = mSearchMinPrice + '-' + mSearchMaxPrice + '万';
        }
    }
    $('#filterPrice').html(name);
}

function chooseMinPrice(current) {
    current.value=Math.min(current.value,current.parentNode.childNodes[5].value - 1);
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.left=value*100/60+'%';
    children[7].style.left=value*100/60+'%';
    mMinPrice = value;
    mSearchMinPrice = value;
    showPriceRange();
}

function chooseMaxPrice(current) {
    current.value=Math.max(current.value,current.parentNode.childNodes[3].value - (-1));
    var value=(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.value)-(60/(parseInt(current.max)-parseInt(current.min)))*parseInt(current.min);
    var children = current.parentNode.childNodes[1].childNodes;
    children[5].style.right=(100-value*100/60)+'%';
    children[9].style.left=value*100/60+'%';
    mMaxPrice = value;
    mSearchMaxPrice = value;
    showPriceRange();
}

function showPriceRange() {
    if (mMaxPrice == 60) {
        mSearchMaxPrice = null;
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    } else {
        if (mMinPrice == 0) {
            mSearchMinPrice = null;
        } else {
            mSearchMinPrice = mMinPrice;
        }
    }

    showSliderPrice();
    showFilterPrice();
}

function showSliderPrice() {
    var name = '';
    if (mSearchMinPrice) {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMinPrice) + '-' + getPriceText(mSearchMaxPrice);
        } else {
            name = getPriceText(mSearchMinPrice) + '以上';
        }
    } else {
        if (mSearchMaxPrice) {
            name = getPriceText(mSearchMaxPrice) + '以下';
        } else {
            name = '价格不限';
        }
    }
    $('#priceRange').html(name);
}

function getPriceText(wan) {
    return wan + '万元';
}

function emptyFilters() {
    $('#filterBody').html('');
    $('#filter').hide();
    $('#priceSlider').addClass('d-none');
    mFilterDisplayIndex = -1;
    bindBusListApi();
}

//functions for post page
function bindCategoryListPostPage() {
    var html = getCategoryListHtmlPostPage();
    $('#categoryListPostPage').html(html);
}

function getCategoryListHtmlPostPage() {
    var html = '';
    $(mCategoryListPostPage).each(function (index, item) {
        html += getCategoryItemHtmlPostPage(index, item);
    });
    return html;
}

function getCategoryItemHtmlPostPage(index, item) {
    return '<div class="border-top p-2" onclick="chooseCategoryPostPage(' + index + ');">' + item.label + '</div>';
}

function chooseCategoryPostPage(index) {
    mCategoryIndexPostPage = index;
    bindCategoryItemPostPage(index);
}

function bindCategoryItemPostPage(index) {
    $('#carCategoryPostPage').removeClass('t-gra');
    $('#carCategoryPostPage').html(mCategoryListPostPage[index].label);

    closeModal();
}

function bindCategoryPostPage(categoryId) {
    if (categoryId == -1) {
        $('#carCategoryPostPage').addClass('t-gra').html('请填写分类板块');
        return;
    }
    for (var i = 0; i < mCategoryListPostPage.length; i++) {
        var category = mCategoryListPostPage[i];
        if (category.key == categoryId) {
            mCategoryIndexPostPage = i;
            $('#carCategoryPostPage').html(category.label);
        }
    }
}

function takePhotoPostPage() {
    mTakePhotoOnPostPage = true;
    openModal('#chooseImageOrPhotoPage');
}

function takePhoto() {
    closeModal();
    if (isH5NotSupported()) {
        return;
    }
    if (mUser == null) {
        goLogin('home', 'takePhoto();', null);
        return;
    }
    if (mTakePhotoOnPostPage) {
        if (mPostPhotoList.length >= 20) {
            showToast('最多20张照片');
            return;
        }
    } else {
        if (mCarPhotoList.length >= 20) {
            showToast('最多20张照片');
            return;
        }
    }

    uexCamera.open(0, 50, function (imgPath) {
        uploadPhoto(imgPath);
    });
}

function chooseImage() {
    closeModal();

    if (isH5NotSupported()) {
        return;
    }
    if (mUser == null) {
        goLogin('home', 'chooseImage();', null);
        return;
    }

    var max = null;
    if (mTakePhotoOnPostPage) {
        max = 20 - mPostPhotoList.length;

    } else {
        max = 20 - mCarPhotoList.length;
    }
    if (max <= 0) {
        showToast('最多20张照片');
        return;
    }
    if (max > 9) {
        max = 9;
    }
    var param={
        min:1,
        max:max,
        quality:0.4, //压缩质量
        style:1
    }
    uexImage.openPicker(JSON.stringify(param))
}

function uploadPhoto(imgPath) {
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
        if (mTakePhotoOnPostPage) {
            mPostPhotoList.push(uploadedUrl);
            bindCarPhotoListPostPage();
        } else {
            mCarPhotoList.push(uploadedUrl);
            bindCarPhotoListCarPage();
        }
    });
}

function bindCarPhotoListPostPage() {
    var html = '<div class="bg-white pb-2 px-2" style="width:100%;">';
    html += '<div class="mb-2">*上传车辆照片：</div>';
    $(mPostPhotoList).each(function (index, item) {
        html += getCarPhotoHtmlPostPage(index, item);
    });
    html += '<img src="img/take-photo.png" style="width:4rem;height:4rem;" class="ml-2" onclick="takePhotoPostPage();" />';
    html += '</div>';
    $('#carPhotoListPostPage').html(html);
}

function locateNowPostPage() {
    mLocationObject.bindCurrentLocation(function (json) {
        mPostLocation = json;
        $('#formattedAddressPostPage').html('*车源的实际位置：' + mPostLocation.formattedAddress);
    })
}

function chooseMapAddress() {
    setCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_WIN_NAME, 'home');
    openWin('choose_address');
}

function chooseGaodeAddress() {
    var location = getObjectCache(CONST_CACHE_CHOOSE_GAODE_LOCATION_OBJECT);
    if (mLastPageIndex == 2) {
        mPostLocation = location;
        $('#formattedAddressPostPage').html('*车源的实际位置：' + mPostLocation.formattedAddress);
    } else {
        mCarLocation = location;
        $('#formattedAddressCarPage').html('*车源的实际位置：' + mCarLocation.formattedAddress);
    }

}

function getCarPhotoHtmlPostPage(index, item) {
    var html = '<div style="position:relative;float:left;" class="mr-2">';
    html += '<img src="' + item + '" style="width:4rem;height:4rem;" class="mr-2" />';
    html += '<span class="alarm" onclick="removePhoto(' + index + ');">-</span>';
    html += '</div>';
    return html;
}

function removePhoto(index) {
    if (mLastPageIndex == 2) {
        mPostPhotoList.splice(index, 1);
        bindCarPhotoListPostPage();
    } else if (mLastPageIndex == 3) {
        mCarPhotoList.splice(index, 1);
        bindCarPhotoListCarPage();
    }
}

function postInformationPostPage() {
    var post = getPostData();

    var errMsg = getPostErrorMsgPostPage(post);
    if (errMsg != null) {
        showToast(errMsg);
        return;
    }

    appendUserId(post);
    jAjaxPostJsonContentType('/post/save', post, function (json) {
        showToast('您已发布成功');
        resetPostPage();
    })
}

function uploadPostPhoto() {
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, mPostPhotoList[mPostPhotoUploadIndex], function (uploadedUrl) {
        mPostPhotoUploadedUrlList.push(uploadedUrl);
        mPostPhotoUploadIndex++;

        if (mPostPhotoUploadIndex < mPostPhotoList.length) {
            uploadPostPhoto();
        } else {
            //upload successful
            finishLoading();
            postInformationPostPage();
        }
    });
}

function getPostData() {
    var post = {};
    post.category_id = (mCategoryIndexPostPage == -1) ? null : mCategoryListPostPage[mCategoryIndexPostPage].key;
    post.title = $.trim($('#titlePostPage').val());
    post.desc = $.trim($('#descriptionPostPage').val());
    post.contact_name = $.trim($('#publisherPostPage').val());
    post.contact_phone = $.trim($('#phonePostPage').val());
    post.location = mPostLocation;
    post.imgs = mPostPhotoList;
    return post;
}

function getPostErrorMsgPostPage(post) {
    if (post.category_id == null) {
        return '请选择分类板块';
    }
    if (post.title == '') {
        return '请输入标题';
    }
    if (post.desc == '') {
        return '请输入描述';
    }
    if (post.contact_name == '') {
        return '请输入您的昵称';
    }
    if (post.contact_phone == '') {
        return '请输入您的手机号';
    }
    if (isPhoneNumber(post.contact_phone) == false) {
        return '手机号输入无效，请检查';
    }
    if (post.location == null) {
        return '请定位您的位置';
    }
    if (post.imgs.length == 0) {
        return '请至少选择一张照片';
    }
    return null;
}

function resetPostPage() {
    mCategoryIndexPostPage = -1;
    $('#carCategoryPostPage').html('');
    $('#titlePostPage').val('');
    $('#descriptionPostPage').val('');
    $('#publisherPostPage').val('');
    $('#phonePostPage').val('');
    mPostPhotoList = [];
    mPostPhotoUploadedUrlList = [];
    bindCarPhotoListPostPage();
}

//functions for car page
function bindPageCarPage() {
    locateNowCarPage();
    bindDataCarPage();
}

function bindDataCarPage() {
    bindCarColorListCarPage();
}

function bindCarCategoryListCarPage() {
    var html = getCarCategoryListHtmlCarPage();
    $('#carCategoryListCarPage').html(html);
    chooseCarCategoryCarPage(0);
}

function getCarCategoryListHtmlCarPage() {
    var html = '';
    for (var i = 0; i < mCarCategoryListCarPage.length; i++) {
        var index = i;
        var item = mCarCategoryListCarPage[index];
        if (i == 0) {
            html += '<div class="col pink pr-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else if (i == mCarCategoryListCarPage.length - 1) {
            html += '<div class="col pink pl-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else {
            html += '<div class="col pink px-0" onclick="chooseCarCategoryCarPage(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        }
    }
    return html;
}

function chooseCarCategoryCarPage(index) {
    if (index == mCarCategoryIndexCarPage) {
        return;
    }

    $('#category' + mCarCategoryIndexCarPage).removeClass('text-white font-weight-bolder').addClass('pink');
    mCarCategoryIndexCarPage = index;
    $('#category' + mCarCategoryIndexCarPage).removeClass('pink').addClass('text-white font-weight-bolder');
}

function bindCarSubmissionTypeListCarPage() {
    var html = getCarSubmissionTypeListHtmlCarPage();
    $('#carSubmissionTypeListCarPage').html(html);
}

function getCarSubmissionTypeListHtmlCarPage() {
    var html = '';
    $(mCarSubmissionTypeListCarPage).each(function (index, item) {
        html += getCarSubmissionTypeItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarSubmissionTypeItemHtmlCarPage(index, item) {
    return '<div class="border-top p-2" onclick="chooseCarSubmissionTypeCarPage(' + index + ');">' + item.label + '</div>';
}

function chooseCarSubmissionTypeCarPage(index) {
    mCarSubmissionTypeIndexCarPage = index;
    bindCarSubmissionTypeItemCarPage(index);
}

function bindCarSubmissionTypeItemCarPage(index) {
    $('#carSubmissionTypeCarPage').removeClass('t-gra');
    $('#carSubmissionTypeCarPage').html(mCarSubmissionTypeListCarPage[index].label);

    closeModal();
}

//gear start
function bindCarGearBoxListCarPage() {
    var html = getCarGearBoxListHtmlCarPage();
    $('#carGearBoxListCarPage').html(html);
}

function getCarGearBoxListHtmlCarPage() {
    var html = '';
    $(mCarGearBoxListCarPage).each(function (index, item) {
        html += getCarGearBoxItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarGearBoxItemHtmlCarPage(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarGearBoxCarPage(' + index + ');">' + item + '</div>';
    return html;
}

function chooseCarGearBoxCarPage(index) {
    mCarGearBoxIndexCarPage = index;
    bindCarGearBoxItemCarPage(index);
}

function bindCarGearBoxItemCarPage(index) {
    $('#carGearBoxCarPage').removeClass('t-gra');
    $('#carGearBoxCarPage').html(mCarGearBoxListCarPage[index]);

    closeModal();
}
//gear end

function bindCarSituationListCarPage() {
    var html = getCarSituationListHtmlCarPage();
    $('#carSituationListCarPage').html(html);
}

function getCarSituationListHtmlCarPage() {
    var html = '';
    $(mCarSituationListCarPage).each(function (index, item) {
        html += getCarSituationItemHtmlCarPage(index, item);
    });
    return html;
}

function getCarSituationItemHtmlCarPage(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarSituationCarPage(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarSituationCarPage(index) {
    mCarSituationIndexCarPage = index;
    bindCarSituationItemCarPage(index);
}

function bindCarSituationItemCarPage(index) {
    $('#carSituationCarPage').removeClass('t-gra');
    $('#carSituationCarPage').html(mCarSituationListCarPage[index].label);

    closeModal();
}

function bindCarBrandListApiCarPage() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mCarBrandListCarPage = json.list;
        bindCarBrandListCarPage();
    });
}

function bindCarBrandListCarPage() {
    var html = getCarBrandListHtmlCarPage();
    $('#carBrandList').html(html);

    html = getCarBrandLetterListHtmlCarPage();
    if (isIos()) {
        $('#carBrandLetters').css('top', '4.5rem');
    }
    $('#carBrandLetters').html(html);
}

function getCarBrandListHtmlCarPage() {
    var itemHtml = '<div id="allCarOption" class="border-bottom p-2" onclick="resetCarBrand();">不限</div>';
    $(mCarBrandListCarPage).each(function (index, item) {
        itemHtml += getCarBrandItemHtmlCarPage(index, item);
    });

    var html = '<div class="row">';
    html += '<div class="col mr-4">' + itemHtml + '</div>';
    html += '<div style="position: fixed;bottom:0px;right:0;">&nbsp;</div>';
    html += '</div>';

    return html;
}

function getCarBrandItemHtmlCarPage(letterIndex, item) {
    if (item.itemList.length == 0) {
        return '';
    } else {
        var html = '<div class="invisible" id="brandLetter' + item.letter + '"></div>';
        $(item.itemList).each(function (index, brand) {
            html += '<div class="border-bottom p-2" onclick="chooseCarBrandCarPage(' + letterIndex + ',' + index + ');">' + brand + '</div>';
        });
        return html;
    }
}

function chooseCarBrandCarPage(letterIndex, index) {
    mSearchCarBrandName = mCarBrandListCarPage[letterIndex].itemList[index];
    $('#filterBrand').html(mSearchCarBrandName);
    bindBusListApi();
    hidePage('#carBrandPage');
}

function getLetterHtml(index) {
    var letter = mCarBrandListCarPage[index].letter;
    return '<div class="text-center px-1 ub-f1" style="color:#DC4F3F;" ontouchstart="jumpToAnchor(' + index + ');">' + letter + '</div>';
}

function jumpToAnchor(index){
    var letter = mCarBrandListCarPage[index].letter;
    var url = 'home.html';               //Save down the URL without hash.
    location.href = "#brandLetter" + letter;                 //Go to the target element.
    history.replaceState(null,null,url);   //Don't like hashes. Changing it back.
}

function getCarBrandLetterListHtmlCarPage() {
    var letterHtml = '';
    $(mCarBrandListCarPage).each(function (index, item) {
        letterHtml += getLetterHtml(index);
    });

    return letterHtml;
}
