var mPostId = null;
var mPost = null;
var mLocationObject = null;

function initPage() {
    mPostId = getCache(CONST_CACHE_POST_ID);
    removeCache(CONST_CACHE_POST_ID);
}

function bindPage() {
	bindData();
}

function bindData() {
    bindPostApi();
}

function bindPostApi() {
    var data = {
        id: mPostId
    };
    jAjaxGet('/post/detail', data, function (json) {
        mPost = json;
        bindBannerList();
        bindPostInfo();
    })
}

function bindBannerList() {
    bindBannerData();
    createSwiper();
}

function bindBannerData() {
    var html = getBannersCode();
    $('#banners').html(html);
}

function getBannersCode() {
    var html = '';
    $(mPost.imgs).each(function (index, item) {
        html += getBannerCode(item);
    });
    return html;
}

function getBannerCode(image) {
    var html = '';
    html += '<div class="swiper-slide">';
    html += '<img src="' + image + '" alt="" style="width:100%;height:12rem;">';
    html += '</div>';
    return html;
}

function createSwiper() {
    var swiper = new Swiper('.swiper-container', {
        spaceBetween: 0,
        centeredSlides: true,
        autoplay: {
            delay: 2500,
            disableOnInteraction: false,
        },
        pagination: {
            el: '.swiper-pagination',
            clickable: true,
        }
    });
}

function bindPostInfo() {
    $('#post_id').html(mPost.id);
    $('#contact_name').html(mPost.contact_name);
    $('#created_at').html(mPost.created_at);
    $('#address').html(mPost.address);
    $('#contact_phone').html(mPost.contact_phone);
    $('#desc').html(mPost.desc);
    var rankLevel = getRankLevel(mPost.vip_level);
    if (rankLevel != null) {
        $('#rankLevel').html(rankLevel);
    }
}

function navigate() {
    $('#navigationPage').show();
    $('.layer').css('display', 'block');
}

function navigateByGaode() {
    if (isIos()) {
        navigateByIosGaode();
    } else if (isAndroid()) {
        navigateByAndroidGaode();
    }
    closeLayer();
}

function navigateByIosGaode() {
    var poiname = mPost.location.formattedAddress;
    var lat = mPost.location.location.lat;
    var lng = mPost.location.location.lng;

    var appInfo = 'iosamap://navi?sourceApplication=pipiche&backScheme=iosamap&poiname=&lat=' + lat + '&lon=' + lng + '&dev=1&style=2';
    uexWidget.loadApp(appInfo,null,null);
}

function navigateByAndroidGaode() {
    var poiname = mPost.location.formattedAddress;
    var lat = mPost.location.location.lat;
    var lng = mPost.location.location.lng;
    var main = "android.intent.action.VIEW";
    var pkg = "com.autonavi.minimap";
    var add = '{"data":{"scheme":"androidamap://navi?sourceApplication=琦亿车&poiname=' + poiname + '&lat=' + lat + '&lon=' + lng + '&style=2&dev=0&package=com.autonavi.minimap"}}';
    uexWidget.startApp(1, main, add);
}

function navigateByBaidu() {
    if (isIos()) {
        navigateByIosBaidu();
    } else if (isAndroid()) {
        navigateByAndroidBaidu();
    }
    closeLayer();
}

function navigateByIosBaidu() {
    jLog('2')
    if (mPost == null) {
        showToast('数据加载中');
        return;
    }

    if (mLocationObject == null) {
        mLocationObject = LocationClass.createNew();
    }

    mLocationObject.bindCurrentLocation(function (currentLocation) {
        var params = {
            latitude:currentLocation.location.lat,
            longitude:currentLocation.location.lng,
            from:"gcj02",
            to:"bd09"
        };
        var data = uexLocation.convertLocation(JSON.stringify(params));
        var baiduLocation = JSON.parse(data);

        var appInfo = 'baidumap://map/direction';
        var verticleLineEncode = encodeURIComponent('|');
        appInfo += '?origin=latlng:' + baiduLocation.latitude + ',' + baiduLocation.longitude + verticleLineEncode + 'name:' + encodeURIComponent(currentLocation.formattedAddress);

        var poiname = mPost.location.formattedAddress;

        params = {
            latitude: mPost.location.location.lat,
            longitude: mPost.location.location.lng,
            from:"gcj02",
            to:"bd09"
        };
        data = uexLocation.convertLocation(JSON.stringify(params));
        baiduLocation = JSON.parse(data);

        appInfo += '&destination=latlng:' + baiduLocation.latitude + ',' + baiduLocation.longitude +  verticleLineEncode + 'name:' + encodeURIComponent(poiname);
        appInfo += '&mode=driving';

        uexWidget.loadApp(appInfo,null,null);
    })
}

function navigateByAndroidBaidu() {
    var poiname = mPost.location.formattedAddress;
    var lat = mPost.location.location.lat;
    var lng = mPost.location.location.lng;

    var main = "android.intent.action.VIEW";
    var add = '{"data":{"scheme":"bdapp://map/direction?destination=latlng:' + lat + ',' + lng + '|name:' + poiname + '&src=Infosys|PiPiChe#Intent;scheme=bdapp;package=com.baidu.BaiduMap;end"}}';
    uexWidget.startApp(1, main, add);
}

function closeLayer() {
    $('.layer').css('display', 'none');
    $('#navigationPage').hide();
}