var mPostList = [];
var mPostCategoryData = null;

var mXXXXPageNumber = 1;
var mXXXXLoading = false;
var mXXXXFullyLoaded = false;

function initPage() {
    var name = getCache(CONST_CACHE_POST_CATEGORY_NAME);
    $('#title').html(name);
    mPostCategoryData = getObjectCache(CONST_CACHE_POST_LOCATION_DATA);

    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mXXXXLoading == false) {
                if (mXXXXFullyLoaded == false) {
                    bindPostListApi();
                } else {
                    showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                }
            }
        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindPostListApi();
}

function bindPostListApi() {
    mXXXXLoading = true;

    var data = mPostCategoryData;
    if (data == null) {
        data = { };
    }
    data.page = mXXXXPageNumber++;
    jAjaxGet('/post/list', mPostCategoryData, function (json) {
        console.log(data.page, json.list.length)
        mPostList = mPostList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mXXXXFullyLoaded = true;
        }
        bindPostList();
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    })
}

function bindPostList() {
    var html = '';
    $(mPostList).each(function (index, item) {
        html += getPostHtml(index, item);
    });
    $('#carList').html(html);
}

function getPostHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2" onclick="choosePost(' + index + ');">';

    html += '<div class="pl-2"><img class="thumb" src="' + item.imgs[0] + '" /></div>';
    html += '<div class="col pr-0 ub-ver">' + getCarDetailsHtml(item) + '</div>';

    html += '</div>';
    return html;

}

function getCarDetailsHtml(item) {
    var html = '<div class="carName small mb-2">' + item.title + '</div>';
    html += '<div class="carAddress small mb-2">发布地址: ' + item.address + '</div>';
    var rankLevel = getRankLevel(item.vip_level);
    if (rankLevel == null) {
        html += '<div class="carAddress small mb-2">发布人: ' + item.contact_name + '</div>';
    } else {
        html += '<div class="carAddress small mb-2">发布人: ' + item.contact_name + ' ' + rankLevel + '</div>';
    }

    html += '<div class="carDate small">发布时间：' + item.updated_at + '</div>';
    return html;
}

function choosePost(index) {
    var post = mPostList[index];
    openWinWithCache('post_details', CONST_CACHE_POST_ID, post.id);
}