var mTabTitles = ['信息置顶', '车源置顶'];    //set titles of tabs
var mCodeList = null;
var mLastIndex = -1;

var mCarList = [];
var mInfoList = [];

var mInfoPageNumber = 1;
var mInfoLoading = false;
var mInfoFullyLoaded = false;

var mCarPageNumber = 1;
var mCarLoading = false;
var mCarFullyLoaded = false;

function initPage() {
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mLastIndex == 0) {
                if (mInfoLoading == false) {
                    if (mInfoFullyLoaded == false) {
                        bindTab1ResultCode();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            } else if (mLastIndex == 1) {
                if (mCarLoading == false) {
                    if (mCarFullyLoaded == false) {
                        bindTab2ResultCode();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            }
        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindTabTitles();
    chooseTab(0);
}

function bindTabTitles() {
    mCodeList = [];
    var html = '';
    $(mTabTitles).each(function (index, item) {
        html += '<div class="col text-center py-2" id="tab' + index + '" onclick="chooseTab(' + index + ');">' + item + '</div>';
        mCodeList.push(null);
    });
    $('#tabs').html(html);
}

function chooseTab(index) {
    if (index != mLastIndex) {
        $('#tab' + mLastIndex).removeClass('highlight');
        $('#tab' + index).addClass('highlight');
        mLastIndex = index;

        var html = mCodeList[index];
        if (html == null) {
            getTabResultCode();
        } else {
            bindTabData();
        }
    }
}

function getTabResultCode() {
    if (mCodeList[mLastIndex] == null) {
        fetchTabResultCode();
    } else {
        bindTabData();
    }
}

//user defined function according to the logic
function fetchTabResultCode() {
    if (mLastIndex == 0) {
        bindTab1ResultCode();
    } else {
        bindTab2ResultCode();
    }
}

function bindTab1ResultCode() {
    mInfoLoading = true;

    var data = getUserIdObject();
    data.page = mInfoPageNumber++;
    jAjaxGet('/user/postVipRecords', data, function (json) {
        console.log(data.page, json.list.length);
        mInfoList = mInfoList.concat(json.list);

        if (json.list.length < CONFIG_PAGE_SIZE) {
            mInfoFullyLoaded = true;
        }

        //get data by tab
        var html = getInfoListHtml(mInfoList);

        //keep below code after data has been returned, mostly through ajax
        mCodeList[mLastIndex] = html;
        bindTabData();
        mInfoLoading = false;
    }, function () {
        mInfoLoading = false;
    }, function () {
        mInfoLoading = false;
    })
}

function bindTab2ResultCode() {
    mCarLoading = true;

    var data = getUserIdObject();
    data.page = mCarPageNumber++;
    jAjaxGet('/user/shopItemVipRecords', data, function (json) {
        console.log(data.page, json.list.length);
        mCarList = mCarList.concat(json.list);

        if (json.list.length < CONFIG_PAGE_SIZE) {
            mCarFullyLoaded = true;
        }
        //get data by tab
        var html = getCarListHtml(mCarList);

        //keep below code after data has been returned, mostly through ajax
        mCodeList[mLastIndex] = html;
        bindTabData();
        mCarLoading = false;
    }, function () {
        mCarLoading = false;
    }, function () {
        mCarLoading = false;
    })
}

function bindTabData() {
    var code = mCodeList[mLastIndex];
    $('#dataList').html(code);
}

function getCarListHtml(carList) {
    if (carList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(carList).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '<div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">车源标题</div>';
    html += '<div class="col">' + item.vehicle_name + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">购买时间</div>';
    html += '<div class="col">' + item.paid_at + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">开始时间</div>';
    html += '<div class="col">' + item.vip_start_time + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">截止时间</div>';
    html += '<div class="col">' + item.vip_end_time + '</div>';
    html += '</div>';

    html += '<div class="row border-bottom middle-y p-2">';
    html += '<div class="label">置顶范围</div>';
    html += '<div class="col">' + getRankLevel(item.vip_level) + '</div>';
    html += '</div>';

    html += '</div>';
    return html;
}

function getInfoListHtml(infoList) {
    if (infoList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(infoList).each(function (index, item) {
        html += getInfoHtml(index, item);
    });
    return html;
}

function getInfoHtml(index, item) {
    var html = '<div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">信息标题</div>';
    html += '<div class="col">' + item.title + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">购买时间</div>';
    html += '<div class="col">' + item.paid_at + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">开始时间</div>';
    html += '<div class="col">' + item.vip_start_time + '</div>';
    html += '</div>';

    html += '<div class="row middle-y p-2">';
    html += '<div class="label">截止时间</div>';
    html += '<div class="col">' + item.vip_end_time + '</div>';
    html += '</div>';

    html += '<div class="row border-bottom middle-y p-2">';
    html += '<div class="label">置顶范围</div>';
    html += '<div class="col">' + getRankLevel(item.vip_level) + '</div>';
    html += '</div>';

    html += '</div>';
    return html;
}
