var mLeftSeconds = 0;
var mWaitingSeconds = 60;
var mWechatCode = null;

function initPage() {
    var code = getCache(CONST_CACHE_WECHAT_CODE);
    if (code) {
        mWechatCode = code;
        removeCache(CONST_CACHE_WECHAT_CODE);
    }

    if (isAndroid()) {
        var height = '15rem';
        $('#invitationCode').on('click', function () {
            $('#bottomMargin').css('height', height);
            event.stopPropagation();
            setTimeout(function(){
                $('#invitationCode')[0].scrollIntoView({behavior: "smooth", block: "end", inline: "nearest"});
            },400);
        });

        $('#password').on('click', function () {
            $('#bottomMargin').css('height', height);
            event.stopPropagation();
            setTimeout(function(){
                $('#password')[0].scrollIntoView({behavior: "smooth", block: "end", inline: "nearest"});
            },400);
        });

        $('#code').on('click', function () {
            $('#bottomMargin').css('height', height);
            event.stopPropagation();
            setTimeout(function(){
                $('#code')[0].scrollIntoView({behavior: "smooth", block: "end", inline: "nearest"});
            },400);
        });

        $('#phone').on('click', function () {
            $('#bottomMargin').css('height', height);
            event.stopPropagation();
            setTimeout(function(){
                $('#phone')[0].scrollIntoView({behavior: "smooth", block: "end", inline: "nearest"});
            },400);
        });
    }
}

function hideBottomMargin() {
    $('#bottomMargin').css('height', '0');
}

function bindPage() {
	bindData();
}

function bindData() {

}

function onSendCode() {
    if (mLeftSeconds == 0) {
        var phone = $.trim($("#phone").val());
        if (isPhoneNumber(phone) == false) {
            showToast("手机号码输入无效");
            return;
        }

        mLeftSeconds = mWaitingSeconds;
        var data = {
            phone: phone,
            type:1
        };

        jAjaxPost("/verifyCode", data, function (jsonData) {
                waitSendCodeOneMinute();
            }, function () {
                $('#codeBlock').css('color', '#F0BE1B');
            }, function () {
                mLeftSeconds = 0;
            }
        );
    }
}

function waitSendCodeOneMinute() {
    $('#codeBlock').css('color', '#ADADAD');
    $("#codeBlock").html(mLeftSeconds + "s");
    setTimeout("countdown();", 1000);
}

function countdown() {
    mLeftSeconds--;
    if (mLeftSeconds > 0) {
        $("#codeBlock").html(mLeftSeconds + "s");
        setTimeout("countdown();", 1000);
    } else {
        $("#codeBlock").html('获取验证码');
        $('#codeBlock').css('color', '#F0BE1B');
    }
}

function onLogin() {
    var phone = $.trim($("#phone").val());
    var code = $.trim($("#code").val());
    var password = $('#password').val();
    var invitationCode = $.trim($('#invitationCode').val());
    if (isFormValid(phone, code, password) == false) {
        return;
    }

    var data = {
        phone: phone,
        password: password,
        sms_code: code,
        invite_code: invitationCode
    };
    if (mWechatCode != null) {
        data.auth_code = mWechatCode;
    }
    jAjaxPost('/register', data, function (jsonData) {
        showToast('注册成功，将返回到登录页面');
        setTimeout(goBack, 1500);
    });
}

function isFormValid(phone, code, password) {
    if (phone == '') {
        showToast("请输入手机号码");
        return false;
    }
    if (isPhoneNumber(phone) == false) {
        showToast("手机号码输入无效");
        return false;
    }
    if (code == '') {
        showToast("请输入验证码")
        return false;
    }
    if (code.length != 4) {
        showToast("验证码长度有误");
        return false;
    }
    if (password == '') {
        showToast('请输入密码');
        return false;
    }
    if (password.length < 8) {
        showToast('密码长度至少为8位');
        return false;
    }
    if (password.length > 16) {
        showToast('密码长度最多为16位');
        return false;
    }
    return true;
}

function closeOrderListAndGoBack() {
    if (isApp()) {
        var page = getCache(CONST_LOGIN_TARGET_PAGE);
        if (page == 'orderList') {
            appcan.window.evaluateScript("orderList", 'goBack();');
        }
    }
    appcan.window.close(5, 100);
}
