var mWechatRegistered = false;
var mGiftList = null;
var mGiftIndex = null;
var mGiftAmount = 1;
var mCustomerService = null;
var mHasWalletPay = false;
var mBalance = null;
var mModalID = null;

function initPage() {
}

function bindPage() {
	bindData();
}

function bindData() {
    bindGiftListApi();
    bindBalanceInfo();
}

function bindGiftListApi() {
    var data = getUserIdObject();
    jAjaxGet('/product/tippingGift', data, function (json) {
        mGiftList = json.list;
        console.dir(mGiftList)
        bindGiftList();
    })
}

function bindGiftList() {
    var html = getGiftListHtml();
    $('#giftList').html(html);
}

function getGiftListHtml() {
    fillArrayOneRow(mGiftList, 4);

    var html = '';
    for (var i = 0; i < mGiftList.length; i += 4) {
        html += getGiftRowListHtml(i);
    }
    return html;
}

function getGiftRowListHtml(startIndex) {
    var html = '<div class="row mt-4">';
    html += getGiftHtml(startIndex);
    html += getGiftHtml(startIndex + 1);
    html += getGiftHtml(startIndex + 2);
    html += getGiftHtml(startIndex + 3);
    html += '</div>';
    return html;
}

function getGiftHtml(index) {
    var item = mGiftList[index];
    if (item == null) {
        return getEmptyGiftHtml();
    } else {
        return getGiftDataHtml(index, item);
    }
}

function getEmptyGiftHtml() {
    var html = '<div class="col mx-0 py-1 px-0">';
    html += '</div>';
    return html;
}

function getGiftDataHtml(index, item) {
    var html = '<div id="gift' + index + '" class="col text-center mx-0 py-1 px-0 text-secondary" onclick="chooseGift(' + index + ');">';
    html += '<img class="giftImage" src="' + item.extra.img + '" />';
    html += '<div>' + item.price + '元</div>';
    html += '<div class="small">' + item.name + '(人气' + item.extra.amount + ')</div>';
    html += '</div>';
    return html;
}

function chooseGift(index) {
    if (index == mGiftIndex) {
        return;
    }
    if (mGiftIndex != null) {
        $('#gift' + mGiftIndex).removeClass('text-danger border border-warning font-weight-bold').addClass('text-secondary');
    }
    mGiftIndex = index;
    $('#gift' + mGiftIndex).removeClass('text-secondary').addClass('text-danger border-danger font-weight-bold');

    if (mGiftAmount == 0) {
        updateEmptyGiftAmount();
    } else {
        updateGiftAmountAndprice();
    }
}

function bindBalanceInfo() {
    var data = getUserIdObject();
    jAjaxGet('/user/profile', data, function (json) {
        mBalance = json.account_money;
       $('#wallet').html('余额支付 (' + mBalance + '元)');
    });
}

function pay() {
    if (mGiftAmount == 0) {
        showToast('请输入礼物数量');
        return;
    }
    if (mGiftIndex == null) {
        showToast('请先选择礼物');
        return;
    }

    var gift = mGiftList[mGiftIndex];
    if ((mHasWalletPay == false) || gift.price > mBalance) {
        if (mWechatRegistered == false) {
            var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0', 'https://noahsoft.site/app/');
            if (info != 0) {
                showToast('微信授权失败');
                return;
            }
            mWechatRegistered = true;
        }

        var supportPay = uexWeiXin.isSupportPay();
        if (supportPay == false) {
            showToast('微信支付不支持');
            return;
        }
    }

    var remark = $.trim($('#remark').val());
    var use_account_money = mHasWalletPay ? 1 : 0;
    var data = {
        id: gift.id,
        shop_id: getCache(CONST_CACHE_COMPANY_ID),
        num: mGiftAmount,
        msg: remark,
        use_account_money: use_account_money
    };
    appendUserId(data);
    jAjaxPost('/product/tippingGift/buy', data, function (json) {
        payOrder(json, null, showGift);
    })
}

function showGift() {
    showGiftImage();
    showLayer();
    $('#carPage').show();
    if (isApp()) {
        var params = {
            playMode: 0
        }
        uexAudio.setPlayMode(params);

        var url = 'res://car.mp3';
        uexAudio.open(url);
        uexAudio.play(0);
    }
    setTimeout(closeGift, 2000);
}

function showGiftImage() {
    var imgUrl = mGiftList[mGiftIndex].extra.img;
    $('#giftImage').attr('src', imgUrl);
}

function closeGift() {
    hideLayer();
    $('#carPage').hide();

    goBack();
}

function showCustomerService() {
    if (mCustomerService == null) {
        showCustomerServiceApi();
    } else {
        showCustomerServicePanel();
    }
}

function showCustomerServiceApi() {
    jAjaxGet('/public/config', null, function (json) {
        mCustomerService = json.kefu;
        bindCustomerService();
        showCustomerServicePanel();
    });
}

function bindCustomerService() {
    $('#qrcode').attr('src', mCustomerService.qrcode);
    $('#btnCopyWechat').html('复制微信号 ' + mCustomerService.weixin);
}

function showCustomerServicePanel() {
    openModal('#customerService');
}

function copyWechat() {
    if (isApp()) {
        uexClipboard.copy(mCustomerService.weixin);
    }

    showToast('微信号已复制');
}

function chooseWallet() {
    if (mBalance != null && mBalance > 0) {
        mHasWalletPay = !mHasWalletPay;
        bindWalletPayStatus();
    }
}

function bindWalletPayStatus() {
    var html = getCheckStatusHtml(mHasWalletPay);
    $('#ckbWallet').html(html);
}

function addAmount() {
    var amount = mGiftAmount + 1;
    updateGiftAmountAndprice(amount);
}

function updateGiftAmountAndprice(amount) {
    if (amount) {
        mGiftAmount = amount;
        $('#giftAmount').html(mGiftAmount);
    }

    if (mGiftIndex != null) {
        var totalPrice = mGiftList[mGiftIndex].price * mGiftAmount;
        $('#payButton').html('支付¥ ' + totalPrice);
    }
}

function decreaseAmount() {
    if (mGiftAmount <= 1) {
        return;
    }

    var amount = mGiftAmount - 1;
    updateGiftAmountAndprice(amount);
}

function inputAmount() {
    var text = $.trim($('#giftAmountText').val());
    if (text == '') {
        showToast('请输入数量');
        return;
    }
    var amount = parseInt(text);
    if (isNaN(amount)) {
        showToast('数量输入有误');
        return;
    } else {
        if (amount <= 0) {
            showToast('数量输入有误');
            return;
        }
    }
    updateGiftAmountAndprice(amount);
    closeModal();
}

function updateEmptyGiftAmount() {
    mGiftAmount = 0;
    if (mGiftIndex != null) {
        $('#payButton').html('支付');
    }
}

function showInputDialog() {
    $('#giftAmountText').val(mGiftAmount);

    openModal('#giftAmountPage');
}

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
    event.stopPropagation();
}

function closeModal() {
    if (mModalID == null) {
        return;
    }
    hideLayer();
    $(mModalID).hide();
    mModalID = null;
}