var mCarList = [];
var mPostList = [];
var mCriteria = null;

var mTabTitles = ['车源', '分类'];    //set titles of tabs
var mCodeList = null;
var mLastIndex = -1;

var mCarPageNumber = 1;
var mCarLoading = false;
var mCarFullyLoaded = false;

var mPostPageNumber = 1;
var mPostLoading = false;
var mPostFullyLoaded = false;

function searchData() {
	mCarList = [];
	mPostList = [];
	mCodeList = [null, null];

	mCarPageNumber = 1;
	mCarLoading = false;
	mCarFullyLoaded = false;

	mPostPageNumber = 1;
	mPostLoading = false;
	mPostFullyLoaded = false;

	var index = mLastIndex;
	mLastIndex = -1;
	chooseTab(index)
}

function initPage() {
	mCriteria = getObjectCache(CONST_CACHE_SEARCH_BUS_OBJECT);
	if (mCriteria.cityName) {
		$('#name').html(mCriteria.cityName);
	} else {
		$('#name').html(mCriteria.district);
	}

	$('.page').scroll(function() {
		var reachedBottom = isScrollToBottom(this);
		if (reachedBottom) {
			if (mLastIndex == 0) {
				if (mCarLoading == false) {
					if (mCarFullyLoaded == false) {
						bindCarListApi();
					} else {
						showToast(CONFIG_NO_MORE_DATA_MESSAGE);
					}
				}
			} else if (mLastIndex == 1) {
				if (mPostLoading == false) {
					if (mPostFullyLoaded == false) {
						bindPostListApi();
					} else {
						showToast(CONFIG_NO_MORE_DATA_MESSAGE);
					}
				}
			}
		}
	});
}

function bindPage() {
	bindData();
}

function bindTabTitles() {
	mCodeList = [];
	var html = '';
	$(mTabTitles).each(function (index, item) {
		html += '<div class="col text-center py-2" id="tab' + index + '" onclick="chooseTab(' + index + ');">' + item + '</div>';
		mCodeList.push(null);
	});
	$('#tabs').html(html);
}

function chooseTab(index) {
	if (index != mLastIndex) {
		$('#tab' + mLastIndex).removeClass('highlight');
		$('#tab' + index).addClass('highlight');
		mLastIndex = index;

		var html = mCodeList[index];
		if (html == null) {
			getTabResultCode();
		} else {
			bindTabData();
		}
	}
}

function getTabResultCode() {
	if (mCodeList[mLastIndex] == null) {
		fetchTabResultCode();
	} else {
		bindTabData();
	}
}

//user defined function according to the logic
function fetchTabResultCode() {
	//get data by tab
	if (mLastIndex == 0) {
		bindCarListApi();
	} else if (mLastIndex == 1) {
		bindPostListApi();
	}
}

function bindTabData() {
	var code = mCodeList[mLastIndex];
	$('#dataList').html(code);
}

function bindData() {
	$('#sourceKeywords').val(mCriteria.name);
	bindTabTitles();
	chooseTab(0);
}

function bindCarListApi() {
	var data = getCarListApiData();
	if (data.name == '') {
		showToast('请输入搜索的关键词');
		return;
	}

	mCarLoading = true;
	data.page = mCarPageNumber++;
	jAjaxGet('/shopItem/list', data, function (json) {
		console.log(data.page, json.list.length)
		mCarList = mCarList.concat(json.list);
		if (json.list.length < CONFIG_PAGE_SIZE) {
			mCarFullyLoaded = true;
		}

		var html = getCarListHtml();
		mCodeList[mLastIndex] = html;
		bindTabData();
		mCarLoading = false;
	}, function () {
		mCarLoading = false;
	}, function () {
		mCarLoading = false;
	})
}

function getCarListApiData() {
	var name = $.trim($('#sourceKeywords').val());
	var data = {
		name: name,
		city_id: mCriteria.cityId
	};
	if (mCriteria.district) {
		data.district = mCriteria.district;
	}
	return data;
}

function getCarListHtml() {
	if (mCarList.length == 0) {
		return getEmptyDataCode();
	}

	var html = '';
	$(mCarList).each(function (index, item) {
		html += getCarHtml(index, item);
	});
	return html;
}

function getCarHtml(index, item) {
	var html = '';
	if (index > 0) {
		html += '<hr>';
	}
	html += '<div class="row mt-2" onclick="chooseCar(' + item.id + ');">';
	html += '<div class="ml-2 thumb divBackground rounded" style="background-image: url(' + item.imgs[0] + ')"></div>';
	html += '<div class="col ellipsis" style="display:flex;flex-direction:column;justify-content:space-between;height:5rem;">' + getCarDetailsHtml(item) + '</div>';

	html += '</div>';
	return html;
}

function chooseCar(carId) {
	openWinWithCache("carDetails", CONST_CACHE_CAR_ID, carId);
}

function getCarDetailsHtml(item) {
	var html = '<div class="carName ellipsis">' + item.vehicle_name + '</div>';
	html += '<div class="carPrice">价格: ¥' + item.price + '</div>';
	html += '<div class="carDate">上牌时间：' + item.first_license_date + '</div>';
	return html;
}

function bindPostListApi() {
	var data = getPostListApiData();
	if (data.text == '') {
		showToast('请输入搜索的关键词');
		return;
	}
	mPostLoading = true;
	data.page = mPostPageNumber++;
	jAjaxGet('/post/list', data, function (json) {
		console.log(data.page, json.list.length)
		mPostList = mPostList.concat(json.list);
		if (json.list.length < CONFIG_PAGE_SIZE) {
			mPostFullyLoaded = true;
		}

		var html = getPostListHtml();
		mCodeList[mLastIndex] = html;
		bindTabData();

		mPostLoading = false;
	}, function () {
		mPostLoading = false;
	}, function () {
		mPostLoading = false;
	})
}

function getPostListApiData() {
	var name = $.trim($('#sourceKeywords').val());
	var data = {
		text: name,
		city_id: mCriteria.cityId
	};
	if (mCriteria.district) {
		data.district = mCriteria.district;
	}
	return data;
}

function getPostListHtml() {
	if (mPostList.length == 0) {
		return getEmptyDataCode();
	}
	var html = '';
	$(mPostList).each(function (index, item) {
		html += getPostHtml(index, item);
	});
	return html;
}

function getPostHtml(index, item) {
	var html = '';
	if (index > 0) {
		html += '<hr>';
	}
	html += '<div class="row mt-2" onclick="choosePost(' + index + ');">';

	html += '<div class="pl-2"><img class="thumbPost rounded" src="' + item.imgs[0] + '" /></div>';
	html += '<div class="col pr-0 ub-ver">' + getPostDetailsHtml(item) + '</div>';

	html += '</div>';
	return html;

}

function getPostDetailsHtml(item) {
	var html = '<div class="carName small mb-2">' + item.title + '</div>';
	html += '<div class="carAddress small mb-2">发布地址: ' + item.address + '</div>';
	html += '<div class="carAddress small mb-2">发布人: ' + item.contact_name + '</div>';
	html += '<div class="carDate small">发布时间：' + item.updated_at + '</div>';
	return html;
}

function choosePost(index) {
	var post = mPostList[index];
	openWinWithCache('post_details', CONST_CACHE_POST_ID, post.id);
}

function pressEnterToSearch() {
	if (event.keyCode==13) { //回车键的键值为13
		document.activeElement.blur();
		searchData();
	}
}