var mCarCategoryList = null;
var mCarBrandList = null;
var mCarTypeList = null;
var mCarColorList = null;
var mCarCategoryIndex = -1;
var mCarBrandLetterIndex = -1;
var mCarBrandLetterItemIndex = -1;
var mCarTypeIndex = -1;
var mCarColorIndex = -1;
var mIsViolation = false;
var mLocationObject = LocationClass.createNew();
var mFileUploader = null;
var mLocation = null;
var mUser = null;
var mCarSubmissionTypeList = null;
var mCarSubmissionTypeIndex = -1;
var mCarSituationList = null;
var mCarSituationIndex = -1;
var mCar = null;
var mCarId = null;
var mLeftApiCount = 4;
var mCarJson = null;
var mCarGearBoxList = null;
var mCarGearBoxIndex = -1;
var mLastBrand = null;
var mCarSeriesArray = [];
var mCarPatternArray = [];
var mDateIndex = -1;
var mModalID = null;

var mChoseImageList = null;
var mUploadingImageIndex = null;

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
}

function closeModal() {
    if (mModalID == null) {
        return;
    }
    $(mModalID).hide();
    hideLayer();

    mModalID = null;
}

function initPage() {
    mUser = getUser();
    mCarId = getCache(CONST_CACHE_CAR_ID);
    removeCache(CONST_CACHE_CAR_ID);
}

function initRollDateControls() {
    var startYear = 1990;
    var endYear = new Date().getFullYear() + 10;
    new Rolldate({
        el: '#first_license_date',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        value: mCar.first_license_date,
        init: function() {
            document.activeElement.blur();
        }
    })
    new Rolldate({
        el: '#inspection_date',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        value: mCar.inspection_date,
        init: function() {
            document.activeElement.blur();
        }
    })
    new Rolldate({
        el: '#insurance_end_date',
        format: 'YYYY-MM-DD',
        beginYear: startYear,
        endYear: endYear,
        value: mCar.insurance_end_date,
        init: function() {
            document.activeElement.blur();
        }
    })
}

function enableSubmitButton() {
    $('#submitButton').removeClass('btn-secondary').addClass('btn-default').css('background-color', '#EE5546');
    $('#submitButton').click(updateCar);
}

function bindPage() {
	bindData();
}

function initCarInfo(data) {
    mCar = getCarInfo(data);
    appendUserId(mCar);
}

function getCarInfo(json) {
    var data = {
        id: json.id,
        vehicle_name: json.vehicle_name,
        vehicle_category: json.vehicle_category,
        vehicle_brand: json.vehicle_brand,
        first_license_date: json.first_license_date,
        inspection_date: json.inspection_date,
        insurance_end_date: json.insurance_end_date,
        violation_status: json.violation_status,
        use_kilometer: json.use_kilometer,
        price: json.price,
        transfer_times: json.transfer_times,
        vehicle_type: json.vehicle_type,
        vehicle_situation: json.vehicle_situation,
        vehicle_color: json.vehicle_color,
        emission_type: json.emission_type,
        gearbox: json.gearbox,
        remark: json.remark,
        imgs: json.imgs,
        location: json.location
    };
    if (data.violation_status) {
        data.violation_times = json.violation_times;
    }
    return data;
}

function bindData() {
    mFileUploader = FileUploader.createNew();

    bindCarCategoryListApi();
    bindCarBrandListApi();
    bindCarTypeListApi();
}

function tryFecthCarInfo() {
    mLeftApiCount--;
    if (mLeftApiCount == 0) {
        if (mCarId != null) {
            bindCarInfoApi();
        } else {
            chooseCarCategory(0);
            chooseCarSituation(0)
        }
    }
}

function bindCarInfoApi() {
    var data = {
        id: mCarId
    };
    jAjaxGet('/shopItem/detail', data, function (json) {
        mCarJson = json;
        initCarInfo(mCarJson);
        bindCarInfo();
        enableSubmitButton();
    });
}

function bindCarCategory() {
    for (var i = 0; i < mCarCategoryList.length; i++) {
        if (mCarCategoryList[i].key == mCar.vehicle_category) {
            chooseCarCategory(i);
            return;
        }
    }
}

function bindCarBrand() {
    $('#carBrand').removeClass('t-gra').html(mCar.vehicle_brand);
    for (var i = 0; i < mCarBrandList.length; i++) {
        for (var j = 0; j < mCarBrandList[i].itemList.length; j++) {
            if (mCarBrandList[i].itemList[j] == mCar.vehicle_brand) {
                mCarBrandLetterIndex = i;
                mCarBrandLetterItemIndex = j;
                return;
            }
        }
    }
}

function bindCarInfo() {
    initRollDateControls();
    bindCarCategory();
    bindCarBrand();

    $('#brand_name').val(mCar.vehicle_brand);
    $('#vehicle_name').val(mCar.vehicle_name);
    bindCarSituation();
    bindViolation();
    $('#use_kilometer').val(mCar.use_kilometer);
    $('#price').val(mCar.price);
    $('#transfer_times').val(mCar.transfer_times);
    bindCarType();
    bindCarColor();
    bindCarSubmissionType();
    bindCarGearBox();
    
    if (mCar.location != null) {
        $('#formattedAddress').html('*车源的实际位置：' + mCar.location.formattedAddress);
    }
    bindCarPhotoList();
    $('#remark').val(mCar.remark);
}

function bindCarSituation() {
    for (var i = 0; i < mCarSituationList.length; i++) {
        if (mCarSituationList[i].key == mCar.vehicle_situation) {
            mCarSituationIndex = i;
            bindCarSituationItem(i);
            return;
        }
    }
}

function bindViolation() {
    if (mCar.vehicle_situation == 1) {
        setViolation(false);
        $('#violationTimes').val(mCar.violation_times);
    }
}

function bindCarType() {
    console.dir(mCarTypeList)
    for (var i = 0; i < mCarTypeList.length; i++) {
        if (mCarTypeList[i].key == mCar.vehicle_type) {
            mCarTypeIndex = i;
            bindCarTypeItem(i);
            return;
        }
    }
}

function bindCarColor() {
    for (var i = 0; i < mCarColorList.length; i++) {
        if (mCarColorList[i] == mCar.vehicle_color) {
            mCarColorIndex = i;
            bindCarColorItem(i);
            return;
        }
    }
}

function bindCarSubmissionType() {
    for (var i = 0; i < mCarSubmissionTypeList.length; i++) {
        if (mCarSubmissionTypeList[i].key == mCar.emission_type) {
            mCarSubmissionTypeIndex = i;
            bindCarSubmissionTypeItem(i);
        }
    }
}

function bindCarGearBox() {
    for(var i = 0; i < mCarGearBoxList.length; i ++) {
        if (mCarGearBoxList[i] == mCar.gearbox) {
            mCarGearBoxIndex = i;
            bindCarGearBoxItem(i);
        }
    }
}

function bindCarCategoryListApi() {
    jAjaxGet('/public/config', null, function (json) {
        mCarCategoryList = json.vehicle_categories;
        bindCarCategoryList();

        mCarSubmissionTypeList = json.emission_types;
        bindCarSubmissionTypeList();

        mCarColorList = json.vehicle_colors;
        bindCarColorList();

        mCarSituationList = json.vehicle_situations;
        var normalSituation = {
            key: 0,
            label: '正常'
        };
        mCarSituationList.splice(0, 0, normalSituation);
        bindCarSituationList();
        mCarGearBoxList = json.gearbox;
        bindCarGearBoxList();
        tryFecthCarInfo();
    })
}

function bindCarCategoryList() {
    var html = getCarCategoryListHtml();
    $('#carCategoryList').html(html);
}

function getCarCategoryListHtml() {
    var html = '';
    for (var i = 0; i < mCarCategoryList.length; i++) {
        var index = i;
        var item = mCarCategoryList[index];
        if (i == 0) {
            html += '<div class="col pink pr-0" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else if (i == mCarCategoryList.length - 1) {
            html += '<div class="col pink pl-0" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        } else {
            html += '<div class="col pink px-0" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + item.label + '</div>';
        }
    }
    return html;
}

//function getCarCategoryItemHtml(index, item) {
//    if (index == 0) {

//    } else if (index == )
//    var html = '<div class="col pink px-0" onclick="chooseCarCategory(' + index + ');" id="category' + index + '">' + item.label + '</div>';
//    return html;
//}

function chooseCarCategory(index) {
    if (index == mCarCategoryIndex) {
        return;
    }

    $('#category' + mCarCategoryIndex).removeClass('text-white').addClass('pink');
    mCarCategoryIndex = index;
    $('#category' + mCarCategoryIndex).removeClass('pink').addClass('text-white');
}

function bindCarSubmissionTypeList() {
    var html = getCarSubmissionTypeListHtml();
    $('#carSubmissionTypeList').html(html);
}

function getCarSubmissionTypeListHtml() {
    var html = '';
    $(mCarSubmissionTypeList).each(function (index, item) {
        html += getCarSubmissionTypeItemHtml(index, item);
    });
    return html;
}

function getCarSubmissionTypeItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarSubmissionType(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarSubmissionType(index) {
    mCarSubmissionTypeIndex = index;
    bindCarSubmissionTypeItem(index);
}

function bindCarSubmissionTypeItem(index) {
    $('#carSubmissionType').removeClass('t-gra');
    $('#carSubmissionType').html(mCarSubmissionTypeList[index].label);

    hidePage('#carSubmissionTypeListPage');
    hideLayer();
}

function getCarSubmissionTypeListHtml() {
    var html = '';
    $(mCarSubmissionTypeList).each(function (index, item) {
        html += getCarSubmissionTypeItemHtml(index, item);
    });
    return html;
}

function getCarSubmissionTypeItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarSubmissionType(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarSubmissionType(index) {
    mCarSubmissionTypeIndex = index;
    bindCarSubmissionTypeItem(index);
}

function bindCarSubmissionTypeItem(index) {
    $('#carSubmissionType').removeClass('t-gra');
    $('#carSubmissionType').html(mCarSubmissionTypeList[index].label);

    hidePage('#carSubmissionTypeListPage');
    hideLayer();
}

//gear start
function bindCarGearBoxList() {
    var html = getCarGearBoxListHtml();
    $('#carGearBoxList').html(html);
}

function getCarGearBoxListHtml() {
    var html = '';
    $(mCarGearBoxList).each(function (index, item) {
        html += getCarGearBoxItemHtml(index, item);
    });
    return html;
}

function getCarGearBoxItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarGearBox(' + index + ');">' + item + '</div>';
    return html;
}

function chooseCarGearBox(index) {
    mCarGearBoxIndex = index;
    bindCarGearBoxItem(index);
}

function bindCarGearBoxItem(index) {
    $('#carGearBox').removeClass('t-gra');
    $('#carGearBox').html(mCarGearBoxList[index]);

    hidePage('#carGearBoxListPage');
    hideLayer();
}
//gear end

function bindCarSituationList() {
    var html = getCarSituationListHtml();
    $('#carSituationList').html(html);
}

function getCarSituationListHtml() {
    var html = '';
    $(mCarSituationList).each(function (index, item) {
        html += getCarSituationItemHtml(index, item);
    });
    return html;
}

function getCarSituationItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarSituation(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarSituation(index) {
    mCarSituationIndex = index;
    bindCarSituationItem(index);
}

function bindCarSituationItem(index) {
    $('#carSituation').removeClass('t-gra');
    $('#carSituation').html(mCarSituationList[index].label);

    hidePage('#carSituationListPage');
    hideLayer();
}

function bindCarBrandListApi() {
    jAjaxGet('/vehicle/brands', null, function (json) {
        mCarBrandList = json.list;
        bindCarBrandList();
        tryFecthCarInfo();
    });
}

function bindCarBrandList() {
    var html = getCarBrandListHtml();
    $('#carBrandList').html(html);

    html = getCarBrandLetterListHtml();
    if (isIos()) {
        $('#carBrandLetters').css('top', '4.5rem');
    }
    $('#carBrandLetters').html(html);
}

function getCarBrandListHtml() {
    var itemHtml = '<div id="allCarOption" class="border-bottom p-2" onclick="resetCarBrand();">不限</div>';
    $(mCarBrandList).each(function (index, item) {
        itemHtml += getCarBrandItemHtml(index, item);
    });

    var html = '<div class="row">';
    html += '<div class="col mr-4">' + itemHtml + '</div>';
    html += '<div style="position: fixed;bottom:0px;right:0;">&nbsp;</div>';
    html += '</div>';

    return html;
}

function getCarBrandLetterListHtml() {
    var letterHtml = '';
    $(mCarBrandList).each(function (index, item) {
        letterHtml += getLetterHtml(index);
    });

    return letterHtml;
}

function getLetterHtml(index) {
    var letter = mCarBrandList[index].letter;
    return '<div class="text-center px-1 ub-f1" style="color:#DC4F3F;" ontouchstart="jumpToAnchor(' + index + ');">' + letter + '</div>';
}

function jumpToAnchor(index){
    var letter = mCarBrandList[index].letter;
    var url = 'home.html';               //Save down the URL without hash.
    location.href = "#brandLetter" + letter;                 //Go to the target element.
    //history.replaceState(null,null,url);   //Don't like hashes. Changing it back.
}

function getCarBrandItemHtml(letterIndex, item) {
    if (item.itemList.length == 0) {
        return '';
    } else {
        var html = '<div class="invisible" id="brandLetter' + item.letter + '"></div>';
        $(item.itemList).each(function (index, brand) {
            html += '<div class="border-bottom p-2" onclick="chooseCarBrand(' + letterIndex + ',' + index + ');">' + brand + '</div>';
        });
        return html;
    }
}

function chooseCarBrand(letterIndex, index) {
    mCarBrandLetterIndex = letterIndex;
    mCarBrandLetterItemIndex = index;
    bindCarBrandItem();
}

function bindCarBrandItem() {
    mLastBrand = mCarBrandList[mCarBrandLetterIndex].itemList[mCarBrandLetterItemIndex];
    checkBrandAndOpenSeriesPage();
}

function checkBrandAndOpenSeriesPage() {
    showPage('#carBrandSeriesPage');
    hidePage('#carBrandPage');
    refreshCarSeriesListApi(mLastBrand);
}

function refreshCarSeriesListApi() {
    $('#carBrandSeriesList').html('');

    var data = {
        brand: mLastBrand
    };

    jAjaxGet('/vehicle/series', data, function (json) {
        mCarSeriesArray = json;
        console.dir(json)
        bindCarSeriesList();
    })
}

function bindCarSeriesList() {
    var html = getCarSeriesListHtml();
    $('#carBrandSeriesList').html(html);
}

function getCarSeriesListHtml() {
    var html = '';
    $(mCarSeriesArray).each(function (index, item) {
        html += getCarSeriesHtml(index, item);
    });
    return html;
}

function getCarSeriesHtml(index, item) {
    var html = '<div class="middle-y border-bottom p-2" onclick="chooseCarSeries(' + index + ');">';
    html += item.series;
    html += '</div>';
    return html;
}

function chooseCarSeries(seriesIndex) {
    $('#carBrandSeriesPatternList').html('');
    showPage('#carPatternPage');

    mBrandSeriesIndex = seriesIndex;
    refreshCarPatternList();
}

function refreshCarPatternList() {
    var carSeries = mCarSeriesArray[mBrandSeriesIndex];
    var data = {
        brand: carSeries.brand,
        series: carSeries.series
    };
    jAjaxGet('/vehicle/names', data, function (json) {
        if (json.length == 0) {
            $('#brand_name').val(carSeries.series);
            hidePage('#carBrandPage');
            hidePage('#carBrandSeriesPage');
            hidePage('#carPatternPage');
        } else {
            mCarPatternArray = json;
            bindCarPatternList();
        }
    })
}

function bindCarPatternList() {
    var html = getCarPatternListHtml();
    $('#carBrandSeriesPatternList').html(html);
}

function getCarPatternListHtml() {
    var html = '';
    $(mCarPatternArray).each(function (index, item) {
        html += getCarPatternHtml(index, item);
    });
    return html;
}

function getCarPatternHtml(index, item) {
    var html = '<div class="middle-y border-bottom p-2" onclick="chooseCarPattern(' + index + ');">';
    html += item;
    html += '</div>';
    return html;
}

function chooseCarPattern(index) {
    var carPattern = mCarPatternArray[index];

    $('#brand_name').val(carPattern);

    hidePage('#carBrandPage');
    hidePage('#carBrandSeriesPage');
    hidePage('#carPatternPage');
}

function bindCarTypeListApi() {
    jAjaxGet('/public/config', null, function (json) {
        mCarTypeList = json.vehicle_types;
        bindCarTypeList();
        tryFecthCarInfo();
    });
}

function bindCarTypeList() {
    var html = getCarTypeListHtml();
    $('#carTypeList').html(html);
}

function getCarTypeListHtml() {
    var html = '';
    $(mCarTypeList).each(function (index, item) {
        html += getCarTypeItemHtml(index, item);
    });
    return html;
}

function getCarTypeItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarType(' + index + ');">' + item.label + '</div>';
    return html;
}

function chooseCarType(index) {
    mCarTypeIndex = index;
    bindCarTypeItem(index);
}

function bindCarTypeItem(index) {
    $('#carType').removeClass('t-gra');
    $('#carType').html(mCarTypeList[index].label);

    hidePage('#carTypeListPage');
    hideLayer();
}

function bindCarColorList() {
    var html = getCarColorListHtml();
    $('#carColorList').html(html);
    tryFecthCarInfo();
}

function getCarColorListHtml() {
    var html = '';
    $(mCarColorList).each(function (index, item) {
        html += getCarColorItemHtml(index, item);
    });
    return html;
}

function getCarColorItemHtml(index, item) {
    var html = '<div class="border-top p-2" onclick="chooseCarColor(' + index + ');">' + item + '</div>';
    return html;
}

function chooseCarColor(index) {
    mCarColorIndex = index;
    bindCarColorItem(index);
}

function bindCarColorItem(index) {
    $('#carColor').removeClass('t-gra');
    $('#carColor').html(mCarColorList[index]);

    hidePage('#carColorListPage');
    hideLayer();
}

function closeAllSubPages() {
    $('#carTypeListPage').hide();
    $('#carColorListPage').hide();
    $('#carBrandListPage').hide();
    $('#carSubmissionTypeListPage').hide();
    $('#carSituationListPage').hide();
    $('#carGearBoxListPage').hide();
}

function showCarTypePage() {
    openModal('#carTypeListPage');
}

function showBrandPage(hasAllOption) {
    if (hasAllOption) {
        $('#allCarOption').show();
    } else {
        $('#allCarOption').hide();
    }
    showPage('#carBrandPage');
}

function showCarColorPage() {
    openModal('#carColorListPage');
}

function showCarSubmissionTypePage() {
    openModal('#carSubmissionTypeListPage');
}

function showCarGearBoxPage() {
    openModal('#carGearBoxListPage');
}

function showCarSituationPage() {
    openModal('#carSituationListPage');
}

function setViolation(isViolation) {
    if (mIsViolation == isViolation) {
        return;
    }
    mIsViolation = isViolation;
    if (mIsViolation) {
        $('#violation1').removeClass('far').addClass('t-red').addClass('fas');
        $('#violation0').removeClass('t-red').removeClass('fas').addClass('far');
        $('#rowViolationTimes').removeClass('d-none');
    } else {
        $('#violation0').removeClass('far').addClass('t-red').addClass('fas');
        $('#violation1').removeClass('t-red').removeClass('fas').addClass('far');
        $('#rowViolationTimes').addClass('d-none');
    }
}

function takePhoto() {
    closeModal();
    uexCamera.open(0, 50, function (imgPath) {
        mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
            mCar.imgs.push(uploadedUrl);
            bindCarPhotoList();
        });
    })
}

function chooseImage() {
    closeModal();

    if (isH5NotSupported()) {
        return;
    }

    var max = CONFIG_MAX_CAR_PHOTOS - mCar.imgs.length;
    if (max <= 0) {
        showToast('最多' + CONFIG_MAX_CAR_PHOTOS + '张照片');
        return;
    }

    var param={
        min:1,
        max:max,
        quality:0.4, //压缩质量
        style:1
    }
    uexImage.openPicker(param, function (error, info) {
        if (error == -1) {
            //cancelled
        } else if (error == 0) {
            mChoseImageList = info.data;
            mUploadingImageIndex = 0;

            uploadChoseImageList();
            //mCar.imgs = mCar.imgs.concat(info.data);
            //bindCarPhotoList();
        } else {
            //error
        }
    })
}

function uploadChoseImageList() {
    startLoading('图片上传中');
    uploadChoseImage();
}

function uploadChoseImage() {
    var imgPath = mChoseImageList[mUploadingImageIndex];
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_SHOPITEMS, imgPath, function (uploadedUrl) {
        mUploadingImageIndex++;

        mCar.imgs.push(uploadedUrl);
        if (mUploadingImageIndex == mChoseImageList.length) {
            bindCarPhotoList();
            finishLoading();
        } else {
            uploadChoseImage();
        }
    });
}

function bindCarPhotoList() {
    var html = '<div class="bg-white pb-2 px-2" style="width:100%;">';
    html += '<div class="mb-2">*上传车辆照片：</div>';
    $(mCar.imgs).each(function (index, item) {
        html += getCarPhotoHtml(index, item);
    });
    html += '<img src="img/take-photo.png" style="width:4rem;height:4rem;" onclick="preparePhotos();" />';
    html += '</div>';
    $('#carPhotoList').html(html);
}

function locateNow() {
    mLocationObject.bindCurrentLocation(function (json) {
        if (json == null) {
            alert('请开启定位权限');
        } else {
            mCar.location = json;
            console.dir(json)
            $('#formattedAddress').html('*车源的实际位置：' + mCar.location.formattedAddress);
        }
    });
}

function getCarPhotoHtml(index, item) {
    //return '<img src="' + item + '" style="width:4rem;height:4rem;" class="mr-1" />';

    var html = '<div style="position:relative;float:left;" class="mr-2">';
    html += '<img src="' + item + '" style="width:4rem;height:4rem;" class="mr-2" />';
    html += '<span class="alarm" onclick="removePhoto(' + index + ');">-</span>';
    html += '</div>';
    return html;
}

function removePhoto(index) {
    mCar.imgs.splice(index, 1);
    bindCarPhotoList();
}

function setCar() {
    console.dir(mCarBrandList)
    console.log(mCarBrandLetterIndex, mCarBrandLetterItemIndex)
    mCar.vehicle_name = $.trim($('#vehicle_name').val());
    mCar.vehicle_category = (mCarCategoryIndex == -1) ? null : mCarCategoryList[mCarCategoryIndex].key;
    mCar.vehicle_brand = $.trim($('#brand_name').val());
    mCar.first_license_date = $('#first_license_date').val();
    mCar.inspection_date = $('#inspection_date').val();
    mCar.insurance_end_date = $('#insurance_end_date').val();
    mCar.violation_status = mIsViolation ? 1 : 0;
    if (mIsViolation) {
        mCar.violation_times = $('#violationTimes').val();
    }
    mCar.use_kilometer = $('#use_kilometer').val();
    mCar.price = $('#price').val();
    mCar.transfer_times = $('#transfer_times').val();
    mCar.vehicle_situation = mCarSituationIndex == -1 ? null : mCarSituationList[mCarSituationIndex].key;
    mCar.vehicle_type = mCarTypeIndex == -1 ? '' : mCarTypeList[mCarTypeIndex].key;
    mCar.vehicle_color = mCarColorIndex == -1 ? null : mCarColorList[mCarColorIndex];
    mCar.emission_type = mCarSubmissionTypeIndex == -1 ? '' : mCarSubmissionTypeList[mCarSubmissionTypeIndex].key;
    mCar.remark = $.trim($('#remark').val());
    mCar.gearbox = mCarGearBoxIndex == -1 ? '' : mCarGearBoxList[mCarGearBoxIndex];
}

function updateCar() {
    setCar();
    console.dir(mCar);

    var errMsg = getPostErrorMsg();
    if (errMsg != null) {
        showToast(errMsg);
        return;
    }

    jAjaxPostJsonContentType('/shopItem/save', mCar, function (json) {
        setTimeout(goBack, CONFIG_TOAST_DURATION_MILLISECONDS);
    })
}

function getPostErrorMsg() {
    if (mCar.vehicle_name == '') {
        return '请输入车辆款式';
    }
    if (mCar.vehicle_category == null) {
        return '请选择车辆类别';
    }
    if (mCar.vehicle_brand == '') {
        return '请选择车辆品牌';
    }
    if (mCar.first_license_date == '') {
        return '请输入首次上牌日期';
    }
    if (mCar.inspection_date == '') {
        return '请输入检车日期';
    }
    if (mCar.insurance_end_date == '') {
        return '请输入保险到期日期';
    }
    var checkMsg = null;
    if (mCar.violation_status == 1) {
        checkMsg = isIntMessage('违章次数', mCar.violation_times, 0);
        if (checkMsg != null) {
            return checkMsg;
        }
    }
    checkMsg = isNumberMessage('真实公里数', mCar.use_kilometer, 0);
    if (checkMsg != null) {
        return checkMsg;
    }

    checkMsg = isNumberMessage('批发价格', mCar.price, 0);
    if (checkMsg != null) {
        return checkMsg;
    }

    if (transfer_times != '') {
        checkMsg = isIntMessage('过户次数', mCar.transfer_times, 0);
        if (checkMsg != null) {
            return checkMsg;
        }
    }

    if (mCar.vehicle_situation == null) {
        return '请选择车辆状况';
    }
    if (mCar.location == null) {
        return '请定位你的车源实际位置';
    }
    if (mCar.imgs.length == 0) {
        return '请上传至少一张车辆照片';
    }
    return null;
}

function showCarInfoPage() {
    var content = $('#remark').val();
    $('#carInfoText').val(content);

    openModal('#carInfoPage');
    event.stopPropagation();
}

function updateCarInfo() {
    var content = $('#carInfoText').val();
    $('#remark').val(content);
    closeModal();
}

function preparePhotos() {
    if (mFileUploader == null) {
        return null;
    }
    if (mCar.imgs.length >= CONFIG_MAX_CAR_PHOTOS) {
        showToast('最多' + CONFIG_MAX_CAR_PHOTOS + '张照片');
        return;
    }
    openModal('#chooseImageOrPhotoPage');
}
