var mCarList = [];
var mXXXXPageNumber = 1;
var mXXXXLoading = false;
var mXXXXFullyLoaded = false;

function initPage() {
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mXXXXLoading == false) {
                if (mXXXXFullyLoaded == false) {
                    bindCarListApi();
                } else {
                    showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                }
            }
        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindCarListApi();
}

function bindCarListApi() {
    mXXXXLoading = true;

    var data = getUserIdObject();
    data.page = mXXXXPageNumber++;
    jAjaxGet('/user/myShopItems', data, function (json) {
        console.log(data.page, json.list.length)
        mCarList = mCarList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mXXXXFullyLoaded = true;
        }
        bindCarList();
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    });
}

function bindCarList() {
    var html = '';
    if (mCarList.length == 0) {
        html = getEmptyDataCode();
    } else {
        $(mCarList).each(function (index, item) {
            html += getCarHtml(index, item);
        });
    }
    $('#carList').html(html);
}

function getCarHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2">';

    html += '<div class="pl-2"><img class="thumb" src="' + item.imgs[0] + '" /></div>';
    html += '<div class="col pr-0 ub-ver">' + getCarDetailsHtml(index, item) + '</div>';

    html += '</div>';
    return html;

}

function getCarDetailsHtml(index, item) {
    var html = '<div class="carName small">' + item.vehicle_brand + ' ' + item.vehicle_name + '</div>';
    html += '<div class="ub-f1">&nbsp;</div>';
    html += '<div class="carAddress small">发布地址: ' + item.address + '</div>';
    var rankLevel = getRankLevel(item.vip_level);
    if (rankLevel == null) {
        html += '<div class="carDate small">编号：' + item.id + '</div>';
    } else {
        html += '<div class="carDate small">编号：' + item.id + ' ' + rankLevel + '</div>';
    }

    html += '<div class="carDate small">审核状态：' + getApproveStatusName(item.review_status) + '</div>';
    html += '<div class="carDate small">上牌时间：' + item.first_license_date + '</div>';
    html += '<div class="text-right small">';
    html += '<span class="mr-2" onclick="buyRank(' + index + ');">置顶</span>';
    html += '<span onclick="edit(' + index + ');">编辑</span>';
    html += '<span class="mx-2" style="color:#999;" onclick="del(' + index + ');">删除</span>';
    html += '</div>';
    return html;
}

function del(index) {
    confirmDialog('您确实要删除当前车源吗?', function () {
        deleteCar(index);
    })
}

function buyRank(index) {
    var car = mCarList[index];
    openWinWithCache('car_rank_buy', CONST_CACHE_CAR_ID, car.id);
}

function edit(index) {
    var car = mCarList[index];
    openWinWithCache('user_car_edit', CONST_CACHE_CAR_ID, car.id);
}

function deleteCar(index) {
    var carId = mCarList[index].id;
    var data = {
        id: carId
    };
    appendUserId(data);
    jAjaxPost('/shopItem/del', data, function (json) {
        bindCarList();
    })
}