var mTabTitles = ['车源', '车商'];    //set titles of tabs
var mCodeList = null;
var mLastIndex = -1;
var mUser = getUser();
var mCompanyList = [];
var mCarList = [];

var mCarPageNumber = 1;
var mCarLoading = false;
var mCarFullyLoaded = false;

var mCompanyPageNumber = 1;
var mCompanyLoading = false;
var mCompanyFullyLoaded = false;

function initPage() {
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mLastIndex == 0) {
                if (mCarLoading == false) {
                    if (mCarFullyLoaded == false) {
                        fetchTabResultCode();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            } else {
                if (mCompanyLoading == false) {
                    if (mCompanyFullyLoaded == false) {
                        fetchTabResultCode();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            }
        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindTabTitles();
    chooseTab(0);
}

function bindTabTitles() {
    mCodeList = [];
    var html = '';
    $(mTabTitles).each(function (index, item) {
        html += '<div class="col text-center py-2" id="tab' + index + '" onclick="chooseTab(' + index + ');">' + item + '</div>';
        mCodeList.push(null);
    });
    $('#tabs').html(html);
}

function chooseTab(index) {
    if (index != mLastIndex) {
        $('#tab' + mLastIndex).removeClass('highlight');
        $('#tab' + index).addClass('highlight');
        mLastIndex = index;

        var html = mCodeList[index];
        if (html == null) {
            getTabResultCode();
        } else {
            bindTabData();
        }
    }
}

function getTabResultCode() {
    if (mCodeList[mLastIndex] == null) {
        fetchTabResultCode();
    } else {
        bindTabData();
    }
}

//user defined function according to the logic
function fetchTabResultCode() {
    if (mLastIndex == 0) {
        mCarLoading = true;
    } else {
        mCompanyLoading = true;
    }
    //get data by tab
    var url = (mLastIndex == 0) ? '/user/followShopItems' : '/user/followShops';
    var data = getUserIdObject();
    data.page = (mLastIndex == 0) ? (mCarPageNumber++) : (mCompanyPageNumber++);
    jAjaxGet(url, data, function (json) {
        console.log(data.page, json.list.length)
        if (json.list.length < CONFIG_PAGE_SIZE) {
            if (mLastIndex == 0) {
                mCarFullyLoaded = false;
            } else {
                mCarFullyLoaded = false;
            }
        }
        bindTabResultCode(json);
        //keep below code after data has been returned, mostly through ajax
        //mCodeList[mLastIndex] = getListHtml(json);
        //bindTabData();

        if (mLastIndex == 0) {
            mCarLoading = false;
        } else {
            mCompanyLoading = false;
        }
    }, function () {
        if (mLastIndex == 0) {
            mCarLoading = false;
        } else {
            mCompanyLoading = false;
        }
    }, function () {
        if (mLastIndex == 0) {
            mCarLoading = false;
        } else {
            mCompanyLoading = false;
        }
    });
}

function bindTabResultCode(json) {
    if (mLastIndex == 0) {
        mCarList = mCarList.concat(json.list);
        bindCarList();
    } else {
        mCompanyList = mCompanyList.concat(json.list);
        bindCompanyList();
    }
    bindTabData();
}

function bindCompanyList() {
    mCodeList[mLastIndex] = getCompanyListHtml();
}

function getCompanyListHtml() {
    if (mCompanyList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(mCompanyList).each(function (index, item) {
        html += getCompanyHtml(index, item);
    });
    return html;
}

function getCompanyHtml(index, item) {
    var html = '<div class="row bg-white small middle-y border-bottom p-2" onclick="chooseCompany(' + index + ');">';
    html += '<div><img src="' + item.shop.cover + '" class="cover rounded-circle" /></div>';
    html += '<div class="col ml-1">' + item.shop.name + '<span class="ml-2 t-red">LV' + item.shop.tipping_level + '</span></div>';
    html += '<div>' + item.updated_at + '</div>';
    html += '</div>';
    return html;
}

function chooseCompany(index) {
    var company = mCompanyList[index];
    openWinWithCache("company", CONST_CACHE_COMPANY_ID, company.shop.id);
}

function bindCarList() {
    mCodeList[mLastIndex] = getCarListHtml();
}

function getCarListHtml() {
    if (mCarList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(mCarList).each(function (index, item) {
        html += getCarHtml(index, item);
    });
    return html;
}

function getCarHtml(index, item) {
    var html = '<div class="row bg-white small middle-y border-bottom p-2" onclick="chooseCar(' + index + ');">';
    html += '<div><img src="' + item.shop_item.imgs[0] + '" class="cover rounded-circle" /></div>';
    html += '<div class="col ml-1">' + item.shop_item.vehicle_name + '<span class="ml-2 t-red">' + item.shop_item.vehicle_brand + '</span></div>';
    html += '</div>';
    return html;
}

function chooseCar(index) {
    var car = mCarList[index];
    openWinWithCache('carDetails', CONST_CACHE_CAR_ID, car.shop_item.id);
}

function bindTabData() {
    $('#dataList').html(mCodeList[mLastIndex]);
}
