var mTabTitles = ['收到的礼物', '送出的礼物'];    //set titles of tabs
var mCodeList = null;
var mLastIndex = -1;
var mUser = getUser();
var mReceivedGiftList = [];
var mReceivedGiftPageNumber = 1;
var mReceivedGiftLoading = false;
var mReceivedGiftFullyLoaded = false;

var mSentGiftList = [];
var mXXXXPageNumber = 1;
var mXXXXLoading = false;
var mXXXXFullyLoaded = false;


function initPage() {
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mLastIndex == 0) {
                if (mReceivedGiftLoading == false) {
                    if (mReceivedGiftFullyLoaded == false) {
                        bindReceivedGiftListApi();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            } else {
                if (mXXXXLoading == false) {
                    if (mXXXXFullyLoaded == false) {
                        bindSentGiftListApi();
                    } else {
                        showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                    }
                }
            }

        }
    });
}

function bindPage() {
    bindNotification();
	bindData();
}

function bindNotification() {
    var extras = getObjectCache(CONST_CACHE_NOTIFICATION_EXTRAS_OBJECT);
    if (extras && extras.img) {
        removeCache(CONST_CACHE_NOTIFICATION_EXTRAS_OBJECT);
        showGiftFromNotification(extras.img);
    }
}

function showGiftFromNotification(imgUrl) {
    $('#giftImage').attr('src', imgUrl);
    showGift();
}

function bindData() {
    bindTabTitles();
    chooseTab(0);
}

function bindTabTitles() {
    mCodeList = [];
    var html = '';
    $(mTabTitles).each(function (index, item) {
        html += '<div class="col text-center py-2" id="tab' + index + '" onclick="chooseTab(' + index + ');">' + item + '</div>';
        mCodeList.push(null);
    });
    $('#tabs').html(html);
}

function chooseTab(index) {
    if (index != mLastIndex) {
        $('#tab' + mLastIndex).removeClass('highlight');
        $('#tab' + index).addClass('highlight');
        mLastIndex = index;

        var html = mCodeList[index];
        if (html == null) {
            getTabResultCode();
        } else {
            bindTabData();
        }
    }
}

function getTabResultCode() {
    if (mCodeList[mLastIndex] == null) {
        fetchTabResultCode();
    } else {
        bindTabData();
    }
}

//user defined function according to the logic
function fetchTabResultCode() {
    //get data by tab
    if (mLastIndex == 0) {
        bindReceivedGiftListApi();
    } else {
        bindSentGiftListApi();
    }
}

function bindTabData() {
    var code = mCodeList[mLastIndex];
    $('#dataList').html(code);
}

function bindReceivedGiftListApi() {
    mReceivedGiftLoading = true;

    var data = {
        id: mUser.shop.id
    }
    data.page = mReceivedGiftPageNumber++;
    jAjaxGet('/shop/tippingRecords', data, function (json) {
        console.log(data.page, json.list.length)
        mReceivedGiftList = mReceivedGiftList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mReceivedGiftFullyLoaded = true;
        }
        bindReceivedGiftList();
        mReceivedGiftLoading = false;
    }, function () {
        mReceivedGiftLoading = false;
    }, function () {
        mReceivedGiftLoading = false;
    })
}

function bindReceivedGiftList() {
    mCodeList[mLastIndex] = getReceivedGiftListHtml();
    bindTabData();
}

function getReceivedGiftListHtml() {
    if (mReceivedGiftList.length == 0) {
        return getEmptyDataCode('暂未收到礼物打赏');
    }
    var html = '';
    $(mReceivedGiftList).each(function (index, item) {
        html += getReceivedGiftHtml(index, item);
    });
    return html;
}

function getReceivedGiftHtml(index, item) {
    var html = '<div class="row mt-2 middle-y p-2">';
    html += '<div style="width:2rem;"><img src="' + item.user.avatar + '" class="img-thumbnail" /></div>';
    html += '<div class="col">';
    html += '<div>' + item.user.name + '</div>';
    html += '<div class="t-gra small">' + item.created_at + '</div>';
    html += '</div>';
    html += '<div class="py-0 px-1 small border rounded border-danger text-danger" onclick="chooseReceivedGift(' + index + ');">查看礼物</div>';
    html += '</div>';

    if (item.msg) {
        html += '<div class="small">' + item.msg + '</div>';
    }

    html += '<div class="row mt-2" style="color:#BC594B">';
    if (item.gift) {
        html += '<div class="col text-left">' + item.gift.name + '</div>';
    } else {
        html += '<div class="col text-left">未知礼物</div>';
    }

    html += '<div class="col text-center"><i class="fas fa-car-side"></i><span class="px-1 small">x</span>' + item.num + '</div>';
    html += '<div class="col text-right">¥ ' + item.total_amount + '</div>';
    html += '</div>';

    return html;
}

function chooseReceivedGift(index) {
    var imgUrl = mReceivedGiftList[index].gift.extra.img;
    $('#giftImage').attr('src', imgUrl);
    showGift();
}

function chooseSentGift(index) {
    var imgUrl = mSentGiftList[index].gift.extra.img;
    $('#giftImage').attr('src', imgUrl);
    showGift();
}

function showGift() {
    showLayer();
    $('#carPage').show();
    if (isApp()) {
        var params = {
            playMode: 0
        }
        uexAudio.setPlayMode(params);

        var url = 'res://car.mp3';
        uexAudio.open(url);
        uexAudio.play(0);
    }
    setTimeout(closeGift, 2000);
}

function closeGift() {
    hideLayer();
    $('#carPage').hide();
}

function bindSentGiftListApi() {
    mXXXXLoading = true;

    var data = getUserIdObject();
    data.page = mXXXXPageNumber++;
    jAjaxGet('/user/tippingRecords', data, function (json) {
        console.log(data.page, json.list.length)
        mSentGiftList = mSentGiftList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mXXXXFullyLoaded = true;
        }

        bindSentGiftList();
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    })
}

function bindSentGiftList() {
    mCodeList[mLastIndex] = getSentGiftListHtml();
    bindTabData();
}

function getSentGiftListHtml() {
    if (mSentGiftList.length == 0) {
        return getEmptyDataCode();
    }
    var html = '';
    $(mSentGiftList).each(function (index, item) {
        html += getSentGiftHtml(index, item);
    });
    return html;
}

function getSentGiftHtml(index, item) {
    var html = '<div class="row mt-2 middle-y p-2">';
    html += '<div style="width:2rem;"><img src="' + item.tipped_shop.cover + '" class="img-thumbnail" /></div>';
    html += '<div class="col">';
    html += '<div>' + item.tipped_shop.name + '</div>';
    html += '<div class="t-gra small">' + item.created_at + '</div>';
    html += '</div>';
    html += '<div class="py-0 px-1 small border rounded border-danger text-danger" onclick="chooseSentGift(' + index + ');">查看礼物</div>';
    html += '</div>';

    if (item.msg) {
        html += '<div class="small">' + item.msg + '</div>';
    }

    html += '<div class="row mt-2" style="color:#BC594B">';
    if (item.gift) {
        html += '<div class="col text-left">' + item.gift.name + '</div>';
    } else {
        html += '<div class="col text-left">未知礼物</div>';
    }

    html += '<div class="col text-center"><i class="fas fa-car-side"></i><span class="px-1 small">x</span>' + item.num + '</div>';
    html += '<div class="col text-right">¥ ' + item.total_amount + '</div>';
    html += '</div>';

    return html;
}