var mImagePath = null;
var mFileUploader = null;
var mUser = null;
var mNewUser = null;
var mIsUserChanged = false;
var mModelID = null;

function initPage() {
    mUser = getUser();
    mNewUser = {
        avatar: mUser.avatar,
        name: mUser.name,
        gender: mUser.gender
    }
}

function bindPage() {
	bindData();
}

function bindData() {
    bindUserData();
}

function bindUserData() {
    $('#id').html(mUser.id);
    $('#gender').html(getGenderMeaning(mUser.gender));
    $('#userName').html(mUser.name);
    $('#headImage').attr('src', mUser.avatar);

    if (isApp()) {
        mFileUploader = FileUploader.createNew();
    }
}

function bindSaveButtonStatus() {
    mIsUserChanged = userChanged();
    if (mIsUserChanged) {
        $('#saveButton').html('<i class="fas fa-save"></i>');
    } else {
        $('#saveButton').html('');
    }
}

function chooseGender() {
    $('#genderListPage').show();
    showLayer();
    event.stopPropagation();
}

function userChanged() {
    return (mUser.avatar != mNewUser.avatar) || (mUser.gender != mNewUser.gender) || (mUser.name != mNewUser.name);
}

function confirmChangeUserName() {
    if (isH5()) {
        return;
    }
    var json = {
        title: '修改昵称',
        message: '请输入您的昵称',
        defaultValue: mUser.name,
        buttonLabels: "OK,Cancel"
    };
    uexWindow.prompt(json, function (index, data) {
        if (index == 0) {
            if (data != mUser.name) {
                updateUserName(data);
            }
        }
    });
}

function updateUserAvatar(imgUrl) {
    var data = {
        avatar: imgUrl
    };
    appendUserId(data);
    jAjaxPost('/user/update', data, function (json) {
        mUser.avatar = imgUrl;
        setUser(mUser);
        $('#headImage').attr('src', imgUrl);

        if (isApp()) {
            appcan.window.evaluateScript('home', 'bindLoggedUserDataUserPage();');
        }
    });
}

function updateUserGender(gender) {
    var data = {
        gender: gender,
    }
    appendUserId(data);
    jAjaxPost('/user/update', data, function (json) {
        mUser.gender = gender;
        setUser(mUser);
        $('#gender').html(getGenderMeaning(gender));
        closeGenderDialog();
    });
}

function updateUserName(name) {
    var data = {
        name: name,
        token: mUser.token
    }
    jAjaxPost('/user/update', data, function (json) {
        $('#userName').html(name);
        mUser.name = name;
        setUser(mUser);
        if (isApp()) {
            appcan.window.evaluateScript('home', 'bindLoggedUserDataUserPage();');
        }
    });
}

function getGenderMeaning(gender) {
    switch (gender) {
        case 0:
            return '保密';
        case 1:
            return '男';
        case 2:
            return '女';
        default:
            return '未知';
    }
}

function closeGenderDialog() {
    hideLayer();
    $('#genderListPage').hide()
}

function openModal(modalID) {
    mModalID = modalID;
    $(mModalID).show();
    showLayer();
}

function closeModal() {
    if (mModalID == null) {
        return;
    }
    $(mModalID).hide();
    hideLayer();

    mModalID = null;
}

function takePhoto() {
    closeModal();
    if (isH5()) {
        return;
    }
    jLog('camera');
    uexCamera.open(0, 50, function (imgPath) {
        jLog(imgPath, 'img')
        mImagePath = imgPath;
        uploadAndUpdateUserPhoto();
    });
}

function chooseImage() {
    closeModal();
    if (isH5()) {
        return;
    }
    var param={
        min:1,
        max:1,
        quality:0.4, //压缩质量
        style:1
    }
    uexImage.openPicker(param, function (error, info) {
        if (error == -1) {
            //cancelled
        } else if (error == 0) {
            mImagePath = info.data[0];
            uploadAndUpdateUserPhoto();
        } else {
            //error
        }
    })
}

function uploadAndUpdateUserPhoto() {
    mFileUploader.uploadImage(mUser.token, CONST_UPLOAD_IMAGE_DIR_AVARTARS, mImagePath, function (uploadedUrl) {
        jLog(uploadedUrl, 'url')
        updateUserAvatar(uploadedUrl);
    });
}