var mInformationList = [];
var mXXXXPageNumber = 1;
var mXXXXLoading = false;
var mXXXXFullyLoaded = false;

function initPage() {
    $('.page').scroll(function() {
        var reachedBottom = isScrollToBottom(this);
        if (reachedBottom) {
            if (mXXXXLoading == false) {
                if (mXXXXFullyLoaded == false) {
                    bindMyPostListApi();
                } else {
                    showToast(CONFIG_NO_MORE_DATA_MESSAGE);
                }
            }
        }
    });
}

function bindPage() {
	bindData();
}

function bindData() {
    bindMyPostListApi();
}

function bindMyPostListApi() {
    mXXXXLoading = true;

    var data = getUserIdObject();
    data.page = mXXXXPageNumber++;
    jAjaxGet('/user/myPosts', data, function (json) {
        console.log(data.page, json.list.length)
        mInformationList = mInformationList.concat(json.list);
        if (json.list.length < CONFIG_PAGE_SIZE) {
            mXXXXFullyLoaded = true;
        }
        bindMyPostList();
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    }, function () {
        mXXXXLoading = false;
    });
}

function bindMyPostList() {
    var html = '';
    if (mInformationList.length == 0) {
        html = getEmptyDataCode();
    } else {
        $(mInformationList).each(function (index, item) {
            html += getMyPostHtml(index, item);
        });
    }
    $('#carList').html(html);
}

function getMyPostHtml(index, item) {
    var html = '';
    if (index > 0) {
        html += '<hr>';
    }
    html += '<div class="row mt-2">';

    html += '<div class="pl-2"><img class="thumb" src="' + item.imgs[0] + '" /></div>';
    html += '<div class="col pr-0 ub-ver">' + getCarDetailsHtml(index, item) + '</div>';

    html += '</div>';
    return html;

}

function getCarDetailsHtml(index, item) {
    var html = '<div class="carName small">' + item.title + '</div>';
    html += '<div class="carAddress small">发布地址: ' + item.address + '</div>';
    html += '<div class="carDate small">发布人：' + item.contact_name + '</div>';
    var rankLevel = getRankLevel(item.vip_level);
    if (rankLevel == null) {
        html += '<div class="carDate small">编号：' + item.id + '</div>';
    } else {
        html += '<div class="carDate small">编号：' + item.id + ' ' + rankLevel + '</div>';
    }

    html += '<div class="carDate small">审核状态：' + getApproveStatusName(item.review_status) + '</div>';
    html += '<div class="carDate small">发布时间：' + item.created_at + '</div>';
    html += '<div class="text-right small">';
    html += '<span class="mr-2" onclick="buyRank(' + index + ');">置顶</span>';
    html += '<span onclick="edit(' + index + ');">编辑</span>';
    html += '<span class="mx-2 t-gra" onclick="del(' + index + ');">删除</span>';
    html += '</div>';
    return html;
}

function del(index) {
    confirmDialog('您确实要删除当前信息吗?', function () {
        deletePost(index);
    })
}

function buyRank(index) {
    var information = mInformationList[index];
    openWinWithCache('post_rank_buy', CONST_CACHE_POST_ID, information.id);
}

function edit(index) {
    var information = mInformationList[index];
    openWinWithCache('user_post_edit', CONST_CACHE_POST_ID, information.id);
}

function deletePost(index) {
    var informationID = mInformationList[index].id;
    var data = {
        id: informationID
    };
    appendUserId(data);
    jAjaxPost('/post/del', data, function (json) {
        bindMyPostListApi();
    })
}