var mUser = null;
var mWechatRegistered = false;
var mQQ_Registered = false;
var mQQ_Installed = null;

function initPage() {
	if (isIos()) {
		$('#shareHeader').addClass('pt-3');
	}
	mUser = getUser();
}

function bindPage() {
	bindData();
}

function bindData() {
	bindQrCode();
	bindInvitationCode();
}

function bindQrCode() {
	var width = $(window).width();
	var height = $(window).height();

	var iImageWidth = 548;
	var iImageHeight = 978;
	var iQrcodeLeft = 40;
	var iQrcodeTop = 187;
	var iQrcodeBottom = 640;

	var left = parseInt(iQrcodeLeft * width / iImageWidth);
	var top = parseInt(iQrcodeTop * height / iImageHeight);
	var imgWidth = width - left * 2;
	var imgHeight = parseInt((iQrcodeBottom - iQrcodeTop) * height / iImageHeight);
	var imgUrl = 'url(' + mUser.qrcode + ')';
	$('#qrcode').css('top', top).css('left', left).css('width', imgWidth).css('height', imgHeight);
	$('#qrcode').css('background-image', imgUrl);
}

function bindInvitationCode() {
	var iImageWidth = 548;
	var iImageHeight = 978;
	var iInvitationTop = 800;
	var height = $(window).height();
	console.log(height)
	var width = $(window).width();

	var top = parseInt(iInvitationTop * 1.0 / iImageHeight * height);

	$('#invitationCode').css('top', top);
	$('#invitationCode').html('我的邀请码： ' + mUser.uuid);
	var inviteWidth = $('#invitationCode').width();
	if (inviteWidth < width) {
		var left = (width - inviteWidth) / 2;
		$('#invitationCode').css('left', left);
	}
}

function shareToWechat(isGroup) {
	if (mWechatRegistered == false) {
		var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0');
		if (info != 0) {
			showToast('微信授权失败');
			return;
		}
		mWechatRegistered = true;
	}

	shareText(isGroup);
}

function shareText(isGroup) {
	closeLayer();
	var url = '/register.html?uuid=' + mUser.uuid;
	shareUrl(isGroup, url, '琦亿车邀请你赚钱啦！', '邀请好友注册琦亿车获得奖励！');
}

function shareToQQ() {
	closeLayer();

	if (isH5()) {
		showToast('H5不支持当前功能');
		return;
	}

	if (mQQ_Installed == null) {
		mQQ_Installed = uexQQ.isQQInstalled();
	}

	if (mQQ_Installed == false) {
		showToast('QQ未安装');
		return;
	}

	if (mQQ_Registered == false) {
		uexQQ.login(CONFIG_QQ_APP_ID, function (error, data) {
			if (error == 0) {
				mQQ_Registered = true;
				qqShareToFriend();
			} else {
				showToast('QQ登录失败');
			}
		});
	} else {
		qqShareToFriend();
	}
}

function qqShareToFriend() {
	var title = getCache(CONST_CACHE_SHARE_TEXT);
	var url = '/register.html?uuid=' + mUser.uuid;

	qqShareUrl(title, url, function () {
		showToast('QQ分享成功');
	});
}

function showSharePage() {
	$('#sharePage').show();
	$('.layer').css('display', 'block');
}

function closeLayer() {
	$('.layer').css('display', 'none');
	$('#sharePage').hide();
}
