var mProductList = null;
var mWechatRegistered = false;
var mBonusObject = BonusClass.createNew('#bonusControlID');
var mProductIndex = null;
var mHasWalletPay = false;
var mBalance = null;

function initPage() {
    mBonusObject.init();
}

function bindPage() {
	bindData();
}

function bindData() {
    bindUserCard();
    bindProductListApi();
    bindBalanceInfo();
}

function bindUserCard() {
    var user = getUser();
    $('#logo').attr('src', user.avatar);
    console.dir(user)
}

function bindProductListApi() {
    var data = getUserIdObject();
    jAjaxGet('/product/userVip', data, function (json) {
        mProductList = json.list;
        bindProductList();
    })
}

function bindProductList() {
    var html = getProductListHtml();
    $('#productList').html(html);
}

function getProductListHtml() {
    var html = '';
    $(mProductList).each(function (index, item) {
        html += getProductHtml(index, item);
    });
    return html;
}

function getProductHtml(index, item) {
    var html = '<div class="row middle-y border-bottom py-2">';
    html += '<div class="col label">' + item.name + '<span class="price">' + item.price + '</span>元</div>';
    html += '<div id="buy' + index + '" class="buyButton unselected" onclick="chooseProduct(' + index + ');">购买</div>';
    html += '</div>';
    return html;
}

function chooseProduct(index) {
    if (mProductIndex == index) {
        return;
    }
    mBonusObject.init();
    $('#buy' + mProductIndex).removeClass('selected').addClass('unselected');
    mProductIndex = index;
    $('#buy' + mProductIndex).removeClass('unselected').addClass('selected');
    var product = mProductList[mProductIndex];
    $('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + product.price);
}

function bindBalanceInfo() {
    var data = getUserIdObject();
    jAjaxGet('/user/profile', data, function (json) {
        mBalance = json.account_money;
        $('#wallet').html('余额支付 (' + mBalance + '元)');
    });
}

function buy() {
    if (mProductIndex == null) {
        showToast('请选择购买会员')
        return;
    }
    var product = mProductList[mProductIndex];
    if ((mHasWalletPay == false) || product.price > mBalance) {
        if (mWechatRegistered == false) {
            var info = uexWeiXin.registerApp('wx78c8b746aa9b52d0', 'https://noahsoft.site/app/');
            if (info != 0) {
                showToast('微信授权失败');
                return;
            }
            mWechatRegistered = true;
        }

        var supportPay = uexWeiXin.isSupportPay();
        if (supportPay == false) {
            showToast('微信支付不支持');
            return;
        }
    }

    var use_account_money = mHasWalletPay ? 1 : 0;
    var data = {
        id: product.id,
        use_account_money: use_account_money
    };
    var coupon_ids = mBonusObject.getBonusIds();
    if (coupon_ids.length > 0) {
        data.coupon_ids = coupon_ids;
    }
    appendUserId(data);
    jAjaxPostJsonContentType('/product/userVip/buy', data, function (json) {
        payOrder(json, '您已成功购买', function () {
            if (isApp()) {
                appcan.window.evaluateScript('home', 'refreshUserApi(true);');
            }
        });
    })
}

function chooseBonus() {
    if (mProductIndex == null) {
        showToast('请选择购买会员');
        return;
    }
    var product = mProductList[mProductIndex];
    mBonusObject.goPage('vip_buy', product.price);
}

function bindBonus() {
    mBonusObject.populate();
    mBonusObject.bindData();

    var product = mProductList[mProductIndex];
    var newPrice = mBonusObject.getPriceOffBonus(product.price);
    $('#submitButton').html('支付 ' + CONST_CHAR_YUAN + ' ' + newPrice);
}

function chooseWallet() {
    if (mBalance != null && mBalance > 0) {
        mHasWalletPay = !mHasWalletPay;
        bindWalletPayStatus();
    }
}

function bindWalletPayStatus() {
    var html = getCheckStatusHtml(mHasWalletPay);
    $('#ckbWallet').html(html);
}