//change Withdraw to corresponding name
var mWithdrawList = null;
var mUser = null;

function initPage() {
	mUser = getUser();
	console.dir(mUser)
}

function bindPage() {
	bindData();
}

function bindData() {
	bindBalanceInfo();
	bindWithdrawListApi();
}

function bindBalanceInfo() {
	$('#balanceInfo').html('账户余额: ¥ ' + mUser.account_money);
}

function bindWithdrawListApi() {
	var data = getUserIdObject();
	jAjaxGet('/user/withdrawRecords', data, function (json) {
		mWithdrawList = json.list;
		bindWithdrawList();
	})
}

function bindWithdrawList() {
	var html = getWithdrawListHtml();
	$('#withdrawList').html(html);
}

function getWithdrawListHtml() {
	var html = '';
	$(mWithdrawList).each(function (index, item) {
		html += getWithdrawHtml(index, item);
	});
	return html;
}

function getWithdrawHtml(index, item) {
	var html = '<div class="row middle-y border-bottom p-2" onclick="chooseWithdraw(' + index + ');">';
	html += '<div class="col" style="font-size: 1rem;">' + CONST_CHAR_YUAN + ' ' + item.amount + '</div>';
	html += '<div class="small" style="color:#777;">';
	html += '<div>' + item.created_at + ' 提现' + '</div>';
	html += '<div>' + item.updated_at + ' ' + item.status_fmt + '</div>';
	html += '</div>';
	return html;
}

function chooseWithdraw(index) {
	var withdraw = mWithdrawList[index];
	console.dir(withdraw);
}

function onWithdraw() {
	jLog(mUser)
	if (mUser.is_wechat != 1) {
		showToast('请先绑定您的微信');
		return;
	}
	var price = $('#price').val();
	var msg = isNumberMessage('金额', price, 0.01);
	if (msg != null) {
		showToast(msg);
		return;
	}
	var wechat = $.trim($('#wechat').val());
	if (wechat == '') {
		showToast('请输入微信号');
		return;
	}
	var data = {
		amount: price,
		account: wechat
	};
	appendUserId(data);
	jAjaxPost('/user/withdraw', data, function (json) {
		jLog(json)
		showToast('提现申请已提交，请耐心等待');
		setTimeout(goBack, CONFIG_TOAST_DURATION_MILLISECONDS);
	});
}