var BonusClass = {
    createNew: function (jqid) {
        var mBonusControlID = jqid;
        var mBonusList = [];
        var bonusObject = {};

        bonusObject.goPage = function (orderPage, amount) {
            setCache(CONST_CACHE_ORDER_PAGE, orderPage);
            setCache(CONST_CACHE_ORDER_AMOUNT, amount);
            openWin('choose_bonus');
        }

        bonusObject.populate = function () {
            var list = getObjectCache(CONST_CACHE_BONUS_LIST_OBJECT);
            mBonusList = list;
        }

        bonusObject.init = function () {
            mBonusList = [];
            var html = '<div>优惠券</div>';
            html += '<div class="col text-right" id="bonusBody">&nbsp;</div>';
            html += '<div>';
            html += '<i class="t-gra fas fa-chevron-right ml-2"></i>';
            html += '</div>';
            $(mBonusControlID).html(html);
        }

        bonusObject.bindData = function () {
            var html = this.getBonusHtml();
            $('#bonusBody').html(html);
        }

        bonusObject.getBonusList = function () {
            var bonusList = getObjectCache(CONST_CACHE_BONUS_LIST_OBJECT);
            return bonusList;
        }

        bonusObject.getTotalBonusAmount = function () {
            var amount = 0;
            $(mBonusList).each(function (index, item) {
                amount += item.coupon_amount;
            })
            return amount;
        }

        bonusObject.getPriceOffBonus = function (price) {
            var bonus = this.getTotalBonusAmount();
            if (bonus > 0) {
                price -= bonus;
                if (price <= 0) {
                    price = 0.01;
                }
            }

            if (parseInt(price, 10) != price) {
                price = price.toFixed(2);
            }

            return price;
        }

        bonusObject.getBonusHtml = function () {
            if (mBonusList == null || mBonusList.length == 0) {
                return '';
            } else {
                var total = 0;
                $(mBonusList).each(function (index, item) {
                    total +=  item.coupon_amount;
                });

                var html = '<div class="ub">';
                html += '<div class="border border-danger small rounded p-1 text-danger middle">已选' + mBonusList.length + '张</div>';
                html += '<div class="ub-f1">&nbsp;</div>';
                html += '<div class="text-danger font-weight-bold">-¥' + total + '</div>';
                html += '</div>';
                return html;
            }
        }

        bonusObject.getBonusIds = function () {
            var list = [];
            $(mBonusList).each(function (index, item) {
                list.push(item.id);
            });
            return list;
        }

        return bonusObject;
    }
};
