var LocationClass = {
    createNew: function () {
        var locationObject = {};
        /*
        var cacheLocation = {
            "location":{
                "lat":"120.893746",
                "lng":"27.998396"
            },
            "addressComponent":{
                "province":"浙江省",
                "street":"兴隆大街东100米",
                "city":"温州市"
            },
            formattedAddress:"中国浙江省温州市乐清市兴隆大街东100米"
        }
         */
        var currentLocation = null;
        var mIsLocationReturned = false;
        var mGetLatAndLng = false;

        locationObject.isInitialized = function () {
            return mIsLocationReturned;
        }

        locationObject.getCurrentLocation = function () {
            return currentLocation;
        }

        locationObject.bindCurrentLocation = function (cbGetLocation, refresh) {
            try {
                if (!refresh) {
                    var today = getDateText(new Date());
                    var cacheDate = getCache(CONST_CACHE_LOCATION_DATE);
                    var location = getObjectCache(CONST_CACHE_LOCATION_OBJECT);
                    if ((cacheDate == today) && (location != null)) {
                        currentLocation = location;
                        locationObject.callBackLocation(cbGetLocation);
                        return;
                    }
                }

                jLog('read location from server');

                if (isH5()) {
                    try {
                        var useFakeAddress = true;
                        if (useFakeAddress) {
                            currentLocation = {
                                "formattedAddress": '浙江省温州市乐清市七里港南来顺酒店南（排七线西）',
                                "location": {
                                    "lat": '27.994973',
                                    "lng": '120.897724'
                                },
                                "addressComponent": {
                                    "province": '浙江省',
                                    "city": '温州市',
                                    "district": '乐清市'
                                }
                            };

                            setObjectCache(CONST_CACHE_LOCATION_OBJECT, currentLocation);
                            setCache(CONST_CACHE_LOCATION_DATE, today);

                            locationObject.callBackLocation(cbGetLocation);
                            return;
                        }
                        var geolocation = new qq.maps.Geolocation("6POBZ-WDCCX-7ZN4R-T74HW-V3ISE-ZLFDU", "pipiche");
                        var options = { timeout: 8000 };
                        geolocation.getLocation(function (position) {
                            var mapInfo = JSON.stringify(position, null, 4);
                            var jsonMapInfo = eval('(' + mapInfo + ')');
                            currentLocation = locationObject.getFormatLocation(jsonMapInfo);

                            setObjectCache(CONST_CACHE_LOCATION_OBJECT, currentLocation);
                            setCache(CONST_CACHE_LOCATION_DATE, today);
                            locationObject.callBackLocation(cbGetLocation);
                        }, function () {
                            jLog('failed to get loation');
                            locationObject.callBackLocation(cbGetLocation);
                        }, options);
                    } catch (err2) {
                        jLog(err2);
                        locationObject.callBackLocation(cbGetLocation);
                    }
                } else {
                    uexLocation.openLocation("gcj02", function (error) {
                        if (!error) {
                            uexLocation.onChange = function (lat, lng) {
                                uexLocation.closeLocation();
                                if (!refresh && mGetLatAndLng) {
                                    return;
                                }
                                mGetLatAndLng = true;
                                var useGaodeMapLocationService = true;
                                if (useGaodeMapLocationService) {
                                    AMap.plugin('AMap.Geocoder', function() {
                                        var geocoder = new AMap.Geocoder({
                                            // city 指定进行编码查询的城市，支持传入城市名、adcode 和 citycode
                                        })

                                        //lng = 125.09465;
                                        //lat = 46.594604;
                                        var lnglat = [lng, lat]

                                        geocoder.getAddress(lnglat, function(status, result) {
                                            jLog(status)
                                            jLog(result)
                                            if (status === 'complete' && result.info === 'OK') {
                                                // result为对应的地理位置详细信息
                                                //jLog(result.regeocode);
                                                currentLocation = locationObject.getGaodeLocation(lng, lat, result.regeocode);
                                                setObjectCache(CONST_CACHE_LOCATION_OBJECT, currentLocation);
                                                setCache(CONST_CACHE_LOCATION_DATE, today);
                                            }
                                            locationObject.callBackLocation(cbGetLocation);
                                        })
                                    })
                                    return;
                                }

                                if (lat && lng) {
                                    var params = {
                                        latitude: lat,
                                        longitude: lng,
                                        type: 'gcj02',
                                        flag: 1
                                    };
                                    uexLocation.getAddressByType(params, function (error, data) {
                                        if (error) {
                                            locationObject.callBackLocation(cbGetLocation);
                                        } else {
                                            data.formattedAddress = data.formatted_address;
                                            delete data.formatted_address;

                                            currentLocation = data;

                                            setObjectCache(CONST_CACHE_LOCATION_OBJECT, data);
                                            setCache(CONST_CACHE_LOCATION_DATE, today);

                                            locationObject.callBackLocation(cbGetLocation);
                                        }
                                    });
                                } else {
                                    locationObject.callBackLocation(cbGetLocation);
                                }
                            }
                        } else {
                            locationObject.callBackLocation(cbGetLocation);
                        }
                    });
                }
            } catch (err) {
                jLog(err)
                this.callBackLocation(cbGetLocation);
            }
        };

        //below are private functions, that should be only invoked in this file
        locationObject.getFormatLocation = function (location) {
            var address = location.province + location.city + location.addr;
            if (!location.city) {
                location.city = location.province;
                address = location.city + location.addr;
            }

            return {
                "formattedAddress": address,
                "location": {
                    "lat": location.lat.toString(),
                    "lng": location.lng.toString()
                },
                "addressComponent": {
                    "province": location.province,
                    "city": location.city,
                    "district": location.district
                }
            };
        };

        locationObject.callBackLocation = function (callback) {
            try {
                mIsLocationReturned = true;
                if (callback) {
                    callback(currentLocation);
                }
            } catch(err) {
                jLog(err)
            }

        };

        locationObject.getGaodeLocation = function (lng, lat, locationInfo) {
            var location = locationInfo.addressComponent;
            if (!location.city) {
                location.city = location.province;
            }
            return {
                "location":{
                    "lat":lat.toString(),
                    "lng":lng.toString()
                },
                "addressComponent":{
                    "province":location.province,
                    "city":location.city,
                    "district":location.district
                },
                formattedAddress:locationInfo.formattedAddress
            };
        };

        locationObject.getGaodeLocationByLngLat = function (lng, lat, cbGetLocation) {
            AMap.plugin('AMap.Geocoder', function() {
                var geocoder = new AMap.Geocoder({
                    // city 指定进行编码查询的城市，支持传入城市名、adcode 和 citycode
                })

                var lnglat = [lng, lat]

                geocoder.getAddress(lnglat, function(status, result) {
                    currentLocation = null;
                    if (status === 'complete' && result.info === 'OK') {
                        // result为对应的地理位置详细信息
                        currentLocation = locationObject.getGaodeLocation(lng, lat, result.regeocode);
                    }
                    cbGetLocation(currentLocation);
                })
            })
        }

        return locationObject;
    }
};

//var locationObject = LocationClass.createNew();
//return locationObject.bindCurrentLocation(cbGetLocation);
