if (isH5()) {
	$(document).ready(function(){
		loadPage();
	});
} else {
    appcan.ready(function () {
        if (CONFIG_PLATFORM == 2) {
            fitIphoneScreen();
        }
		loadPage();
	});
}

function appendUserId(data) {
    var user = getUser();
    if (user == null) {
        //data.token = '';
        goLogin();
    } else {
        data.token = user.token;
    }
}

function getUserIdObject() {
    var user = getUser();
    if (user == null) {
        goLogin();
    }
    var data = { token: user.token };
    return data;
}

function getEmptyDataCode(msg) {
    if (!msg) {
        msg = CONFIG_NO_DATA_MESSAGE;
    }
    return '<div class="noData text-center"><div><img src="img/archive.png" /></div><div class="mt-2">' + msg + '</div></div>';
}

function getImageUrl(imageName) {
    return getApiUrl('/data/' + imageName);
}

function bindBannerImage(jqid, imgUrl) {
    var html = '<div class="swiper-slide">';
    html += '<img src="' + imgUrl + '" alt="" style="width:100%; height:10em;">';
    html += '</div>';
    $(jqid).html(html);
}

function openUserPage(fromPage, refreshFunction, toPage) {
    if (isUserLogged()) {
        if (toPage) {
            openWin(toPage);
        }
    } else {
        var data = {
            fromPage: fromPage,
            refreshFunction: refreshFunction,
            toPage: toPage
        };
        setObjectCache(CONST_CACHE_LOGIN_OBJECT, data);
        openWin('login');
    }
}

function trySetJpush(id) {
    if (CONFIG_ENABLE_JPUSH && isApp()){
        var jPushSet = getCache(CONST_JPUSH_SET);
        jLog(jPushSet, 'jPushSet');
        if (jPushSet == id) {
            return;
        }
        if (CONFIG_IS_DEBUG) {
            alert(jPushSet + ' is not ' + id);
        }

        var script = 'setJPushUserAlias(' + id + ');';
        jLog(script, 'script');
        appcan.window.evaluateScript('root', script);
    }
}

function fillArrayOneRow(arr, colCount) {
    var balance = arr.length % colCount;
    if (balance == 0) {
        return;
    }
    for(var i = 0; i < colCount - balance; i ++) {
        arr.push(null);
    }
}

function getPriceText(price, subfix) {
    if (subfix) {
        return price + subfix;
    } else {
        return price + '万';
    }
}

function shareUrl(isGroup, urlPart, title, description, successCallBack) {
    var url = CONFIG_SHARE_URL + urlPart;
    var scene = isGroup ? 1 : 0;
    var jsonData = {
        thumbImg: 'res://logo.png',
        wedpageUrl: url,
        scene: scene,
        title: title,
        description: description
    }
    jLog(jsonData)
    uexWeiXin.shareLinkContent(JSON.stringify(jsonData), function (error) {
        jLog(error)
        if (error == 0) {
            if (successCallBack) {
                successCallBack();
            }
        }
    });
}

function qqShareUrl(title, urlPart, successCallBack) {
    var url = CONFIG_SHARE_URL + urlPart;
    var jsonData = {
        title: title,
        summary: '电话咨询请说明是从“琦亿车收车宝”看到的。',
        targetUrl: url,
        imageUrl: 'http://noahsoft.site/logo.png',
        appName: '琦亿车',
        cflag: 2
    }
    uexQQ.shareWebImgTextToQQ(CONFIG_QQ_APP_ID,JSON.stringify(jsonData), function (error, data) {
        jLog(error, 'error')
        jLog(data, 'data')
        if (error == 0) {
            if (successCallBack) {
                successCallBack();
            }
        }
    });
}

function getCarSituationNameById(situationId) {
    switch(situationId) {
        case 1:
            return '火烧车';
        case 2:
            return '事故车';
        case 3:
            return '营转非';
        case 4:
            return '下线车';
        case 5:
            return '水淹车';
        case 6:
            return '出租车';
        default:
            return '';
    }
}

function getCheckStatusHtml(checked) {
    if (checked) {
        return '<i class="fas fa-check-circle fa-lg text-danger"></i>';
    } else {
        return '<i class="far fa-circle text-secondary fa-lg"></i>';
    }
}

function payOrder(json, msg, callBack) {
    jLog('payOrder')
    jLog(json)
    if (json.noPay) {
        showToast(msg);
        if (callBack) {
            callBack();
        }
    } else {
        var data = JSON.stringify(json.config);
        jLog('start pay')
        uexWeiXin.startPay(data, function (result) {
            if (result.errCode == 0) {
                if (msg) {
                    showToast(msg);
                }
                if (callBack) {
                    callBack();
                }
            }
        });
    }
}

function getApproveStatusName(statusId) {
    switch (statusId) {
        case 0:
            return '待审核';
        case 1:
            return '通过';
        case 2:
            return '已拒绝';
        default:
            return '未知';
    }
}

function getRankLevel(vipLvel) {
    switch (vipLvel) {
        case 1:
            return '本市置顶';
        case 2:
            return '本省置顶';
        case 3:
            return '全国置顶';
        default:
            return null;
    }
}

function isScrollToBottom(obj) {
    if (isH5()) {
        return $(obj).scrollTop() + $(obj).innerHeight() >= $(obj)[0].scrollHeight;
    } else {
        return $(obj).scrollTop() + $(obj).height() >= $(obj)[0].scrollHeight;
    }
}