var mCacheLastUpdateCheckDate = "_cache_last_update_check_date";
var mTodayString = getDateText(new Date());

function checkUpdate(json) {
    if (json.versionId) {
        var lastUpdateDate = getCache(mCacheLastUpdateCheckDate);
        if (mTodayString == lastUpdateDate) {
            //Everyday checked once
            return;
        }
        checkUpdateResult(json);
    }
}

function getVersionId() {
    return CONFIG_IS_TEST ? CONFIG_ANDROID_TEST_VERSION_ID : CONFIG_ANDROID_PRODUCTION_VERSION_ID;
}

function checkUpdateResult(json) {
    var force = false;
    var currentVersionId = getVersionId();
	if (isLatestVersion(currentVersionId, json.versionId)) {
	    setCache(mCacheLastUpdateCheckDate, mTodayString);
		if (force) {
		    showAlert(json.msg);
		}
		return;
     }
     var buttons = (json.is_force == 1) ? ['马上升级'] : ['马上升级', '以后再说'];
     appcan.window.confirm("版本更新", json.msg, buttons, function (err, data, dataType, optId) {
        if (data == 0) {
            uexWidget.startApp("1", "android.intent.action.VIEW", '{"data":{"mimeType":"text/html","scheme":"' + json.fileUrl + '"}}');

            if (json.is_force) {
                setInterval( "uexWidgetOne.exit(0);", 1000);
            }
        } else if (data == 1) {
            setCache(mCacheLastUpdateCheckDate, mTodayString);
        }
      });
}

function isLatestVersion(currentVersionId, latestVersionId) {
    return currentVersionId == latestVersionId;
}
